import java.net.*;

class Client {

	public static void main(String[] args) {
		if (args.length < 2) {
			System.out.println("too few arguments");
			System.out.println("java Client <hostname> <port>");
			System.exit(1);
		}

		String hostname = args[0];
		int port = Integer.parseInt(args[1]);

		try {
			System.out.print("connecting to "+hostname+":"+port+"...");
			DatagramSocket socket = new DatagramSocket();
			socket.connect(new InetSocketAddress(hostname, port));
			System.out.println("done");

			System.out.print("sending packet...");
			byte[] data = new byte[] {'q', 'u', 'e', 'r', 'y'};
			DatagramPacket packet = new DatagramPacket(data, data.length);
			socket.send(packet);
			System.out.println("done");

			System.out.print("listening for response...");
			socket.receive(packet);
			System.out.println("done");

			System.out.print("response: ");
			byte[] buff = packet.getData();
			for (int i = 0; i < packet.getLength(); ++i) {
				System.out.print((char)buff[i]);
 			}
			System.out.println("");
		} catch (Exception e) {
			System.out.println("error");
			e.printStackTrace();
		}
	}
}
