import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;


public class GUI extends JFrame {

	private JTextArea status;
	private JScrollPane scrollpane;
	private JButton exitbtn;
	private JButton connectbtn;
	private int nextCam = 0;

	public GUI() {
		super("Camera Client");

		exitbtn = new JButton("Exit");
		exitbtn.addActionListener(new ExitListener());

		connectbtn = new JButton("Connect");
		connectbtn.addActionListener(new ConnectListener());

		status = new JTextArea();
		status.setEnabled(false);
		status.setDisabledTextColor(Color.BLACK);
		status.setRows(7);
		status.setColumns(40);

		scrollpane = new JScrollPane(status);

		this.getContentPane().setLayout(new BorderLayout());
		this.getContentPane().add(scrollpane, BorderLayout.NORTH);
		this.getContentPane().add(exitbtn, BorderLayout.EAST);
		this.getContentPane().add(connectbtn, BorderLayout.WEST);
		this.setLocationRelativeTo(null);
		this.pack();
		this.setVisible(true);
		setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
	}

	public void addStatusLine(String msg) {
		status.insert(msg+"\n", 0);
	}

	class ExitListener implements ActionListener {
		public void actionPerformed(ActionEvent a) {
			System.exit(0);
		}
	}

	class ConnectListener implements ActionListener {
		public void actionPerformed(ActionEvent a) {
			new HostConnect(GUI.this);
		}
	}
}
