/**
 * Stress test for the GC of LJRT.
 *
 * Use
 * ../configure --with-thread=pthread
 * ../configure --with-thread=pthread --with-gc=nonmoving
 *
 * @author Jesper Öqvist <jesper.oqvist@cs.lth.se>
 */
public class GCTest {
	private static final int LIMIT = 1000000;
	private static final int ELEMENTS = 100000;
	public static void main(String[] args) {
		for (int i = 0; i < LIMIT; ++i) {
			BigClass[] a = new BigClass[ELEMENTS];
			if (i % 100000 == 0) System.out.println(i/(LIMIT/10));
		}
		System.out.println("Test 1 passed!");
		for (int i = 0; i < LIMIT; ++i) {
			byte[] a = new byte[ELEMENTS];
			if (i % 100000 == 0) System.out.println(i/(LIMIT/10));
		}
		System.out.println("Test 2 passed!");
		for (int i = 0; i < LIMIT; ++i) {
			BigClass a = new BigClass();
			if (i % 100000 == 0) System.out.println(i/(LIMIT/10));
		}
		System.out.println("Test 3 passed!");
	}
}
