public class Generics {
	public static void main(String[] args) {

        WaterController controller = new WaterController();

		new EventPoster(controller).start();
		new EventFetcher(controller).start();
    }
    
}

public class EventPoster extends Thread {
	WaterController controller;

	public EventPoster(WaterController c) {
		controller = c;
	}

	public void run() {
		int i = 1;
		try {
			while (i < 10) {
				controller.doPost(new WaterEvent("event"+i));

				i++;
				sleep(1000);
			}
		} catch (InterruptedException e) {}
	}
}

public class EventFetcher extends Thread {
	WaterController controller;

	public EventFetcher(WaterController c) {
		controller = c;
	}

	public void run() {
		int i = 1;
		try {
			while (i < 10) {
				WaterEvent event = controller.doFetch();
				System.out.println(event);

				i++;
				sleep(1200);
			}
		} catch (InterruptedException e) {}
	}
}

public class RTEvent {
}

public class RTEventBuffer<T extends RTEvent> {
	T[] events = new T[10];
	int start = 0;
	int end = 0;
	int free = 10;

	synchronized void doPost(T e) {
		try {
			while (free == 0) {
				wait();
 			}
		} catch (InterruptedException exception) { }
		events[end] = e;
		end = (end+1) % 10;
		free--;
		notifyAll();
	}

	synchronized T doFetch() {
		try {
			while (free == 10) {
				wait();
 			}
		} catch (InterruptedException exception) { }
		T result = events[start];
		start = (start+1) % 10;
		free++;
		notifyAll();
		return result;
	}
}

public class RTThread<T extends RTEvent> {
    protected RTEventBuffer<T> mailbox = new RTEventBuffer<T>();
}

public class WaterEvent extends RTEvent {
	String message;

	public WaterEvent(String msg) {
		message = msg;
	}

	public String toString() {
		return message;
	}
}

public class WaterController extends RTThread<WaterEvent> {
    public WaterController() {
    }

	public void doPost(WaterEvent event) {
		mailbox.doPost(event);
	}

	public WaterEvent doFetch() {
		return mailbox.doFetch();
	}
}

