import se.lth.cs.robot.irb6.*;
import java.lang.*;

class P {
    private float y, y_ref, v, I, u;
    private float K, H, Beta, Ti,Tr;
    private boolean integratorOn;
	
    public P() {
	K = (float)1.0;
	Beta = (float)1.0;
	H = (float)1.0;
	Ti = (float)0.0;
	Tr=10.0;
	integratorOn = false;
    }
	
    public synchronized float calculateOutput(float y, float y_ref) {
	this.y = y;
	this.y_ref = y_ref;
	v = K*(Beta*y_ref -y);
	if(integratorOn) {
	    v = v +I;
	}
	return v;
    }
    
    public synchronized void updateState(float u) {
	if(integratorOn) {
	    I = I + (H*K/Ti)*(y_ref-y)+H*(1/Tr)*(u-v);
	}
	else {
	    I = (float)0.0;
	}
    }	
    public synchronized int getSamplingInterval() {
	return (int)(H*100);
    }
}
