import se.lth.cs.robot.irb6.*;
import java.lang.*;

class PI {
    private float y, y_ref, v, I, u;
    private float K, H, Beta, Ti,Tr;
   
	
    public PI() {
	K = (float)1.0;
	Beta = (float)1.0;
	H = (float)1.0;
	Ti = (float)0.0;
	Tr=0.0;
       
    }
	
    public synchronized float calculateOutput(float y, float y_ref) {
	this.y = y;
	this.y_ref = y_ref;
	v = K*(Beta*y_ref -y);
	v = v +I;
	
	return v;
    }
    
    public synchronized void updateState(float u) {
     
	    I = I + (H*K/Ti)*(y_ref-y)+H*(1/Tr)*(u-v);
       
    }	
    public synchronized int getSamplingInterval() {
	return (int)(H*100);
    }
}
