import se.lth.cs.robot.irb6.*;
import java.lang.*;


class PID {
    private float y, y_ref, v, I, u,D, yold;
    private float K, H, Beta, Ti,Tr;
    private float N, Td, ad, bd;  
	
    public PID() {
	K = (float)1.0;
	Beta = (float)1.0;
	H = (float)1.0;
	Ti = (float)0.0;
	Tr=(float)0.0;
	Td=(float)30.0;
	N=(float)15.0; //Maximum derivative gain, typical parameters between 10-20

	ad=(2*Td-N*H)/(2*Td+N*H);
	bd=(2*K*Td*N)/(2*Td+N*H);
    }
	
    public synchronized float calculateOutput(float y, float y_ref) {
	this.y = y;
	this.y_ref = y_ref;
	v = K*(Beta*y_ref -y);
	
	v = v +I+D;
	
	return v;
    }
    
    public synchronized void updateState(float u) {
	
	    I = I + (H*K/Ti)*(y_ref-y)+H*(1/Tr)*(u-v);
	    D=ad*D-bd*(y-yold);
	    yold=y;
 
    }	
    public synchronized int getSamplingInterval() {
	return (int)(H*100);
    }
}