import java.lang.*;
import se.lth.cs.robot.irb6.*;

class PutInStartPosition extends Thread{
    
    private P p;
    private float y, y_ref,v,u;
    private long sleepTime, sleepUntil;	
    private boolean stop;
    private int motor;
    private Motors motors;
    public PutInStartPosition(int motor, Motors motors) {
	stop = false;	
	p = new P();
	y_ref = (float)0.0;
	this.motor = motor;
	this.motors = motors;
    }
	
    public float limit(float output) {
	if(output >= 0.5) 
	    return (float)0.5;
	if(output <= -0.5)
	    return (float)-0.5;
	else 
	    return output;
    }
    
    public void setStop() {
	stop = true;
    }

    public synchronized void run() { 
	int count = 0;
	long time = System.currentTimeMillis();
	int interval = p.getSamplingInterval();
	long sleepUntil = (long)(time + interval);
	while(true) {
	    if(stop) {
		System.out.println("Motor in start position");
		motors.analogOut(motor, (float)0.000000);
		return;
	    }
	    y = motors.getPosition(motor);
	    v = p.calculateOutput(y, y_ref);
	    u = limit(v);
	    u = -u;
	    motors.analogOut(motor,u);
	    p.updateState(u);
	    if((y_ref - y)*(y_ref-y) < 0.009) {
		count++;
		if(count > 10) {
		    setStop();
		}
	    }
	    else {
		count = 0;
	    }
	    
	    sleepTime = (long)(sleepUntil - (int)System.currentTimeMillis());
	    if(sleepTime > 0) {
		try {
		    sleep(sleepTime);
		    sleepUntil = sleepUntil + interval;
		} catch(Exception e) {
		    System.out.println("Exception catched in Regul");
		}
	    }
	    else {
		sleepUntil = sleepUntil + interval;
		System.out.println("WARNING: Regul did not sleep");
	    }
	}
    }
}
