import java.lang.*;
import se.lth.cs.robot.irb6.*;

class Regul extends Thread{

    private Motors motors;
    private int i,j, motor;
    private int count[];
    private Synchronize syncs[];
    public  static final int NbrOfJoints = 5;
    private boolean stop;
    private float y, y_ref;
    private PutInStartPosition pisp[];
    private P p;
    private long sleepTime, sleepUntil;
    private  boolean[] sync;
   
    
    
    public Regul(){
       motors= new Motors();      
       p = new P();
       pisp = new PutInStartPosition[5];
       syncs = new Synchronize[5];
       sync = new boolean[5];
       
    }

    public float limit(float output) {
       float thelimit =(float) 0.5;
       if(output >= thelimit)
           return (float)thelimit;
       if(output <= -thelimit)
           return (float)-thelimit;
       else
           return output;
    }

    public boolean iniRef(float[] yref){
	boolean done;
	yref[1]=(float)-100.0;
	yref[2]=(float)-50.0;
	yref[3]=(float)-50.0;
	yref[4]=(float)0.0;
	yref[5]=(float)0.0;
	done=true;
	return done;
    }
   

    public boolean allSync(boolean[] sync_table){
	boolean allSync;
	if(sync[1] && sync[2] && sync [3] && sync [4] && sync [5]){
	    allSync=true;
	}else{
	    allSync=false;
	}return allSync;
    }

    public void getMotionReference(int i, float y, float yref[]){// int count[])

       
	switch(i){
		   case 1:

		       if (y < -99 && y > -101){
			  yref[i]=(float)100.0;		      			     

		       }else if (y < 101 && y > 99){
			  yref[i]=(float)-100.0;
		       
		       }else{
		       }

		   case 2:
		       if (y < -49 && y > -51){
			   yref[i]=(float)0.0;			 			     

		       }else if (y <1  && y >-1 ){
			   yref[i]=(float)-50.0;		       
			   
		       }else{
		       }
		   case 3:
		       if (y < -49 && y >-51 ){
			   yref[i]=(float)0.0;		      			   
			   
		       }else if (y < 1 && y > -1){
			   yref[i]=(float)-50.0;			
			   
		       }else{
		       } 
		   case 4:
		       
		   case 5:
		      
	}	   

    }


    private void setStop() {
	stop = true;
    }
    
    public synchronized void run(){
       

	//	int[] count = new int[5];
	float[] yref = new float[5];
	float[] u = new float[5];
	boolean readyToMove=false;
	boolean initialized=false;
      
    
	for (int k=1; k<=NbrOfJoints; k++){
           sync[k]=false;
	   syncs[k] = new Synchronize(k, motors);
	   pisp[k]=new PutInStartPosition(k, motors);
	   // count[k]=0;
       }

       int interval = p.getSamplingInterval();
       long maxtime = System.currentTimeMillis() + 120000;
       long time=System.currentTimeMillis();                            
       long sleepUntil = (long)(time + interval);

       while(true){
	   
	   time = System.currentTimeMillis();
           if(time > maxtime) {
	       setStop();
           }
           if(stop) {
	       for (i=1; i<=NbrOfJoints; i++){

	       pisp[i].start();
               System.out.print("pisp started");
               return;
	       }
           }
      
	   for (i=1; i<=NbrOfJoints; i++){

	       if (sync[i]){
		   float v,tmp;
		   float utemp;

		   // Get reference for joint i
		   y = motors.getPosition(i);	 
		   v = p.calculateOutput(y, yref[i]);	     
		   utemp = limit(v);
		   u[i] = -utemp;
		
		

	       }else{
		   // Find reference to sync joint i
		   sync[i] = syncs[i].synchronize();
		   u[i] = syncs[i].getReference();

		   if(sync[i]){
		       motors.analogOut(i,0);
		       motors.reset(i);
		     //   try {
// 			   sleep(100);
// 		       } catch(Exception e) {
// 		       	   System.out.println("Exception catched during sleep in Synchronize ");
// 		       }
		       motors.setSafeBit();
		       System.out.print("Joint ");
		       System.out.print(i);
		       System.out.println(" synchronized");
		       
		       yref[i] = motors.getPosition(i);
		       
		       
		   }
	       }
	   }
       
   
	      
	   for (i=1; i<=NbrOfJoints; i++){
	       // output control signal to joint i

	       motors.analogOut(i, u[i]); 
		 if(sync[i]){
		     p.updateState(u[i]);
		 }

		 readyToMove= this.allSync(sync); 
	   
		 if(readyToMove) {//all joints synchronized
		     
		     if(!initialized){
			 initialized=this.iniRef(yref);
			 System.out.println("initialized");
		     }
		     
		     //Motion generation
		     y = motors.getPosition(i);
		     this.getMotionReference(i, y, yref);
		   		   
		 }
	   }
	          
	 
	
       sleepTime = sleepUntil - System.currentTimeMillis();
           if(sleepTime > 0) {
               try {
                   sleep(sleepTime);
                   sleepUntil = sleepUntil + interval;
               } catch(Exception e) {
                   System.out.println("Exception catched in Regul");
               }
           }
           else {
               sleepUntil = sleepUntil + interval;
               System.out.println("WARNING: Regul did not sleep");
           }

       }//while(true)

   }//run


}

// 	case 1:
// 	if((yref[i] - y)*(yref[i]-y) < 0.009) {
//                 count[i]++;
//                 if(count[i] > 10) {
//                     count[i] = 0;
//                    if(yref[i] > -1 && yref[i] < 1) {
//                        yref[i] = (float)-31.400000;
// 		       System.out.println("pos1");
//                    }
//                     else if(yref[i] < -30 && yref[i] > -32) {
//                         yref[i] = (float)31.400000;
// 			System.out.println("pos2");
//                     }
//                     else if(yref[i] > 30 && yref[i] < 32) {
//                         yref[i] = (float)-56.500000;
// 			 System.out.println("pos3");
//                     }
//                     else if(yref[i] < -55 && yref[i] > -57) {
//                         yref[i] = (float)56.500000;
// 			 System.out.println("pos4");
//                     }
//                     else if(yref[i] > 55 && yref[i] < 57) {
//                         yref[i] = (float)-100.000000;
// 			System.out.println("pos5");
//                     }
//                     else if(yref[i] < -99 && yref[i] > -101) {
//                         yref[i] = (float)100.000000;
// 			 System.out.println("pos6");
//                     }
//                    else if(yref[i] > 99 && yref[i] < 101) {
//                         yref[i] = (float)-200.000000;
//                     }
//                     else if(yref[i] < -199 && yref[i] > -201) {
//                         yref[i] = (float)200.000000;
//                     }
//                     else if(yref[i] > 199 && yref[i] < 201) {
//                         yref[i] = (float)-300.000000;
//                     }
//                     else if(yref[i] < -299 && yref[i] > -301) {
//                         yref[i] = (float)300.000000;
//                     }
//                     else if(yref[i] > 299 && yref[i] < 301) {
//                         yref[i] = (float)0.000000;
//                     }
//                     else {
//                         System.out.println("Wrong value");
// 			return;
//                     }
//                 }
// 	}
// 	else {
// 	    count[i] = 0;
// 	}

// 	case 2:
// 	      if((yref[i] - y)*(yref[i]-y) < 0.009) {
//                 count[i]++;
//                 if(count[i] > 10) {
//                    count[i] = 0;
//                     if(yref[i] > -1 && yref[i] < 1) {
//                         yref[i] = (float)-50.00000;
		

//                     }
//                     else if(yref[i] < -49 && yref[i] > -51) {
//                         yref[i] = (float)0.00000;
		   
//                     }
//                     else {
// 			System.out.println("Wrong value");
// 			return;
//                     }
//                 }
//             }
//             else {
//                 count[i] = 0;
//             }

 //    case 3:
//    

	  //   if((yref[i] - y)*(yref[i]-y) < 0.009) {
//                 count[i]++;
//                 if(count[i] > 10) {
//                     count[i] = 0;
//                     if(yref[i] > -51 && yref[i] < -49) {
//                         yref[i] = (float)0.000000;
//                     }
//                     else if(yref[i] > -1 && yref[i] < 1) {
//                         yref[i] = (float)50.000000;

//                     }
//                     else {
//                         System.out.println("Wrong value");
// 			return;
//                     }
//                 }
//             }
//             else {
//                 count[i] = 0;
//            }

// 	case 4:
	  //   if((yref[i] - y)*(yref[i]-y) < 0.009) {
//                 count[i]++;
//                 if(count[i] > 10) {
//                     count[i] = 0;
//                     if(yref[i] > -51 && yref[i] < -49) {
//                         yref[i] = (float)-300.00000;
//                     }
//                     else if(yref[i] > -301 && yref[i] < -299) {
//                         yref[i] = (float)-50.00000;
//                     }
//                     else {
//                         System.out.println("Wrong value");
// 			return;
//                     }
//                 }
//             }
// 	    else {
// //                 count[i] = 0;
// //             }
//     case 5:
	 //    if((yref[i] - y)*(yref[i]-y) < 0.009) {
//                 count[i]++;
// 		if(count[i]>10){
// 		    count[i]=0;
// 		    yref[i]=(float)0.0;
//                 }else{
// 		    System.out.println("Wrong value");
// 		    return;
// 		}
// 	    }
// 	    else {
//                 count[i] = 0;
// 	    }
		
    