import java.lang.*;
import se.lth.cs.robot.irb6.*;

class test1 extends Thread{

   private Motors motors;
   private int i;
   private Synchronize Sync1, Sync2, Sync3, Sync4, Sync5;
   public  static final int NbrOfJoints = 5;
   private boolean manualSync, stop;
   private float y, y_ref, v;
   private PutInStartPosition pisp;
   private P p;
   private long sleepTime, sleepUntil;

 public test1(){
       motors= new Motors();
       manualSync=false;
       p = new P();
       y_ref = (float)0.0;
       pisp = new PutInStartPosition(i, motors);
   }

   public float limit(float output) {
       if(output >= 3.5)
           return (float)3.5;
       if(output <= -3.5)
           return (float)-3.5;
       else
           return output;
   }

 private void setStop() {
       stop = true;
   }

   public synchronized void run(){

       boolean[] sync = null;

       for (int k=1; k<=NbrOfJoints+1; k++){
           sync[k]=false;
       }

       int count = 0;
       int interval = p.getSamplingInterval();
       long maxtime = System.currentTimeMillis() + 60000;
       long time=System.currentTimeMillis();                            
       long sleepUntil = (long)(time + interval);

       while(true){
	   
	   time = System.currentTimeMillis();
           if(time > maxtime) {
	       setStop();
           }
           if(stop) {
               pisp.start();
               System.out.print("pisp started ");
               System.out.println(i);
               return;
           }
      
	   for (i=1; i<=NbrOfJoints; i++){

	       if (sync[i] || manualSync){
               System.out.println("Synchronized " +i);
               
	       }else{
	       

		   if(i==1){
		       Sync1=new Synchronize(i, motors);
		       Sync1.start();
		   }else if(i==2){
		       Sync2=new Synchronize(i, motors);
		       Sync2.start();
		   }else if(i==3){
		       Sync3=new Synchronize(i, motors);
		       Sync3.start();
		   }else if(i==4){
		       Sync4=new Synchronize(i, motors);
		       Sync4.start();
		   }else{
		       Sync5=new Synchronize(i, motors);
		       Sync5.start();
		   }
	       }
	       sync[i]=true;

	   }//for

	   //Control loop

	   for (i=1; i<=NbrOfJoints; i++){

           y = motors.getPosition(i);
           v = p.calculateOutput(y, y_ref);
           v = limit(v);
           v = -v;
           motors.analogOut(i,v);
           p.updateState();

           if(i==1){
               if((y_ref - y)*(y_ref-y) < 0.009) {
               count++;
               if(count > 10) {
                   count = 0;
                   if(y_ref > -1 && y_ref < 1) {
                       y_ref = (float)-31.400000;
                   }
                   else if(y_ref < -30 && y_ref > -32) {
                       y_ref = (float)31.400000;
                   }
                   else if(y_ref > 30 && y_ref < 32) {
                       y_ref = (float)-56.500000;
                   }
                   else if(y_ref < -55 && y_ref > -57) {
                       y_ref = (float)56.500000;
                   }
                   else if(y_ref > 55 && y_ref < 57) {
                       y_ref = (float)-100.000000;
                   }
                   else if(y_ref < -99 && y_ref > -101) {
                       y_ref = (float)100.000000;
                   }
                   else if(y_ref > 99 && y_ref < 101) {
                       y_ref = (float)-200.000000;
                   }
                   else if(y_ref < -199 && y_ref > -201) {
                       y_ref = (float)200.000000;
                   }
                   else if(y_ref > 199 && y_ref < 201) {
                       y_ref = (float)-300.000000;
                   }
                   else if(y_ref < -299 && y_ref > -301) {
                       y_ref = (float)300.000000;
                   }
                   else if(y_ref > 299 && y_ref < 301) {
                       y_ref = (float)0.000000;
                   }
                   else {
                       System.out.println("Wrong value");
                       return;
                   }
               }
           }
           else {
               count = 0;
           }
           }else if(i==2){
               if((y_ref - y)*(y_ref-y) < 0.009) {
               count++;
               if(count > 10) {
                   count = 0;
                   if(y_ref > -1 && y_ref < 1) {
                       y_ref = (float)-50.00000;
                   }
                   else if(y_ref < -49 && y_ref > -51) {
                       y_ref = (float)0.00000;
                   }
                   else {
                       System.out.println("Wrong value");
                       return;
                   }
               }
           }
           else {
               count = 0;
           }
           }else if(i==3){

               if((y_ref - y)*(y_ref-y) < 0.009) {
               count++;
               if(count > 10) {
                   count = 0;
                   if(y_ref == 50.000000) {
                       y_ref = (float)0.000000;
                   }
                   else if(y_ref == 0.000000) {
                       y_ref = (float)50.000000;

                   }
                   else {
                       System.out.println("Wrong value");
                       return;
                   }
               }
           }
           else {
               count = 0;
           }
           }else if(i==4){
               if((y_ref - y)*(y_ref-y) < 0.009) {
               count++;
               if(count > 10) {
                   count = 0;
                   //if(y_ref > -6.00 && y_ref < -4.00) {
                   //y_ref = (float)-10.00000;
                   //}
                   //else if(y_ref > -11 && y_ref < -9) {
                   //y_ref = (float)-5.00000;
                   if(y_ref > -51 && y_ref < -49) {
                       y_ref = (float)-300.00000;
                   }
                   else if(y_ref > -301 && y_ref < -299) {
                       y_ref = (float)-50.00000;
                   }
                   else {
                       System.out.println("Wrong value");
                       return;
                   }
               }
           }
               else {
               count = 0;
           }
           }else{
               if((y_ref - y)*(y_ref-y) < 0.009) {
               count++;
               setStop();
               }
               else {
               count = 0;
               }

           }
       }//for NbrOfJoints

       sleepTime = sleepUntil - System.currentTimeMillis();
           if(sleepTime > 0) {
               try {
                   sleep(sleepTime);
                   sleepUntil = sleepUntil + interval;
               } catch(Exception e) {
                   System.out.println("Exception catched in Regul");
               }
           }
           else {
               sleepUntil = sleepUntil + interval;
               System.out.println("WARNING: Regul did not sleep");
           }

       }//while(true)

   }//run

}
