import java.lang.*;
import java.net.*;
import java.io.*;
import se.lth.cs.robot.irb6.*;
//import roblet.examole.*;


class trajDemo extends Thread{

    private Motors motors;
    private int i,j, motor;
   
    public  static final int NbrOfJoints = 5;
    private boolean stop;
    private float y, y_ref;
    private PutInStartPosition pisp[];
    private P p;
    private long sleepTime, sleepUntil;
    private ServerSocket irbServerSocket;
   
   
   

    
    
    public trajDemo(){
     
	motors= new Motors();      
	p = new P();
	pisp = new PutInStartPosition[5];
	try {
	    irbServerSocket = new ServerSocket(2002);
    } catch (IOException e) {
// 	    System.err.println(e)
// 	    e.printStackTrace()
	    System.out.println("Caught IOException in trajDemo.<init>");
	    System.exit(1);
    }
    }
    
    public float limit(float output) {
       float thelimit =(float)0.7;
       if(output >= thelimit)
           return (float)thelimit;
       if(output <= -thelimit)
           return (float)-thelimit;
       else
           return output;
    }

  
    private void setStop() {
	stop = true;
    }
    
    public synchronized void run(){
       

	//	int[] count = new int[5];
	float[] yref = new float[5];
	float[] u = new float[5];

    
	for (int k=1; k<=NbrOfJoints; k++){
        
	 
	   pisp[k]=new PutInStartPosition(k, motors);
	   // count[k]=0;
	}

	try{
	    while(true){
		
		System.out.println("Waiting for connection on port 2002");
		Socket s = irbServerSocket.accept();
		DataInputStream traj = new DataInputStream(s.getInputStream());
	     
	       
		try{
		    
		    int interval = p.getSamplingInterval();
		    long maxtime = System.currentTimeMillis() + 120000;
		    long time=System.currentTimeMillis();                            
		    long sleepUntil = (long)(time + interval);
		    
		    while(true){
			
			time = System.currentTimeMillis();
			if(time > maxtime) {
			    setStop();
			}
			if(stop) {
			    for (i=1; i<=NbrOfJoints; i++){
				
				pisp[i].start();
				System.out.print("pisp started");
				return;
			    }
			}
			
			
			for (i=1; i<=NbrOfJoints; i++){
			
			    
			    float v,tmp;
			    float utemp;
			    
			    // Get reference for joint i
			  
			    y = motors.getPosition(i);	 
			    v = p.calculateOutput(y, yref[i]);	     
			    utemp = limit(v);
			    u[i] = -utemp;
			    
			    
			    // output control signal to joint i
			    
			    motors.analogOut(i, u[i]); 
			    p.updateState(u[i]);
			    
			    
			    
			    yref[i]= (float)traj.readDouble();
			  
			    
			    
			}
			
			
			
			sleepTime = sleepUntil - System.currentTimeMillis();
			if(sleepTime > 0) {
			    try {
				sleep(sleepTime);
				sleepUntil = sleepUntil + interval;
			    } catch(Exception e) {
				System.out.println("Exception catched in Regul");
			    }
			}
			else {
			    sleepUntil = sleepUntil + interval;
			    System.out.println("WARNING: Regul did not sleep");
			}
			
		    }//while(true)
		    
		} catch (IOException e) {
		    System.out.println("Lost connection");
		}
		
		
	    }//while(true)
	    
	    
	} catch (IOException e) {
// 	    System.err.println(e);
// 	    e.printStackTrace();
	    System.exit(1);
	}
    }//run
    
}
