// Virtual robot
//import se.lth.robot.servo.*;
// Real robot
import se.lth.cs.robot.servo.*;

public class PosSDSblock extends CascadePID {

    
    public SDSblock update(Sample s) {

	theAdmittedOutput.siso = s.siso;
	dynamics.update(s.siso);

	if (prevBlock != null) {
	    prevBlock.update(theAdmittedReference);
	    prevBlock = null;
	}

	return null;
    }

    
    public Sample reference(Sample s) {

	//System.out.println("PosSDSblock.reference(): s.siso =  " + s.siso);

	theDesiredReference.siso = s.siso;
	theDesiredReference.setTimestamp(s.getMillis());

	float v = s.siso;
	float u = limit(v);
	if(u != v) {
	    theAdmittedReference.siso = u;
	    theAdmittedReference.saturated = true;
	} else {
	    theAdmittedReference.siso = s.siso;
	    theAdmittedReference.saturated = false;
	}
	theAdmittedReference.setTimestamp(s.getMillis());

	return theAdmittedReference;
    }

    
    public Sample compute(Sample s) {

	//System.out.println("PosSDSblock.compute(): s.siso = " + s.siso);

	theDynamicsInput.siso = s.siso;
	theDynamicsInput.setTimestamp(s.getMillis());
	theDesiredOutput.siso = dynamics.compute(s.siso, theAdmittedReference.siso);
	theDesiredOutput.setTimestamp(s.getMillis());

	dispatcher.dispatch(theDesiredOutput);

	return s;
    }
}
