// Virtual robot
//import se.lth.robot.servo.*;
// Real robot
import se.lth.cs.robot.servo.*;

public class RefGen extends Thread {

    private boolean stop = false;
    private boolean generate = false;
    private int period;
    private float[] ref; 
    private float[] sync;
    private PosSDSblock[] posBlock;
    private Sample[] theSample;

    
    public RefGen(int iperiod, float[] iref, PosSDSblock[] iposBlock) {
	period = iperiod;
	ref = iref;
	posBlock = iposBlock;
	theSample = new Sample[posBlock.length];
	for (int i=0;i<theSample.length;i++) {
	    theSample[i] = new Sample();
	}
    }

    
    public void doStop() {
	stop = true;
    }

    
    public void startGenerating(float[] synchValues) {

	sync = synchValues;
	//System.out.println("RefGen.startGenerating(): sync[1]=" + sync[1] + ", sync[2]=" + sync[2]);
	generate = true;
    }

    
    public void stopGenerating() {
	generate = false;
    }

    
    public boolean isGenerating() {
	return generate;
    }

    
    public void run() {
	long t = System.currentTimeMillis();
	long sleepUntil = t + period;

	while(!stop) {

	    if (generate) {
		System.out.println("New references");
		for(int i=0; i<posBlock.length; i++) {
		    ref[i] = -1*ref[i];
		    theSample[i].siso = ref[i] + sync[i];
		    posBlock[i].reference(theSample[i]);
		    //System.err.println("[" + i + "] RefGen.run(), theSample.siso=" + theSample[i].siso);
		}
	    }

	    t = System.currentTimeMillis();
	    long sleepTime = sleepUntil-t;
	    if(sleepTime > 0) {
		try{
		    sleep(sleepTime);
		}catch(Exception e) {
		    System.out.println("Exception in RefGen.run()");
		}
	    }

	    sleepUntil = sleepUntil + period;
	}
    }
}

