// Virtual robot
//import se.lth.robot.servo.*;
// Real robot
import se.lth.cs.robot.servo.*;

public class Sampler extends Thread {

    private SDSinput[] posBlock;
    private SDSinput[] velBlock;
    private SDSoutput[] driveBlock;
    private Sample[] theSample;
    private long period;

    
    public Sampler(long iperiod, SDSinput[] pos, 
	    SDSinput[] vel, SDSoutput[] drive) {
	period = iperiod;
	posBlock = pos;
	velBlock = vel;
	driveBlock = drive;

	theSample = new Sample[posBlock.length];
	for (int i=0;i<theSample.length;i++) {
	    theSample[i] = new Sample();
	    theSample[i].setTimestamp(0);
	}
    }

    
    public void run() {
	try {
	    while (!isInterrupted()) {
		perform();
		sleep(period);
	    }
	} catch (InterruptedException e) {
	    System.out.println("Exception in Sampler.run()");
	}
    }

    
    public void perform() {
	for (int i = 0; i < posBlock.length; i++) {
	    //System.out.println("Joint: "+i);
	    theSample[i].setTimestamp(theSample[i].getMillis() + period);
	    Sample s = driveBlock[i].sampleOutput(theSample[i]);
	    posBlock[i].compute(s);
	    velBlock[i].compute(s);
	}
    }
}
