// Virtual robot
//import se.lth.robot.servo.*;
// Real robot
import se.lth.cs.robot.servo.*;

public class VelSDSblock extends CascadePID {

    public SDSblock update(Sample s) {

	theAdmittedOutput.siso = s.siso;

	if (prevBlock != null) {
	    prevBlock.update(theAdmittedOutput);
	    prevBlock = null;
	}

	return null;
    }


    public Sample compute(Sample s) {

	//System.out.println("VelSDSblock.compute(): thAdmittedReference.siso = " + theAdmittedReference.siso + 
	//		" s.siso = " + s.siso);

	theDynamicsInput.siso = s.siso;
	theDynamicsInput.setTimestamp(s.getMillis());

	theDesiredOutput.siso = theAdmittedReference.siso;
	dispatcher.dispatch(theDesiredOutput);

	return s;
    }


    public Sample reference(Sample s) {

	//System.out.println("VelSDSblock.reference(): s.siso = " + s.siso);

	// No tracking
	theDesiredReference.siso = theAdmittedReference.siso = s.siso;

	return theAdmittedReference;
    }
}
