import regtest.*;

public class RegTest {
   

    public static void main(String[] args) {
		int errCount = 0;

		System.out.println("Starting regression test suite\n");
		errCount += RewriteTest.testAll();
		errCount += PrimTypesTest.testAll();
		errCount += FieldTest.testAll();
		errCount += MethodTest.testAll();
		errCount += ConstructorTest.testAll();
		errCount += ExprTest.testAll();
		errCount += StmtTest.testAll();
		errCount += ForTest.testAll();
		errCount += WhileTest.testAll();
		errCount += SwitchTest.testAll();
  		errCount += ArrayTest.testAll();
		errCount += StringTest.testAll();
		errCount += LiteralTest.testAll();
		errCount += InheritanceTest.testAll();
		errCount += InnerClassTest.testAll();
		errCount += ConstTest.testAll();
		errCount += GCTest.testAll();
		errCount += GenericsTest.testAll();
		//errCount += AnonymousClassTest.testAll();
		errCount += ThreadTest.testAll();
		errCount += InterfaceTest.testAll();
		//errCount += UtilTest.testAll();
		errCount += IOTest.testAll();
		//errCount += ReflectionTest.testAll();
		errCount += ExceptionTest.testAll();
				

		System.out.println("\nRegression test suite finished");
		if (errCount > 0) {
			System.out.println();
			System.out.println("***********************");
			System.out.print("ATTENTION: ");
			System.out.print(errCount);
			System.out.println(" test(s) failed");
			System.out.println("***********************");
			System.out.println();
			System.out.println();
		} else {
			System.out.println("All tests went through clean\n");
		}
    }
    
}
