package regtest;

public class AnonymousClassTest extends TestCase{

    private static int errCount = 0;

    public static int testAll() {
	System.out.println("  AnonymousClassTest start");
	testSimple();
	testParams();
	testLocalVar();
	testMethod();
	System.out.println("  AnonymousClassTest finished");
	return errCount;
    }

    private static void testSimple() {
	TestClass test = new TestClass();
	I i = test.test();
	errCount += check(i.method()==8,"    testSimple failed.\n"+
			  "      i.method()=="+i.method()+" (8)");
    }

    private static void testParams() {
	TestClass test = new TestClass();
	I i = test.testParam(13);
	errCount += check(i.method()==13,"    testParam failed.\n"+
			  "      i.method()=="+i.method()+" (13)");
    }

    private static void testLocalVar() {
	TestClass test = new TestClass();
	I i = test.testLocalVar();
	errCount += check(i.method()==21,"    testLocalVar failed.\n"+
			  "      i.method()=="+i.method()+" (21)");
    }

    private static void testMethod() {
	TestClass test = new TestClass();
	I i = test.testMethod();
	errCount += check(i.method()==34,"    testLocalVar failed.\n"+
			  "      i.method()=="+i.method()+" (21)");
    }

}

class TestClass {

    int i = 3;

    int phonyMethod() {
	return 34;
    }

    I test() {
	I test = new I() {
		int a = i;
		public int method() {
		    return a+5;
		}
	    };
	return test;
    }

    I testParam(final int var) {
	I test = new I() {
		int a = var;
		public int method() {
		    return a;
		}
	    };
	return test;
    }

    I testLocalVar() {
	final int var = 21;
	I test = new I() {
		int a = var;
		public int method() {
		    return a;
		}
	    };
	return test;
    }

    I testMethod() {
	final int var = 21;
	I test = new I() {
		int a = phonyMethod();
		public int method() {
		    return a;
		}
	    };
	return test;
    }
}

interface I {
    int method();
}
