package regtest;


public class ConstructorTest extends TestCase{

    private static int errCount = 0;


    int a;

    Object o;

    public ConstructorTest() {
	a = 1;
    }

    public ConstructorTest(Object arg) {
	super();
	a = 2;
    }

    public static int testAll() {
	System.out.println("  ConstructorTest start");
	testSimpleCall();
	testCallArguments();
	testImplicitSuper();
	testExplicitConstructorCall();
	testNoDest();
	System.out.println("  ConstructorTest finished");
	return errCount;
    }

    private static void testSimpleCall() {
	int err = 0;
	int i = 0;
	ConstructorTest ct;
	ct = new ConstructorTest();
	i = ct.a;
	if (i != 1) {
	    System.out.println("    testSimpleCall failed.");
	    err++;
	}
	errCount += err;
    }

    private static void testCallArguments() {
	int err = 0;
	int i = 0;
	ConstructorTest ct;
	ct = new ConstructorTest();
	ct = new ConstructorTest(ct.o);
	i = ct.a;
	if (i != 2) {
	    System.out.println("    testCallArguments failed.");
	    err++;
	}
	errCount += err;
    }

    private static void testImplicitSuper() {
	int err = 0;
	int i = 0;
	ConstructorTest ct;
	ct = new ConstructorTest();
	SubClass sc = new SubClass();
	if (sc.a != 1) {
	    System.out.println("    testImplicitConstructor failed.");
	    err++;
	}
	errCount += err;
    }

    private static void testExplicitConstructorCall() {
	SubClass cs = new SubClass(2);
	errCount += check(cs.getAttr() == 2,
			  "    testExplicitConstructorCall failed.\n      cs.getAttr() == "+
			  cs.getAttr()+" (2)");
    }

    private static void testNoDest() {
	new SubClass();
	errCount += check(SubClass.b == 3,
			  "    testNoDest failed.\n      SubClass.b == "+
			  SubClass.b+" (3)");
    }




}

class SubClass extends ConstructorTest {

    static int b;

    public SubClass(){
	b = 3;
    }

    public SubClass(int i) {
 	this(i,System.currentTimeMillis());
    }

    public SubClass(int i, long j) {
	a = i;
    }

    public int getAttr() {
	return a;
    }
}
