package regtest;

public class ExprTest extends TestCase {

	private static int[] a;

	private static int errCount = 0;

	private if_this_causes_an_undeclared_error_while_compiling_to_C_there_is_a_problem_with_reachability_analysis_for_fields_with_initializers testfieldsinitializers =
		new if_this_causes_an_undeclared_error_while_compiling_to_C_there_is_a_problem_with_reachability_analysis_for_fields_with_initializers();

	int tmpi;

	private int i,j;
	private static int ii,jj;

	public static int testAll() {
		System.out.println("  ExprTest start");
		testCast();
		testParentheses();
		testLiterals();
		testQuestionColon();
		testAdd();
		testAssignSequence();
		testAssignLShift();
		testAssignOr();
		testAssignAnd();
		testAssignNull();
		testInstanceof();
		testPostfixIncrement();
		testPrefixIncrement();
		testPostfixDecrement();
		testPrefixDecrement();
		testPrePost();
		testLogicalExpr();
		System.out.println("  ExprTest finished");
		return errCount;
	}

	private static void testCast() {
		// NIY
		int err = 0;
		int i = (int)System.currentTimeMillis();
		if (i == 0) {
			System.out.println("    testCast failed.");
			err++;
		}
		errCount += err;
	}

	private static void testParentheses() {
		int err = 0;
		int i = 0;
		ExprTest et = new ExprTest();
		et.tmpi = 5;
		i = (et.tmpi + et.tmpi)/2;
		if (i != 5) {
			System.out.println("    testParentheses failed 1.");
			err++;
		}
		i = ((et.tmpi + et.tmpi)/2)*3;
		if (i != 15) {
			System.out.println("    testParentheses failed 2.");
			err++;
		}
		errCount += err;
		Object o = new ExprA();
		errCount += check(((ExprA) o).bMethod() == 3,"    testParentheses failed 3.\n"+
				"      ((ExprA) o).bMethod() = "+((ExprA) o).bMethod()+" (3)");
	}

	private static void testLiterals() {
		int err = 0;
		long i = 1L << 58;
		if (i == 0) {
			System.out.println("    testLiterals failed.");
			err++;
		}
		errCount += err;
	}

	private static void testQuestionColon() {
		int err = 0;
		int i = 5;
		i = i<5 ? 0 : 3;
		if (i == 0) {
			System.out.println("    testQuestionColon failed 1.");
			err++;
		}
		i = 0;
		i = System.currentTimeMillis() != 50 ? new Object().hashCode() : new String().length();
		errCount += check(i!=0,"    testQuestionColon failed 2.");
		errCount += check(returnQCE1()==42,"    testQuestionColon failed 3.");
		errCount += check(returnQCE2()==3,"    testQuestionColon failed 4.");
		i = 5;
		String s = "T"+(i==0 ? "1" : "2");
		errCount += check(s.equals("T2"),"    testQuestionColon failed 5.\n"+
				"      s=="+s+" (T2)");
	}

	private static void testAdd() {
		ExprTest et = new ExprTest();
		et.tmpi = 0;
		et.tmpi++;
		errCount += check(et.tmpi==1,"    testAdd failed.");
	}

	private static void testAssignSequence() {
		ExprTest et = new ExprTest();
		et.i = et.j = 3;
		errCount += check(et.i==3 && et.j==3,"    testAssignSequence failed for fields.");
		ii = jj = 4;
		errCount += check(ii==4 && jj==4,"    testAssignSequence failed for static fields.");
	}

	private static void testAssignLShift() {
		ExprTest et = new ExprTest();
		et.i = 1;
		et.i <<= 4;
		errCount += check(et.i==16,"    testAssignLShift failed for fields.\n"+
				"      et.i<<=3 =="+et.i+" (et.i<<=3 == 16)");
		ii = 1;
		ii <<= 4;
		errCount += check(ii==16,"    testAssignLShift failed for static fields.\n"+
				"      ii<<=3 ="+ii+" (ii<<=3 == 16)");
	}

	private static void testAssignOr() {
		ExprTest et = new ExprTest();
		et.i = 5;
		et.i |= 2;
		errCount += check(et.i==7,"    testAssignOr failed for fields.\n"+
				"      et.i |= 2 == "+et.i+" (7)");
		ii = 5;
		ii |= 2;
		errCount += check(ii==7,"    testAssignOr failed for static fields.\n"+
				"      ii |= 2 == "+ii+" (7)");
	}

	private static void testAssignAnd() {
		ExprTest et = new ExprTest();
		et.i = 5;
		et.i &= 2;
		errCount += check(et.i==0,"    testAssignAnd failed for fields.\n"+
				"      et.i &= 2 == "+et.i+" (0)");
		ii = 5;
		ii &= 2;
		errCount += check(ii==0,"    testAssignAnd failed for static fields.\n"+
				"      ii &= 2 == "+ii+" (0)");
	}

	private static void testAssignNull() {
		ExprB e1 = null;
		ExprB e2 = null;
		e1 = new ExprB();
		errCount += check(e2 == null, "    testAssignNull failed.");
	}
	
	private static void testInstanceof() {
		Object o = new ExprB();
		Thread t = Thread.currentThread();
		errCount += check(o instanceof ExprA,"    testInstanceof failed 1.\n"+
				"      (o instanceof ExprA) should be true.");

		// Not valid Java code. Should be replaced with something
		// better. AndersN
		// 	errCount += check(!(o instanceof String),"    testInstanceof failed 1.\n"+
		// 			  "      (o instanceof String) should be false.");
		errCount += check(o instanceof ExprI,"    testInstanceof failed 2.\n"+
				"      (o instanceof ExprI) should be true.");
		errCount += check(!(o instanceof AlmostDead),"    testInstanceof failed 3.\n"+
				"      (o instanceof AlmostDead) should be false.");

		errCount += check(!(o instanceof AlmostDeadInterface),"    testInstanceof failed 4.\n"+
				"      (o instanceof AlmostDeadInterface) should be false.");

		errCount += check(Thread.currentThread() instanceof Thread,"    testInstanceof failed 5.\n"+
				"      (currentThread() instanceof Thread) should be true.");

		AThread at = new AThread();
		errCount += check(!at.test(),"    testInstanceof failed 6.\n"+
				"      at.test() should be false.");

	}

	private static void testPostfixIncrement() {
		ExprB a = new ExprB();
		a.a = 1;
		a.b = a.a++;
		errCount += check(a.a == 2 && a.b == 1,
				"    testPostfixIncrement failed(1)\n" +
				"      a.a = " + a.a + " (2)\n" +
				"      a.b = " + a.b + " (1)");

		a.a = 1;
		a.b = a.a++ - 1;
		errCount += check(a.a == 2 && a.b == 0,
				"    testPostfixIncrement failed(2)\n" +
				"      a.a = " + a.a + " (2)\n" +
				"      a.b = " + a.b + " (0)");

		a.a = 1;
		a.a++;
		errCount += check(a.a == 2,
				"    testPostfixDecrement failed (3)\n"+
				"      a.a =  " + a.a + " (2)");
	}

	private static void testPrefixIncrement() {
		ExprB a = new ExprB();
		a.a = 1;
		a.b = ++a.a;
		errCount += check(a.a == 2 && a.b == 2,
				"    testPrefixIncrement failed(1)\n" +
				"      a.a = " + a.a + " (2)\n" +
				"      a.b = " + a.b + " (2)");

		a.a = 1;
		a.b = ++a.a - 1;
		errCount += check(a.a == 2 && a.b == 1,
				"    testPrefixIncrement failed(2)\n" +
				"      a.a = " + a.a + " (2)\n" +
				"      a.b = " + a.b + " (0)");

		a.a = 0;
		++a.a;
		errCount += check(a.a == 1,
				"    testPrefixIncrement failed(3)\n"+
				"      a.a =  " + a.a + " (1)");
	}

	private static void testPostfixDecrement() {
		ExprB a = new ExprB();
		a.a = 1;
		a.b = a.a--;
		errCount += check(a.a == 0 && a.b == 1,
				"    testPostfixDecrement failed(1)\n" +
				"      a.a = " + a.a + " (0)\n" +
				"      a.b = " + a.b + " (1)");

		a.a = 1;
		a.b = a.a-- - 2;
		errCount += check(a.a == 0 && a.b == -1,
				"    testPostfixDecrement failed(2)\n" +
				"      a.a = " + a.a + " (0)\n" +
				"      a.b = " + a.b + " (-1)");

		a.a = 1;
		a.a = a.a--;
		errCount += check(a.a == 1,
				"    testPostfixDecrement failed(3)\n"+
				"      a.a =  " + a.a + " (1)");
	}

	private static void testPrefixDecrement() {
		ExprB a = new ExprB();
		a.a = 1;
		a.b = --a.a;
		errCount += check(a.a == 0 && a.b == 0,
				"    testPrefixDecrement failed(1)\n" +
				"      a.a = " + a.a + " (2)\n" +
				"      a.b = " + a.b + " (2)");

		a.a = 1;
		a.b = --a.a - 1;
		errCount += check(a.a == 0 && a.b == -1,
				"    testPrefixDecrement failed(2)\n" +
				"      a.a = " + a.a + " (2)\n" +
				"      a.b = " + a.b + " (-1)");

		a.a = 3;
		a.a = --a.a;
		errCount += check(a.a == 2,
				"    testPrefixDecrement failed(3)\n"+
				"      a.a =  " + a.a + " (2)");

	}

	private static void testPrePost() {
		ExprB a = new ExprB();
		a.a = 3;
		a.b = 4;
		a.a = a.a++ - --a.b;
		errCount += check(a.a == 0 && a.b == 3,
				"    testPrePost failed(1)\n" +
				"      a.a = " + a.a + " (4)\n" +
				"      a.b = " + a.b + " (3)");

		a.a = 0;
		ExprA.cMethod(a.a++);
		errCount += check(a.a == 1,
				"    testPrePost failed(2)\n"+
				"      a.a =  " + a.a + " (1)");

	}

	private static void testLogicalExpr() {
		ExprB a = new ExprB();
		ExprB b = null;
		boolean tf;

		a.a = -10;
		a.b = 4;

		tf = a != null && (a.a > 0 || a.b < 10);
		errCount += check(tf == true,
				"    testLogicalExpr failed(1)");

		tf = b != null && b.a == 3;
		errCount += check(tf == false,
				"    testLogicalExpr failed(2)");
	}

	private static int returnQCE1() {
		int i = 1;
		return i==1 ? 42 : 41;
	}

	private static int returnQCE2() {
		int i = 1;
		return append(i==0?2:3);
	}

	private static int append(int i) {
		return i;
	}
	// Useful snippets to test

	// 	blockData[ blockDataCount++ ] = (byte)data;

}

interface ExprI {
	void aMethod();
}

class ExprA implements ExprI {
	public void aMethod() {}
	public int bMethod() {return 3;}
	public static final void cMethod(int a) {}
}

class ExprB extends ExprA {
    int a;
    int b;
}

class if_this_causes_an_undeclared_error_while_compiling_to_C_there_is_a_problem_with_reachability_analysis_for_fields_with_initializers {}

class AlmostDead {}

interface AlmostDeadInterface {}

class AThread {

	public boolean test() {
		AInner a = new AInner();
		return a.test();
	}

	class AInner extends Thread {
		public boolean test() {			
			if (currentThread() instanceof AInner) {
				return true;
			}	
			return false;
		}
	}
}
