package regtest;

public class FieldTest extends TestCase {

    private static final float floatConst = 4.0f;

    private static int INDEX = 2;

    private int tmp;
    private boolean tmpb;

    private static int errCount = 0;

    protected String s = new String("init");

    public static int testAll() {
	System.out.println("  FieldTest start");
	testStaticField();
	testFloatConst();
	testIntConst();
	testFieldAssign();
	testFieldInitializer();
	System.out.println("  FieldTest finished");
	return errCount;
    }

    private static void testStaticField() {
	int err = 0;
	int tmp;
	tmp = INDEX;
	if (tmp != 2) {
	    System.out.println("    testStaticField failed assign to local var. ");
		System.out.println(tmp);
	    err++;
	}
	FieldTest ft = new FieldTest();
	ft.tmp = INDEX;
	if (ft.tmp != 2) {
	    System.out.println("    testStaticField failed assign to attribute.");
	    err++;
	}
	INDEX++;
	if (INDEX != 3) {
	    System.out.println("    testStaticField failed postincrement.");
	    err++;
	}
	errCount += err;
    }

    private static void testFloatConst() {
	float tmp = 2.0f;
	if(tmp <= floatConst) {
	    tmp = floatConst;
	}
	errCount += check(tmp == 4.0f,"    testFloatConst failed.\n"+
			  "      tmp = "+tmp+" (4.0)");
    }

    private static void testIntConst() {
	int tmp = Integer.MAX_VALUE;
	errCount += check(tmp == Integer.MAX_VALUE,"    testIntConst failed.\n"+
			  "      tmp = "+tmp+" (2147483647)");
    }

    private static void testFieldAssign() {
	int err = 0;
	FieldTest ft = new FieldTest();
	ft.tmpb = !ft.tmpb;
	if (!ft.tmpb) {
	    System.out.println("    testFieldAssign failed assign to simplify.");
	    err++;
	}
	errCount += err;
    }

    private static void testFieldInitializer() {
		FieldTest ft = new FieldTest();
		errCount += check(ft.s.equals("init"),"    testFieldInitializer failed.\n"+
						  "      ft.s.equals(init) = "+ft.s.equals("init")+" (true)");
    }
	

}