package regtest;

public class InheritanceTest extends TestCase{


    private static int errCount = 0;


    public static int testAll() {
		System.out.println("  InheritanceTest start");
		testOverrideMethod();
		testInheritedMethod();
		testSuperMethod();
		testAbstractInheritance();
		System.out.println("  InheritanceTest finished");
		return errCount;
    }

    private static void testOverrideMethod() {
		int i = 0;
		A a = new A();
		i = a.overrideMethod();
		errCount += check(i==1,"    overrideMethod failed.\n      A.overrideMethod() = "+i+" ( 1 )");
		a = new B();
		i = a.overrideMethod();
		errCount += check(i==2,"    overrideMethod failed.\n      B.overrideMethod() = "+i+" ( 2 )");
    }

    private static void testInheritedMethod() {
		int err = 0;
		int i = 0;
		A a = new A();
		i = a.inheritedMethod();
		if (i != 3) {
			System.out.println("    inheritedMethod failed.");
			System.out.print("      A.inheritedMethod() = ");
			System.out.print(i);
			System.out.println(" ( 3 )");
			err++;
		}
		a = new B();
		i = 0;
		i = a.inheritedMethod();
		if (i != 3) {
			System.out.println("    inheritedMethod failed.");
			System.out.print("      B.inheritedMethod() = ");
			System.out.print(i);
			System.out.println(" ( 3 )");
			err++;
		}
    }

    private static void testSuperMethod() {
		int err = 0;
		int i = 0;
		B b = new B();
		i = b.superCall();
		if (i != 1) {
			System.out.println("    testSuperMethod failed.");
			System.out.print("      B.superCall() = ");
			System.out.print(i);
			System.out.println(" ( 1 )");
			err++;
		}
    }

	private static void testAbstractInheritance() {
		int err = 0;
		int i = 0;
		D d = new D();
		i = d.getA();
		errCount += check(i == 5,"    abstractInheritance1 failed.\n      d.getA() = "+i+" ( 5 )");
		i = d.getB();
		errCount += check(i == 4,"    abstractInheritance2 failed.\n      d.getB() = "+i+" ( 4 )");
	}

}


class A {
    int overrideMethod() {
		return 1;
    }

    int inheritedMethod() {
		return 3;
    }
}

class B extends A {
    int overrideMethod() {
		return 2;
    }

    int superCall() {
		return super.overrideMethod();
    }
}

abstract class C {
	int a = 5;
	transient int b = 4;
}

class D extends C {
	public int getA() {
		return a;
	}
	public int getB() {
		return b;
	}
}
