package regtest;

public class InnerClassTest extends TestCase{

    private int i = 1;

    private static int errCount = 0;

    public static int testAll() {
		System.out.println("  InnerClassTest start");
		testSimple();
		testSimpleMethod();
		testMultiLevel();
		System.out.println("  InnerClassTest finished");
		return errCount;
    }

    private static void testSimple() {
		InnerClassTest o = new InnerClassTest();
		int i = o.testInner();
		errCount += check(i==2,"    testSimple failed.\n"+
						  "      i=="+i+" (2)");
    }

    private static void testSimpleMethod() {
		InnerClassTest o = new InnerClassTest();
		int i = o.testInnerMethod();
		errCount += check(i==26,"    testSimpleMethod failed.\n"+
						  "      i=="+i+" (26)");
    }

    private static void testMultiLevel() {
		InnerClassTest o = new InnerClassTest();
		int i = o.testMulti();
		errCount += check(i==30,"    testMultiLevel failed.\n"+
						  "      i=="+i+" (30)");
    }

    private int testInner() {
		Inner inner = new Inner();
		return inner.innerMethod();
    }

    private int testInnerMethod() {
		Inner inner = new Inner();
		return inner.callEnclosingMethod();
    }

    private int testMulti() {
		Inner inner = new Inner();
		return inner.multiLevel();
    }

    int outerMethod() {
		return 13;
    }

    private class Inner {
		int a = 1;
		int ii = 3;

		int innerMethod() {
			return i+Inner.this.a; 
		}

		int callEnclosingMethod() {
			return InnerClassTest.this.outerMethod() + outerMethod();
		}

		int multiLevel() {
			MoreInner im = new MoreInner();
			return im.multiLevel();
		}

		private class MoreInner {
			int iii = 5;

			int multiLevel() {
				InnerMost im = new InnerMost();
				return im.topLevelMethod();
			}

			private class InnerMost {
				int iiii = 8;

				int topLevelMethod() {
					return outerMethod() + i + ii + iii + iiii;
				}
			}
		}
    }

}
