package regtest;



public class InterfaceTest extends TestCase {

    private static int errCount = 0;

    public static int testAll() {
	System.out.println("  InterfaceTest start");
	testInterfaceSimple();
	testInterfaceAttribute();
	testInterfaceStaticInnerClass();
	System.out.println("  InterfaceTest finished");
	return errCount;
    }

    private static void testInterfaceSimple() {
	TestInterface t;
	t = new IUserA();
	errCount += check(t.iMethod()==2,"    testInterfaceSimple failed 1.\n"+
			  "      t.iMethod() = "+t.iMethod()+" (2)");
	t = new IUserB();
	errCount += check(t.iMethod()==3,"    testInterfaceSimple failed 2.\n"+
			  "      t.iMethod() = "+t.iMethod()+" (2)");
    }

    private static void testInterfaceAttribute() {
	errCount += check(TestInterface.ISTATIC == 42,"    testInterfaceAttribute failed 1.\n"+
			  "      TestInterface.ISTATIC = "+TestInterface.ISTATIC+" (42)");
	errCount += check(IUserA.ISTATIC == 42,"    testInterfaceAttribute failed 2.\n"+
			  "      IUserA.ISTATIC = "+IUserA.ISTATIC+" (42)");
    }

    private static void testInterfaceStaticInnerClass() {
	TestInterface2.A c;
	c = new TestInterface2.A();
	errCount += check(c.a == 5,"    testInterfaceStaticInnerClass failed.\n"+
			  "      c.a = "+c.a+" (5)");
    }

}


interface TestInterface {

    static int ISTATIC = 42;

    public int iMethod();

    void deadMethod();
}

class IUserA implements TestInterface {
    public int iMethod() {
	return 2;
    }

    public void deadMethod(){}
}

class IUserB implements TestInterface {
    public int iMethod() {
	return 3;
    }

    public void deadMethod(){}
}

class DeadIUser implements TestInterface {
    public int iMethod() {
	return 1;
    }

    public void deadMethod(){}
}

interface TestInterface2 {
	public static final class A {
	    int a = 5;
	}
}

