package regtest;

public class WhileTest {

	public static int testAll() {
		int errCount = 0;
		System.out.println("  WhileTest start");
		errCount += testWhile();
		errCount += testContinue();
		errCount += testBreak();
		errCount += testNested();
		errCount += testExpression();
		errCount += testEmpty();
		errCount += testGCPopRoot();
		System.out.println("  WhileTest finished");
		return errCount;
	}

	private static int testWhile() {
		int i = 0;
		while (i != 10) {
			i = 10;
		}
		if (i != 10) {
			System.out.println("    testWhile failed");
			return 1;
		}
		return 0;
	}

	private static int testContinue() {
		int i = 0, j = 0;
		while (i != 3) {
			if (i != 3) {
				i += 1;
				continue;
			}
			j = 4;
		}
		if (j != 0) {
			System.out.println("    testContinue failed");
			return 1;
		}
		return 0;
	}

	private static int testBreak() {
		int i = 0;
		while (true) {
			if (i == 3) break;
			i += 1;
		}
		if (i != 3) {
			System.out.println("    testBreak failed");
			return 1;
		}
		return 0;
	}

	private static int testNested() {
		int i = 0, j = 0;
		while (i < 3) {
			while (j < 10) {
				j += 1;
			}
			i += 1;
		}
		if (i != 3 || j != 10) {
			System.out.println("    testNested failed");
			return 1;
		}
		return 0;
	}

	private static int testExpression() {
		int	i = 0;
		int	j = 0;
		while (i++ < 10) {
			j = i * 2;
		}
		if (j != 20) {
			System.out.println("    testExpression failed");
			return 1;
		}
		return 0;
	}

	private static int testEmpty() {
		int	i = 0;
		int	j = 0;
		while (i++ < 10);
		if (i != 11) {
			System.out.println("    testEmpty failed");
			return 1;
		}
		return 0;
	}

	private static int testGCPopRoot() {
		// The translated code for this method needs to be manually inspected
		while (true) {
			WhileTestClass obj = new WhileTestClass();
			break;
		}
		int i = 0;
		while (i++ < 1) {
			WhileTestClass obj = new WhileTestClass();
			int aval = obj.a;
			obj.a += aval * 3;
			continue;
		}
		return 0;
	}

}

class WhileTestClass {
	int a;
	int b;
}
