package done;

public class PushButton {
	private byte state;

	public static final int NONE = 0;

	public static final int TIME = 1;
	public static final int ALARMSET = 2;
	public static final int TIMESET = 3;
	public static final int ALARMCHANGE = 4;

	public static final int UP = 1;
	public static final int DOWN = 2;
	public static final int RIGHT = 3;
	public static final int LEFT = 4;

	public PushButton() {
		state = (byte)0xFF;
	}

	/**
	 * Read port and return true if there is a state change
	 * since last method invocation.
	 */
	public boolean stateChanged() {
		byte data = getData();
		boolean result = (data != state);
		state = data;
		return result;
	}

	public byte getState() {
		return state;
	}

	public int getMode() {
		switch (state & 0x11) {
		case 0x11:
			return TIME;
		case 0x01:
			return TIMESET;
		case 0x10:
			return ALARMSET;
		case 0x00:
			return ALARMCHANGE;
		default:
			return NONE;
		}
	}

	public int getDirection() {
		switch (state & 0x2E) {
		case 0x2C:
			return LEFT;
		case 0x2A:
			return DOWN;
		case 0x26:
			return RIGHT;
		case 0x0E:
			return UP;
		default:
			return NONE;
		}
	}

	private static final native byte getData();
}
