package todo;
import done.*;
import se.lth.cs.realtime.semaphore.Semaphore;

class AlarmControl extends Thread {

	private ClockInput	input;
	private AlarmClock	alarm;
	private int		prevMode	= ClockInput.SHOW_TIME;

	AlarmControl(AlarmClock a, ClockInput i) {
		input = i;
		alarm = a;
	}

	public void run() {
		Semaphore inputsem = input.getSemaphoreInstance();

		while (true) {
			inputsem.take();
			
			alarm.resetAlarm();
                        try {sleep(100);} catch (InterruptedException e) {}
			alarm.setAlarm(input.getAlarmFlag());

			int choice = input.getChoice();
			if (choice != prevMode) {
				if (prevMode == ClockInput.SET_ALARM) {
					alarm.setAlarmTime(input.getValue());
				} else if (prevMode == ClockInput.SET_TIME) {
					alarm.setTime(input.getValue());
				}
				prevMode = choice;
			}
		}
	}
}
