import se.lth.cs.realtime.*;

public class RTPerf extends Thread {

//     {
// 	System.out.println("Initializing RTPerf");
//     }

    static long finishTime;
//     static CountingSem mutex;
    
    int period;
    int prio;
    int workload;

    static long startTime;

    RTPerf link;

    public long[] latencyLog;
    public long[] responseLog;


    private boolean stopped;
    
    RTPerf() {}

    RTPerf(int priority, int period, int workload) {
	setPriority(priority);
        this.period = period;
	prio = priority;
	this.workload = workload;
	latencyLog = new long[500];
	responseLog = new long[500];
    }

    public void stop() {
    	stopped = true;
    }

    
    public void run() {
	long wakeUp;
	long actualWakeUp;
	long latency;
	long responseTime;
	long response;
	long tmpTime;
	int work = workload;
	int ix = 0;

	if (startTime==0) {
	    startTime= RTSystem.currentTimeMicros();
	}

//  	wakeUp = RTSystem.currentTimeMicros();
 	wakeUp = startTime;

 	while( ix < 500 && !stopped) {
// 	while(!stopped) {
// 	System.out.println(wakeUp);
// 	System.out.println(finishTime);

	    actualWakeUp = RTSystem.currentTimeMicros();
	    latency = actualWakeUp-wakeUp;
//	    System.out.println(latency);
 	    for (int i=0; i<work; i++) {
		Object o = new Object();
//      		doWork();
//      		testScalar();
 	    }
	    
	    responseTime = RTSystem.currentTimeMicros();
// 	    response = responseTime - actualWakeUp;
	    response = responseTime - wakeUp;
	    latencyLog[ix] = latency;
	    responseLog[ix] = response;
	    ix++;

	    wakeUp += period;
	    long t = RTSystem.currentTimeMicros();
// 	    try {
// 		if (val > 0) {
// 	    sleep(0,(int) (wakeUp-t)*1000);
 		    RTSystem.sleepUntilMicros(wakeUp);

//		    RTSystem.sleepUntilMicros(RTSystem.currentTimeMicros()+100000);
//		    System.out.println(RTSystem.currentTimeMicros());
//		    System.out.println(wakeUp);
// 		    sleep((int)val/1000,(int)((int)val % 1000)*1000);
// 		}
// 	    } catch (InterruptedException e) {
// 		System.out.print("Thread: ");
// 		System.out.print(prio);
// 		System.out.println(" got interrupted");
// // 		interrupt();
// 		return;
// 	    }
	}
    }

    void doWork() {
	Object o = new Object();
    }

    long fib(int n) {
	return n<2 ? 1 : fib(n-2)+fib(n-1);
    }

    static long staticFib(int n) {
	return n<2 ? 1 : staticFib(n-2)+staticFib(n-1);
    }

    double scalar(double[] a, double[] b) {
	double res = 0;
	int len = a.length;
	for (int i=0; i<6; i++) {
	    res += a[i]*b[i];
	}
	return res;
    }

    void testScalar() {
 	double a[] = new double[6];
 	double b[] = new double[6];
//  	a[0] = 1.2;
//  	a[1] = 1.2;
//  	a[2] = 1.2;
//  	a[3] = 1.2;
//  	a[4] = 1.2;
//  	a[5] = 1.2;
//  	b[0] = 1.2;
//  	b[1] = 1.2;
//  	b[2] = 1.2;
//  	b[3] = 1.2;
//  	b[4] = 1.2;
//  	b[5] = 1.2;
//  	for (int j=0; j<100000; j+=1000) {
//  	    long time = System.currentTimeMillis();
//  	for (int i=0; i<5; i++) {
//  		double res = scalar(a,b);
//  	}
// 	    System.out.print(j);
//	    System.out.print("*scalar(a,b)");
// 	    System.out.print(" Time: ");
// 	    System.out.println(System.currentTimeMillis()-time);
//  	}
    }

    void testTempVariables(Object o1, Object o2, Object o3) {
// 	link = new RTPerf();
	link = this;
	link.link.link = link.link.link.link;
    }

    static void testAllocation() {
	RTPerf rtp;
	long time = System.currentTimeMillis();
	for (int i=0; i<200000; i++) {
	    rtp = new RTPerf();
	}
	System.out.print("200000 new RTPerf");
	System.out.print(" Time: ");
	System.out.println(System.currentTimeMillis()-time);
    }

    public static void main(String[] args) {
	System.out.println("hello");

	RTPerf rtp = new RTPerf();
	
	long time;
 	time = System.currentTimeMillis();
// 	for (int i=0; i<500000; i++) {
// 	    rtp.testTempVariables(rtp,rtp,rtp);
// 	}
	System.out.print("50000*testTempVariables=");
	System.out.print(" Time: ");
	System.out.println(System.currentTimeMillis()-time);
	    


	int fibNo = 10;

	    time = System.currentTimeMillis();
	    long res = rtp.fib(fibNo);
	    System.out.print("fib(");
	    System.out.print(fibNo);
	    System.out.print(")=");
	    System.out.print(res);
	    System.out.print(" Time: ");
	    System.out.println(System.currentTimeMillis()-time);
	    time = System.currentTimeMillis();
	    res = staticFib(fibNo);
	    System.out.print("staticFib(");
	    System.out.print(fibNo);
	    System.out.print(")=");
	    System.out.print(res);
	    System.out.print(" Time: ");
	    System.out.println(System.currentTimeMillis()-time);

// 	    time = System.currentTimeMillis();
// 	    rtp.testScalar();
// 	    System.out.print("1000000*scalar()");
// 	    System.out.print(" Time: ");
// 	    System.out.println(System.currentTimeMillis()-time);


	    // Time allocation of new objects
// 	    testAllocation();



// 	long now = RTSystem.currentTimeMicros();
// 	System.out.println(now);
// 	RTSystem.sleepUntil(now+1000);
// 	now = RTSystem.currentTimeMicros();
// 	System.out.println(now);
	

 	RTPerf rtp1,rtp2,rtp3;
// 	System.out.println(1);

 	rtp1 = new RTPerf(8,1000,7);
// 	System.out.println(3);

 	rtp2 = new RTPerf(9,400,6);

 	rtp3 = new RTPerf(10,250,2);

 	long startTime = RTSystem.currentTimeMicros();
//  	finishTime = startTime + 100000;
//  	rtp1.startTime = startTime;
//  	rtp2.startTime = startTime;
//  	rtp3.startTime = startTime;

    	rtp1.start();
      	rtp2.start();
  	rtp3.start();

 	RTSystem.sleepUntilMicros(startTime+10000000);
	rtp1.stop();
	rtp2.stop();
	rtp3.stop();

  	String comma = new String(",");

 	for (int i=0; i<500; i++) {
 	    System.out.print(rtp3.latencyLog[i]);
 	    System.out.print(comma);
 	    System.out.print(rtp3.responseLog[i]);
 	    System.out.print(comma);
 	    System.out.print(rtp2.latencyLog[i]);
 	    System.out.print(comma);
 	    System.out.print(rtp2.responseLog[i]);
 	    System.out.print(comma);
 	    System.out.print(rtp1.latencyLog[i]);
 	    System.out.print(comma);
 	    System.out.println(rtp1.responseLog[i]);
	}
    }
}
