import se.lth.cs.realtime.semaphore.*;

public class SemTest {

  public SemTest() {

	System.out.println("SemTest - main-start");	
	
	MutexSem sem = new MutexSem();
	CountingSem cs = new CountingSem();
	BinarySem bs = new BinarySem();
	
	Thread pt0 = new Thread0(sem);

	Thread pt1 = new Thread1(sem, cs, bs);
	Thread pt2 = new Thread2(sem, cs);
	Thread pt3 = new Thread3(sem, bs);

	System.out.println("SemTest - created threads");
	
	
	System.out.println("SemTest - testing semaphore");	
	cs.give();
	cs.take();

	
	//pt1.setPriority(10);
	pt0.setPriority(java.lang.Thread.MAX_PRIORITY);
	System.out.println("SemTest - starting threads");
	pt1.start();
	pt3.start();
	pt2.start();
	pt0.start();

	System.out.println("SemTest - started threads");
    }
  
	
    public static void main(String[] args) {
	SemTest s = new SemTest();	
    }
 
  
   class Thread0 extends Thread {
    	private String str;
	private int counter = 0;
    	private MutexSem sem;

    	public Thread0(MutexSem sem) {
		this.sem = sem;
		str = "Thread0";
    	}   
     
    	public void run() {
    		sem.take();
		for(int i=0;i<50;i++) {
	    		if(counter < 6) {
				//System.out.print(str.charAt(counter));
				System.out.print(counter);
				counter++;
	    		} else {
				counter = 0;
				System.out.println("");
		    	}
	    		try {
	    			this.sleep(100);
		    	} catch(Exception exc) {}
		}
	    sem.give();
    	}
    } 
        
    class Thread1 extends Thread {
	    private String str;
	    private MutexSem sem;
	    private Semaphore s1;
	    private Semaphore s2;
	    
	    public Thread1(MutexSem sem, Semaphore s1, Semaphore s2) {
		    this.sem = sem;
		    this.s1 = s1;
		    this.s2 = s2;
		    str = "Thread1";
	    }
	    
	    public void run() {
		    for(int i = 0;i<10;i++) {
			    sem.take();
			    System.out.println(str);
			    s1.give();
			    s1.give();
			    s2.give();
			    s2.give();
			    sem.give();
			    try {
				    this.sleep(700);
			    } catch(Exception exc) {}
		    }
	    }
    } 
    
    class Thread2 extends Thread {
	    private String str;
	    private MutexSem sem;
	    private Semaphore s;
	    
	    public Thread2(MutexSem sem, Semaphore s) {
		    this.sem = sem;
		    this.s = s;
		    str = "Thread2";
	    }
	    
	    public void run() {
		    for(int i = 0;i<15;i++) {
			    s.take();
			    sem.take();
			    System.out.println(str);
			    sem.give();
		    }
	    }
    } 
    
    class Thread3 extends Thread {
	    private String str;
	    private MutexSem sem;
	    private Semaphore s;
	    
	    public Thread3(MutexSem sem, Semaphore s) {
		    this.sem = sem;
		    this.s = s;
		    str = "Thread3";
	    }
	    
	    public void run() {
		    for(int i = 0;i<5;i++) {
			    s.take();
			    sem.take();
			    System.out.println(str);
			    sem.give();
		    }
	    }
    } 
}
