
import se.lth.cs.realtime.*;

public class SetPeriodThread extends PeriodicThread {

	private PeriodicThread target;
	private long sleepTime;
	private int count;
	private int periodCount;
	
	public SetPeriodThread(String name, PeriodicThread target, long sleepTime) {
		super(name, sleepTime);
		this.target = target;
		this.sleepTime = sleepTime;
		
		count = 0;
		periodCount = 0;
	}
	
	public void perform() {
		try {
			sleep(sleepTime);
	
			if (count % 3 == 0) {
				int period = 200 + (periodCount % 10)*100;
				System.out.println(getName() + "\tSET_PERIOD " + period);
				target.setPeriod(period);
			}
			
			count++;
			periodCount++;
			
		} catch (InterruptedException e) {
			
		}
	}
}
