import java.net.*;
import java.io.*;

public class SocketTest {

	public static void main(String[] args) {
		if (args.length < 1) {
			System.out.println("args: <listen port>");
			System.exit(1);
		}

		int port = Integer.parseInt(args[0]);
		ListenThread lt = new ListenThread(port);
		SendThread st = new SendThread(port);

		lt.start();
		st.start();
	}
}

public class ListenThread extends Thread {

	private int port;

	public ListenThread(int port) {
		this.port = port;
	}
	
	public void run() {
		try {
		ServerSocket servSock = new ServerSocket(port);
		while (true) {
				System.out.println("listening");
				Socket clientSock = servSock.accept();
				System.out.println("client connected");
				InputStream  is = clientSock.getInputStream();
				int cmd = 0;
				while (true) {
					cmd = is.read();
					if (cmd == -1)
						break;
					System.out.println("recv: "+cmd);
				}
				clientSock.close();
		}
		} catch (IOException e) {
			System.out.println("Caught exception in Receiver, continuing " + e);
		}
	}

}

public class SendThread extends Thread {

	private int port;

	public SendThread(int port) {
		this.port = port;
	}
	
	public void run() {
		try {
			Socket sock = new Socket("localhost", port);
			OutputStream out = sock.getOutputStream();
			out.write('h');
			out.write('e');
			out.write('j');
			out.flush();
			out.close();
			sock.close();
		} catch (IOException e) {
			System.out.println("IOException: " + e);
		}
	}

}
