class A extends Thread {

	public void run() {
		execute();
	}

	public synchronized static void sayStaticHello() {
		System.out.print("Hello ");
	}
	
	public static synchronized void execute() {
		sayHello();
		try {
			sleep(100);
		} catch (InterruptedException e) {
			System.out.println("Catch B.run()");
		}
		sayBye();
	}

	public static void sayBye() {
		System.out.println("Bye");
	}

	public static void sayHello() {
		System.out.print("Hello ");
	}
	
	public static void main(String[] args) {
		B myT1;
		B myT2;

		myT1 = new B();
		myT2 = new B();

		myT1.start();		
		try {
			sleep(10);
		} catch (InterruptedException e) {
			System.out.println("Catch Main");
		}

		myT1.sayInterrupt();
	}

	public synchronized static void sayInterrupt() {
		System.out.println("Interrupt!");
	}


}

class B extends A {
	
	public void run() {
		execute();
	}
}
