public class Threads {
	public static void main(String[] args) {

		Monitor m = new Monitor();

		try {
			new Thread1(m).start();
			new Thread2(m).start();
			m.start();
		} catch (Exception e) {
			e.printStackTrace();
		}
    }
    
}

public class Monitor {
	boolean go = false;
	int value = 0;
	boolean in_v2 = false;
	Integer v2 = new Integer(3);
	Integer v3 = new Integer(3);


	synchronized void start() {
		go = true;
		notifyAll();
	}

	synchronized void waitGo() {
		try {
			while (!go) wait();
		} catch (InterruptedException e) {}
	}

	synchronized void sync1() {
		value += 1;
		notifyAll();
		return;
	}

	synchronized void sync2() {
		value += 2;
		notifyAll();
		return;
	}

	synchronized void wait1() {
		int old = value;
		try {
			while (old == value) wait();
		} catch (InterruptedException e) {}
	}


	void syncblock1() {
		synchronized (this) {
			synchronized (v2) {
				if (in_v2 == true) {
					throw new RuntimeException("Another thread is in v2!");
				}
				in_v2 = true;
				//v2.toString();
				in_v2 = false;
				synchronized (v3) {
					return;
				}
			}
		}
	}
	void syncblock2() {
		do {
			synchronized (this) {
				synchronized (v2) {
					if (in_v2 == true) {
						throw new RuntimeException("Another thread is in v2!");
					}
					in_v2 = true;
					//v2.toString();
					in_v2 = false;
					break;
				}
			}
		} while (false);
	}
}

public class Thread1 extends Thread {
	Monitor m;
	public Thread1(Monitor mon) {m = mon;}
	public void run() {
		m.waitGo();
		for (int i = 0; i < 10000; ++i) {
			//System.out.println("[Thread1] i="+i);
			m.syncblock1();
			//m.sync1();
		}
		System.out.println("Thread1 done.");
	}
}

public class Thread2 extends Thread {
	Monitor m;
	public Thread2(Monitor mon) {m = mon;}
	public void run() {
		m.waitGo();
		for (int i = 0; i < 10000; ++i) {
			//System.out.println("[Thread2] i="+i);
			m.syncblock2();
			//m.sync2();
		}
		System.out.println("Thread2 done.");
	}
}
