#ifndef ONCE_GC_MS_H
#define ONCE_GC_MS_H

#include "gc.h"
#include "gc_types.h"
#include "mem.h"

typedef struct memdq memdq;

/* ObjectHead_real is used in the GC (for sweeping) */
typedef struct ObjectHead_real {
	memdq m;
	OBJECTHEAD;
} ObjectHead_real;

void gc_ms_init(int heapsize);

int gc_free(void *ptr, unsigned int size);

void *gc_new(uint32 size, void *tmplate);

// GC write barrier

#ifndef UPDATE_MACRO
void gc_update(void **a, void *c);
#endif
int gc_create_heap(unsigned int size);

// void gc_push(GC___REF(ObjectHead) ptr);

int gc_marking_roots(void);
#endif
