#ifndef __GC_H__
#define __GC_H__

#include <stddef.h>							
int gc_layout(int descriptors, ...);

void* myMalloc(int size);

// fast hack prototypes for alarm clock lab
void _java_lang_System_arraycopy_Object_int_Object_int_int(void* src, int src_pos, 
							   void* dest, int dest_pos,
							   int length);
long _java_lang_System_currentTimeMillis();
void _java_lang_System_exit_int(JInt i);
void _java_lang_System_registerNatives();
int _java_lang_System_identityHashCode_Object(void* o);
void _done_LCDDisplay_writeDataByte_char(unsigned char c);
void _done_LCDDisplay_writeCtrlByte_char(unsigned char c);
void _done_LCDDisplay_setupPorts(void);
void _done_LCDDisplay_extraDelay(void);
void _done_Alarm_on(void);
void _done_Alarm_off(void);
void _done_Alarm_setupAlarm(void);
char _done_PushButton_getData(void);
void _java_lang_Thread_sleep_long(long millis);
/*  long _java_lang_Thread_createThread(void* this, void (*method)(void)); */
long _java_lang_Thread_createThread(void* this);
void _java_lang_Thread_start(void* this);
void _java_lang_Thread_startThread_long(void *this, long target);
long _se_lth_cs_realtime_semaphore_CountingSem_createCountingSem_int(void *this, int i);
void _se_lth_cs_realtime_semaphore_CountingSem_giveCountingSem_long(void *this, long target);
void _se_lth_cs_realtime_semaphore_CountingSem_takeCountingSem_long(void *this, long target);
//int Java_Main_getTick(void);
long _todo_TimeHandler_getMillis(void);
long Java_System_currentTimeMillis(void);

// Common implementation macros

// HERE BE DRAGONS! Remove these when the compiler has been fixed to generate
// the proper macros (GC___REF &c.)

/*  #define REF(x) GC___REF(x) */
/*  #define PTR(x) GC___PTR(x) */
#define REF(x) x*
#define PTR(x) x
#define GC___REF(x) x*
#define GC___PTR(x) x
#define GC___ASSIGN(a,b) a = b
#define GC___ADDR_OF_PTR(x) x

/*  #define OBJECTHEAD \ */
/*    GCFields gc;\ */
/*    GC___REF(struct LayoutHead) tmplate */

///*  typedef unsigned short     uint16 ;  /* char  - unsigned 8-bits */ */
/*  #define LAYOUTHEAD \ */
/*    OBJECTHEAD;\ */
/*    GC___REF(struct Uint8Array) gcInfo; \ */
/*    uint16 objectSize */

/*  typedef struct ObjectHead { */
/*    OBJECTHEAD; */
/*  } ObjectHead; */

/*  typedef struct LayoutHead { */
/*    LAYOUTHEAD; */
/*  } LayoutHead; */


/*  typedef struct gc_root { */
/*    GC___REF(ObjectHead) ref; */
/*    struct gc_root *next_root; */
/*    struct gc_root *top_root; */
/*    struct gc_root *next_thread; */
/*    struct gc_root *prev_thread; */
/*    int local_result; */
/*  } gc_root; */

/* local_result in the gc_thread struct is used as a temporary variable for 
   making GC_IS_NULL and GC_EQUAL expressions. (see e.g. GC__IMPL_EQUAL)*/

// HERE BE DRAGONS! temporarily moved local_result to gc_root

/*  typedef struct gc_thread_t{  */
/*      gc_root root;  */
/*   //    int local_result; */
/*    GC___REF(ObjectHead) this; */
/*  } gc_thread_t;  */

/*  gc_root *gc_thread_get_root(void); */
/*  //extern gc_root *gc_thread_roots; */
/*  extern gc_root *gc_static_roots; */
/*  //extern void ****gc_roottop; */
/*  //extern int gc_marking; */
/*  //extern struct objecthead *markstk; */

/*  void gc_incremental_ms_init(int heapsize); */


/*  #define GC__IMPL_KIND(object, field) \ */
/*    gc_field_kind(GC___PTR(object.ref), &(GC___PTR(object.ref)->field), \ */
/*  		sizeof(GC___PTR(object.ref)->field)) */

/*  GC___REF(LayoutHead) gc_new_layout(int size, int descriptors, ...); */

//
// One time 
//
#define GC_GLOBALS

#define GC_INIT(heapsize) 

#define GC_EXIT 

//
// For each thread  
//

#define GC_THREAD_INIT 

#define GC_THREAD_EXIT 
//
// Object layout declaration 
//
#define GC_STRUCT_BEGIN(name) struct name { 
#define GC_STRUCT_REF(type, name) GC___REF(struct type) name
#define GC_STRUCT_VAR(type, name) type name
#define GC_STRUCT_END(name) }
#define GC_NEW_LAYOUT(layout, object, size, ...) \
  layout = (void *) sizeof(object)
/*    layout = (void *) size */
#define GC_LAYOUT_FIELD(object, field) offsetof(struct object, field)
#define GC_LAYOUT_ARRAY(length, offsets) \
  fprintf(stderr, "GC_LAYOUT_ARRAY(%s, %s) not supported (yet)\n", \
          #length, #offsets)

//
// Reference declaration
//
#define GC_REF(type, name) \
  GC___REF(struct type) name
#define GC_PUSH_ROOT(var) 
#define GC_POP_ROOT(var) 

#define GC_PUSH_STATIC_ROOT(var) 
#define GC_POP_STATIC_ROOT(var) 

//
// Object allocation
//
#ifdef IAR
#define GC_NEW(obj,layout) \
  GC___ASSIGN(obj, (void *)myMalloc((int)layout));
#else
#define GC_NEW(obj,layout) \
  GC___ASSIGN(obj.ref, gc_new_2(layout.ref));
#endif

//
// Reference access
//
#define GC_ASSIGN(target, source) \
  GC___ASSIGN(target, source); 
#define GC_ASSIGN_NULL(target, source) target = 0
#define GC_IS_NULL(var) (var.ref == 0)
#define GC_EQUAL(ref1, ref2) ((void *)(ref1)==(void *)(ref2))

//
// Field access
//
#define GC_GET(var, object, field) var = GC___PTR(object)->field 
#define GC_GET_PTR(var, type, object, field) var = (type) GC___PTR(object)->field 
#define GC_SET(object, field, value) GC___PTR(object)->field = value 
#ifdef IAR
#define GC_GET_REF(var, object, field) \
  GC___ASSIGN(var, (void*)GC___PTR(object)->field);
#else
#define GC_GET_REF(var, object, field) \
  GC___ASSIGN(var.ref, GC___PTR(object.ref)->field);
#endif
#define GC_SET_REF(object, field, value) \
  GC___ASSIGN((GC___PTR(object)->field), value);
#define GC_SET_NULL(object, field) GC___PTR(object)->field = 0

//
// Function declaration
//
#define GC_REF_FUNC_BEGIN(type, name, ...) \
  GC___REF(type) name(__VA_ARGS__) { \
    GC_REF(type, gc_result); GC_PUSH_ROOT(gc_result); {
#define GC_VAR_FUNC_BEGIN(type, name, ...) \
  type name(__VA_ARGS__) { \
    type gc_result; {
#define GC_PROC_BEGIN(name, ...) \
  void name(__VA_ARGS__) { \
    {
#define GC_PARAM(type, name) GC___REF(struct type) name
#define GC_PARAM_REF(type, name)
#define GC_PUSH_PARAM(local) 
#define GC_FUNC_ENTER 
#define GC_RETURN_REF(result) \
  GC___ASSIGN(gc_result, result);  goto gc_leave
#define GC_RETURN_VAR(result) \
  gc_result = result; goto gc_leave
#define GC_RETURN goto gc_leave
#define GC_FUNC_LEAVE gc_leave:
#define GC_POP_PARAM(local) 
#define GC_REF_FUNC_END(type, name) \
  }{ void *kludge = gc_result; GC_POP_ROOT(gc_result); return kludge; }}
#define GC_VAR_FUNC_END(type, name) \
  } return gc_result; }
#define GC_PROC_END(name) \
  } }

//
// Function call
// 
#define GC_REF_FUNC_CALL(result, func, ...) \
  GC___ASSIGN(result, func(__VA_ARGS__)); 
#define GC_VAR_FUNC_CALL(result, func, ...) \
  result = func(__VA_ARGS__);
#define GC_PROC_CALL(proc, ...) proc(__VA_ARGS__)
#ifdef IAR
#define GC_PASS(obj) (void*)GC___ADDR_OF_PTR(obj)
#else
#define GC_PASS(obj) GC___ADDR_OF_PTR(obj)
#endif



/*  #define GC_GLOBALS GC__THREAD_GLOBALS \ */
/*    struct gc_globals gc_global; */
/*  #define GC_INIT(heapsize) GC__THREAD_INIT(heapsize) */
/*  #define GC_EXIT GC__THREAD_EXIT */

/*  // */
/*  // For each thread */
/*  // */

/*  #define GC_THREAD_INIT GC__THREAD_THREAD_INIT */
/*  #define GC_THREAD_EXIT GC__THREAD_THREAD_EXIT */

/*  //  */
/*  // Object layout declaration */
/*  //  */
/*  #define GC_STRUCT_BEGIN(name) GC__THREAD_STRUCT_BEGIN(name) */
/*  #define GC_STRUCT_REF(type, name) GC__THREAD_STRUCT_REF(type, name) */
/*  #define GC_STRUCT_VAR(type, name) GC__THREAD_STRUCT_VAR(type, name) */
/*  #define GC_STRUCT_END(name) GC__THREAD_STRUCT_END(name) */
/*  #define GC_NEW_LAYOUT(layout, object, ...) \ */
/*    GC__THREAD_NEW_LAYOUT(layout, object,__VA_ARGS__) */
/*  #define GC_LAYOUT_FIELD(object, field) GC__THREAD_LAYOUT_FIELD(object, field) */
/*  #define GC_LAYOUT_ARRAY(length, array) GC__THREAD_LAYOUT_ARRAY(length, array) */

/*  // */
/*  // Reference declaration */
/*  // */
/*  #define GC_REF(type, name) GC__THREAD_REF(type,name) */
/*  #define GC_PUSH_ROOT(var) GC__THREAD_PUSH_ROOT(var) */
/*  #define GC_POP_ROOT(var) GC__THREAD_POP_ROOT(var) */
/*  #define GC_PUSH_STATIC_ROOT(var) GC__THREAD_PUSH_STATIC_ROOT(var) */
/*  #define GC_POP_STATIC_ROOT(var) GC__THREAD_POP_STATIC_ROOT(var) */

/*  // */
/*  // Object allocation */
/*  // */
/*  #define GC_NEW(ref,layout) GC__THREAD_NEW(ref,layout) */

/*  // */
/*  // Reference acess */
/*  // */
/*  #define GC_ASSIGN(target, source) GC__THREAD_ASSIGN(target, source) */
/*  #define GC_ASSIGN_NULL(target) GC__THREAD_ASSIGN(target) */
/*  #define GC_IS_NULL(var) GC__THREAD_IS_NULL(var) */
/*  #define GC_EQUAL(ref1, ref2) GC__THREAD_EQUAL(ref1, ref2) */

/*  // */
/*  // Field access */
/*  // */
/*  #define GC_GET(var, object, field) GC__THREAD_GET(var, object, field) */
/*  #define GC_GET_PTR(var, type, object, field) GC__THREAD_GET_PTR(var, type, object, field) */
/*  #define GC_SET(object, field, value) GC__THREAD_SET(object, field, value) */
/*  #define GC_GET_REF(var, object, field) \ */
/*    GC__THREAD_GET_REF(var, object, field) */
/*  #define GC_SET_REF(object, field, value) \ */
/*    GC__THREAD_SET_REF(object, field, value) */
/*  #define GC_SET_NULL(object, field) GC__THREAD_SET_NULL(object, field) */




/*  // */
/*  // Function declaration */
/*  // */
/*  #define GC_REF_FUNC_BEGIN(type, name, ...) \ */
/*    GC__THREAD_REF_FUNC_BEGIN(type, name,__VA_ARGS__) */
/*  #define GC_VAR_FUNC_BEGIN(type, name, ...) \ */
/*    GC__THREAD_VAR_FUNC_BEGIN(type, name,__VA_ARGS__) */
/*  #define GC_PROC_BEGIN(name, ...) \ */
/*    GC__THREAD_PROC_BEGIN(name,__VA_ARGS__) */
/*  #define GC_PARAM(type, name) GC__THREAD_PARAM(type, name) */
/*  #define GC_PARAM_REF(type, name) GC__THREAD_PARAM_REF(type, name) */
/*  #define GC_PUSH_PARAM(obj) GC__THREAD_PUSH_PARAM(obj,obj) */
/*  #define GC_FUNC_ENTER GC__THREAD_FUNC_ENTER */
/*  #define GC_RETURN_REF(result) GC__THREAD_RETURN_REF(result) */
/*  #define GC_RETURN_VAR(result) GC__THREAD_RETURN_VAR(result) */
/*  #define GC_RETURN GC__THREAD_RETURN */
/*  #define GC_FUNC_LEAVE GC__THREAD_FUNC_LEAVE */
/*  #define GC_POP_PARAM(obj) GC__THREAD_POP_PARAM(obj,obj) */
/*  #define GC_REF_FUNC_END(type, name) GC__THREAD_REF_FUNC_END(type, name) */
/*  #define GC_VAR_FUNC_END(type, name) GC__THREAD_VAR_FUNC_END(type, name) */
/*  #define GC_PROC_END(name) GC__THREAD_PROC_END(name) */

/*  // */
/*  // Function call */
/*  // */
/*  #define GC_REF_FUNC_CALL(result, func, ...) \ */
/*    GC__THREAD_REF_FUNC_CALL(result, func, __VA_ARGS__) */
/*  #define GC_VAR_FUNC_CALL(result, func, ...) \ */
/*    GC__THREAD_VAR_FUNC_CALL(result, func, __VA_ARGS__) */
/*  #define GC_PROC_CALL(name, ...) \ */
/*    GC__THREAD_PROC_CALL(name, __VA_ARGS__) */
/*  #define GC_PASS(obj) GC__THREAD_PASS(obj) */


#endif
