#ifndef __GC_IMPL_BATCH_COPY_H__
#define __GC_IMPL_BATCH_COPY_H__
//
// This file contains the implementation layer macros for the batch
// copying collector

//
// Internally used macros
//

/* REF: Macro for specifying reference types.
 *   Examples: Object *x is written REF(Object) x
 *             (Object *) x is written (REF(Object)) x;
 */
#define GC___REF(ref_type) ref_type *

/* PTR: Macro for accessing a reference.
 *   Example: x->y is written PTR(x)->y
 */
#define GC___PTR(ref) ref

/* address of pointer */
#define GC___ADDR_OF_PTR(ref) ref

/* pointer (not reference) assignment with write barrier*/
/* #define GC___ASSIGN(target, source) (void *)target=source; */
// Fix to make it compile using GCC 4.0. AndersN
#define GC___ASSIGN(target, source) target=source;

// gc (block) header information 

typedef struct GCFields {
  void *fp;
} GCFields;

#endif
