#ifndef __GC_IMPL_INCREMENTAL_COPY_H__
#define __GC_IMPL_INCREMENTAL_COPY_H__
//
// This file contains the implementation layer macros for the batch
// copying collector

//
// Internally used macros
//

/* REF: Macro for specifying reference types.
 *   Examples: Object *x is written REF(Object) x
 *             (Object *) x is written (REF(Object)) x;
 */
#define GC___REF(ref_type) ref_type **

/* PTR: Macro for accessing a reference.
 *   Example: x->y is written PTR(x)->y
 */
// #define GC___PTR(ref) (*(ref->gc.fp))
#define GC___PTR(ref) (*ref)


/* address of pointer */
#define GC___ADDR_OF_PTR(ref) &GC___PTR(ref)

/* pointer (not reference) assignment with write barrier*/
#define GC___ASSIGN(target, source) (void *)target=source; gc_evacuate(&target);

// gc (block) header information 

typedef struct GCFields {
  void *fp;
} GCFields;

#endif
