#ifndef __GC_IMPL_NONMOVING_H__
#define __GC_IMPL_NONMOVING_H__
//
// This file contains the implementation layer macros for the nonmoving
// mark sweep collector

//
// Internally used macros
//

/* REF: Macro for specifying reference types.
 *   Examples: Object *x is written REF(Object) x
 *             (Object *) x is written (REF(Object)) x;
 */
#define GC___REF(ref_type) ref_type *

/* PTR: Macro for accessing a reference.
 *   Example: x->y is written PTR(x)->y
 */
#define GC___PTR(ref) (ref)

/* address of pointer */
#define GC___ADDR_OF_PTR(ref) ref

/* macro hack
#define gc_update(a,c) do { \
        (void *)a = (void *)c; \
	gc_shade(a); \
} while(0)
*/


/* pointer (not reference) assignment with write barrier*/
#if 0
extern int gc_started;
#define GC___ASSIGN(target, source) \
	gc_update(&target,source); \
 	if(gc_started) gc_full_cycle();
#else
#define GC___ASSIGN(target, source) gc_update(&target,source); 
#endif

// gc (block) header information 

typedef struct GCFields {
  void *next;
} GCFields;

#endif
