#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

static int log_gc_running=0, log_gc_cycle=0;
static int log_panic_gc_done=0;
static int log_ncStatus=-1;
/*
static int log_curProcNbr, log_curProcLabel;
static int log_time=0;	//HACK
static int pl;
// static FILE *logfile=0;
static int log_labelCnt=0;
static int log_labels[20];
*/
extern unsigned int gc_cycle_olength;
extern unsigned int freed_last;
extern double allocrate;

#ifdef STORK_PPC
#include "Times.h"
#endif

typedef struct log_element {
#ifdef STORK_PPC
	Times_Time	t;
#else
	long		t;
#endif
	int		cycle;
	int		mem;
	int		panic;
	unsigned int	length;
	unsigned int	freed_last;
	double		allocrate;
} log_element;

#define LOG_SIZE 50000

static log_element log_log[LOG_SIZE];
static int log_index;
static int log_mem_count;

void log_init(void) 
{
	log_index = 0;
	log_mem_count = 0;
}

void log_print(void) 
{
	printf("** GC LOG (length=%d)**\n",log_index);
	int i;
	for(i=0; i<log_index; i++) {
		printf("GC_LOG:");
#ifdef STORK_PPC		
		LCS_PutTime(log_log[i].t);
#else
		printf("%ld", log_log[i].t);
#endif		
		printf(", %d, %d, %d, %d, %lf\n", log_log[i].cycle, log_log[i].mem, log_log[i].panic, log_log[i].length, log_log[i].allocrate);
	}
}	

#if 0
int log_findProcLabel(int n)
{
  int i;

  if(n==0) return 0;

  for(i=1; i <= log_labelCnt; i++){
    if(log_labels[i] == n)
      return i;
  }

  log_labels[++log_labelCnt] = n;
  return log_labelCnt;
}
#endif

void log_output()
{
#if 0
  if(!logfile) {
    logfile = fopen("ivm.log", "w");
  }
  if(ivm) {
    log_time = ivm->ticks;
    /*if(log_time >= ivm->ticks) 
      log_time++;
    else
      log_time = ivm->ticks;
    */
}  else {
    log_time=0;
  }
#ifdef LPMEM
  fprintf(logfile, "%d, %d, %d, %d, %d, %d, %d, %d, %d\n", log_time, log_curProcLabel, gc_freemem(), log_gc_running, log_gc_cycle, getHPreserved()-getLPalloced(), getLPalloced(), log_ncStatus, log_panic_gc_done);
#else
  fprintf(logfile, "%d, %d, %d, %d, %d, %d, %d, %d, %d\n", log_time, log_curProcLabel, gc_freemem(), log_gc_running, log_gc_cycle, 0, 0, log_ncStatus, log_panic_gc_done);
#endif
#else
if(log_mem_count == 0 && log_index <= LOG_SIZE ) {
#ifdef STORK_PPC
	log_log[log_index].t = Times_Now();
#else	
	log_log[log_index].t = currentTimeMillis();
#endif	
	log_log[log_index].cycle = log_gc_cycle;
	log_log[log_index].panic = log_panic_gc_done;
	log_log[log_index].mem = gc_freemem();
	log_log[log_index].length = gc_cycle_olength;
	//log_log[log_index].freed_last = freed_last;
	log_log[log_index].allocrate = allocrate;
	log_index++;
#endif
} 
}
void log_gc_inc_start()
{
#if 0  
  if(!log_gc_running) {
    log_gc_running=1;
    pl = log_curProcLabel;
    log_curProcLabel=-1;
    log_output(ivm);
  }
#endif  
}
void log_gc_inc_end()
{  
#if 0
  if(log_gc_running){
    log_gc_running=0;
    log_curProcLabel=pl;
    log_output();
  }
#endif  
}
void log_gc_cycle_start()
{ 
  log_gc_cycle = 1;
  log_mem_count = 0;
  log_output();
}
void log_gc_cycle_end()
{ 
  log_gc_cycle = 0;
  log_mem_count = 0;
  log_output();
}

/*
void log_context_switch()
{
  int old = log_curProcNbr;
  log_curProcNbr = (int) ivm->currentThread;
  if( log_curProcNbr != old){
    log_curProcLabel = log_findProcLabel(log_curProcNbr);
    log_output(ivm);
  }
}
*/

void log_nc_alloc(int i){
  // 0 = failed, 1 = succeeded, -1 = N/A
  log_ncStatus = i;
  log_output();
  log_ncStatus = -1;
}

void log_gc_panic()
{
  log_panic_gc_done=1;
  log_mem_count = 0;
  log_output();
  log_panic_gc_done=0;
}

void log_malloc()
{
  log_mem_count = (log_mem_count + 1) % 10;
  log_output();
}

