/*
  gc_timer.h
 * S. G. Robertz 20010124

 */

#ifndef __gc_timer_h
#define __gc_timer_h

/* #include "types.h"
*/

/* HERE BE DRAGONS!!!
   this will probably only work under unix, and really should be done in a
   portable way. */

#ifdef UNIX
#include <sys/time.h>

typedef struct timeval timeval ;
#endif

/* Routines to call when entering/exiting GC code */

void gc_timer_enter(void);
void gc_timer_exit(void);

/* Routines to call when starting/ending a GC cycle */

void gc_timer_cycle_start(void);
void gc_timer_cycle_end(void);

/* Get time estimates */


#ifdef UNIX
void gc_timer_cycle_time(timeval *tv);
void gc_timer_cycle_etime(timeval *tv);
#endif
long gc_timer_cycle_time_ms(void);
long gc_timer_cycle_etime_ms(void);

#endif
