/* gc_timer.c
 * 
 * S. G. Robertz 20021020
 */

#include "gc_timer.h"
#include "Times.h"

#include <stdio.h>


Times_Duration	etime_last_cycle, /* time on CPU */
		time_last_cycle, /* wall-clock time */ 
		elapsed_this_cycle;  /* accumulator for current cycle etime */
Times_Time	time_istart, time_iend, /* current increment start/stop times */
		time_cstart, time_cend; /* current cycle start/stop times */

/* Routines to call when entering/exiting GC code */

void gc_timer_enter(void)
{
	time_istart = Times_Now();
}
void gc_timer_exit(void)
{
	time_iend = Times_Now();
	elapsed_this_cycle = Times_AddDuration(elapsed_this_cycle, Times_Diff(time_iend, time_istart));
}

/* Routines to call when starting/ending a GC cycle */

void gc_timer_cycle_start(void)
{
	time_cstart = Times_Now();
	// HERE BE DRAGONS! direct access of the fields
	elapsed_this_cycle.high = elapsed_this_cycle.low = 0;
}
void gc_timer_cycle_end(void)
{
	//gettimeofday(&time_cend, NULL);
	time_cend = Times_Now();
	etime_last_cycle.low  = elapsed_this_cycle.low;
	etime_last_cycle.high = elapsed_this_cycle.high;
	time_last_cycle = Times_Diff(time_cend, time_cstart);
}

/* Get time estimates */
/*

void gc_timer_cycle_time(timeval *tv)
{
	tv->tv_sec = time_last_cycle.tv_sec;
	tv->tv_usec = time_last_cycle.tv_usec;
}

void gc_timer_cycle_etime(timeval *tv)
{
	tv->tv_sec = etime_last_cycle.tv_sec;
	tv->tv_usec = etime_last_cycle.tv_usec;
}
*/

/* Get times in *micro*seconds */

long gc_timer_cycle_time_ms(void)
{
	long result = Times_DurationToSeconds(time_last_cycle)*1000000;
	return result;
}

long gc_timer_cycle_etime_ms(void)
{
	long result = Times_DurationToSeconds(etime_last_cycle)*1000000;
	return result;
}
