#ifndef __gc_types_h
#define __gc_types_h

#define IVM_NULL 0
#define IVM_TRUE 1
#define IVM_FALSE 0

#define IVM_INLINE

typedef unsigned char      boolivm;  /* boolean - 1-bit ??? */
typedef signed char        int8   ;  /* byte  - signed 8-bits */
typedef unsigned char      uint8  ;  /*  IVM internal  */
typedef signed short       int16  ;  /* short - signed 16-bits */
//typedef unsigned short     uint16 ;  /* char  - unsigned 8-bits */
typedef signed int         int32  ;  /* int   - signed 32-bits */
typedef unsigned int       uint32 ;  /*  IVM internal  */
#ifdef BITS64
typedef signed long long   int64  ;  /* long  - signed 64-bits */
typedef unsigned long long uint64 ;  /* unsigned long - IVM internal */
#endif
#ifdef HAS_FLOAT
typedef float              float32;  /* float - floating point 32-bits */
#endif
#ifdef BITS64
typedef double             float64;  /* double - floating point 64-bits */
#endif

//#define ALIGN4(_value) (((_value + 3) >> 2) << 2)

/* Some compilers don't accept array size 0, and some warns when
 * hard coded array accesses exceed the size 1 as given below. If
 * so please set JVL_MIN_ARRAY_SIZE to some greater value.*/
#define JVL_MIN_ARRAY_SIZE 1


/* Internal structures */

#define ARRAYHEAD \
  OBJECTHEAD;             \
  uint16 nbrElements;     \
  uint16 objectSize;      \
  uint32 arraySize

struct LayoutHead;


/* The ArrayHead struct is only used when allocating new
   arrays. The other array structs are used to access array
   elements. This is due to compiler warnings about 
   zero length arrays. */
typedef struct ArrayHead {
  ARRAYHEAD;
} ArrayHead;

/*TODO: How is this utilised?*/
typedef struct Array {
  ARRAYHEAD;
  struct {uint32 bytes;} data[JVL_MIN_ARRAY_SIZE];
} Array;

typedef struct Uint8Array {
  ARRAYHEAD;
  struct {uint8 bytes;} data[JVL_MIN_ARRAY_SIZE];
} Uint8Array;

typedef struct MetaLayout {
  LAYOUTHEAD;
#ifdef ADD_PADDING
  uint16 dummy[1];
#endif
} MetaLayout;

//REF(LayoutHead) CreateLayout(unsigned int n, unsigned int v[], unsigned int s);
//void GC_INIT(void);
//void GC_DESTROY(void);


/* array macros */
#define GETARRAY(_arrayRef, _index) (GC___PTR(_arrayRef)->data[_index].bytes)
#define SETARRAY(_arrayRef, _index, _value) (GC___PTR(_arrayRef)->data[_index].bytes = _value)
/*#define SETREFARRAY(_arrayRef, _index, _value) (PTR(_arrayRef)->data[_index].bytes = _value);CHK(PTR(_arrayRef)->data[_index].bytes)*/


#endif
