/*
 * fmtio.c - Formatted IO also on targets without printf.
 */

#include <stdarg.h>
#include <stdio.h>
#include "fmtio.h"
#include "Debug.h"

#ifdef STORK_PPC
#define BUFLEN 4096

extern void Console_PutString(unsigned char s[], unsigned long maxlen);

int cprintf(const char *fmt, ...) {
  static int ans;
  char extra1[BUFLEN/2];
  static char buf[BUFLEN];
  char extra2[BUFLEN/2];
  static char* p;
  va_list arg;
  p = &buf[BUFLEN/2];
  va_start(arg, fmt);
  ans = vsprintf(p, fmt, arg);
  va_end(arg);
  Console_PutString(p, BUFLEN/2);
  if (ans > BUFLEN) ans = -ans; /* Already crasched (?), but anyway. */
  return ans;
}

#else
#define cprintf printf
#endif

/*EOF*/
