/* Socket.java -- Client socket i
 * Minimal implementation for LJRT lib
*/

package java.net;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;


public class Socket
{
  /**
   * True if the socket is bound.
   */
  private boolean bound;
  private long myfd;


  void setFd(long fd){
	  myfd = fd;
  }
  
  private native static long createSocket();

  public Socket()
  {
	  myfd = createSocket();
//	  System.out.println("Socket():"+myfd);
  }

  public Socket(String host, int port)
    throws UnknownHostException, IOException
  {
//    this(InetAddress.getByName(host), port, null, 0, true);
  }


  public native static int connect(long fd, long adr, int port, int timeout) throws IOException;

  public void connect(SocketAddress endpoint) throws IOException
  {
    connect(endpoint, 0);
  }

  public void connect(SocketAddress endpoint, int timeout)
    throws IOException
  {
    try
      {
//	getImpl().connect(endpoint, timeout);
	byte a[] = ((InetSocketAddress)endpoint).getAddress().getAddress();
	int port = ((InetSocketAddress)endpoint).getPort();
	System.out.println("connect to:"+a[0]+"."+a[1]+"."+a[2]+"."+a[3]);
	long adr = (((long)a[0]) << 24) |
		(((long)a[1]) << 16) |
		(((long)a[2]) << 8) |
		(long)a[3];


	System.out.println("Socket.connect():"+myfd+" adr = "+adr+" port = "+port);
	connect(myfd, adr, port, timeout);
      }
    catch (IOException exception)
      {
	close();
	throw exception;
      }
    catch (RuntimeException exception)
      {
	close();
	throw exception;
      }
    catch (Error error)
      {
	close();
	throw error;
      }
  }

  /**
   * Returns an InputStream for reading from this socket.
   *
   * @return The InputStream object
   *
   * @exception IOException If an error occurs or Socket is not connected
   */
  public InputStream getInputStream() throws IOException
  {
//    if (isClosed())
//      throw new SocketException("socket is closed");

//    if (! isConnected())
//      throw new IOException("not connected");
    if(myfd != 0) {
	    return new java.io.SimpleTCPInputStream(myfd);
    } else {
	    System.out.println("not connected");
	    return null;
    }
//    return getImpl().getInputStream();
  }

  /**
   * Returns an OutputStream for writing to this socket.
   *
   * @return The OutputStream object
   *
   * @exception IOException If an error occurs or Socket is not connected
   */
  public OutputStream getOutputStream() throws IOException
  {
//    if (isClosed())
//      throw new SocketException("socket is closed");

//    if (! isConnected())
//      throw new IOException("not connected");

    return new java.io.SimpleTCPOutputStream(myfd);
//    return getImpl().getOutputStream();
  }

  public void close(){
	  close(myfd);
	  myfd = 0;
  }
  public native void close(long fd);

  public String toString()
  {
//    try
//      {
//	if (isConnected())
//	  return ("Socket[addr=" + getImpl().getInetAddress() + ",port="
//	         + getImpl().getPort() + ",localport="
//	         + getImpl().getLocalPort() + "]");
//      }
//    catch (SocketException e)
//      {
	// This cannot happen as we are connected.
//      }

//    return "Socket[unconnected]";
    return "Socket[toString not completely implemented]";
  }

    public boolean isConnected() {
	return myfd!=0;
    }


}
