/* $Id: SemInterrupted.java,v 1.3 2005/08/15 13:24:45 d02en Exp $          
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime.semaphore;

import se.lth.cs.realtime.RTError;

/**
 * Unchecked exception in form of an <code>Error</code>, to be thrown
 * instead of <code>InterruptedException</code>. This is basically the
 * same as the <code>RTInterrupted</code> class but part of the
 * <code>semaphore</code> package, thereby supporting import/loading of
 * only that package when the target system only provides semaphores
 * for synchronization.
 *
 * @see License
 * @see se.lth.cs.realtime.RTError 
 */

public class SemInterrupted extends RTError {
    public SemInterrupted(String error) { super(error); }
}
