/* $Id: SemViolation.java,v 1.3 2005/08/15 13:24:44 d02en Exp $          
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime.semaphore;

import se.lth.cs.realtime.RTError;

/**
 * Unchecked exception in form of an <code>Error</code>, to be thrown when
 * semaphore methods are misused. At the moment of writing, the only
 * case is when trying to unlock a mutex semaphore without first
 * having acquired it.
 *
 * @see License
 * @see se.lth.cs.realtime.RTError; 
 * @see java.lang.Error; 
 */

public final class SemViolation extends RTError {
    public SemViolation(String error) { super(error); }
}
