/* Automatically defines __RTAI__ if it is not defined and
	__HARD_RTAI__ is defined */
#ifdef __RTAI_HARD__
	#ifndef __RTAI__
	#define __RTAI__
	#endif
#endif

#ifndef __RTAI__
/* Thread creation */
#define pthread_create_rt 						pthread_create
#define pthread_attr_init_rt 					pthread_attr_init
#define pthread_attr_destroy_rt 				pthread_attr_destroy
#define pthread_attr_setattr_rt 				pthread_attr_setattr
#define pthread_attr_getattr_rt 				pthread_attr_getattr
#define pthread_attr_getdetachstate_rt   	pthread_attr_getdetachstate
#define pthread_attr_setschedpolicy_rt   	pthread_attr_setschedpolicy
#define pthread_attr_getschedpolicy_rt   	pthread_attr_getschedpolicy
#define pthread_attr_setschedparam_rt    	pthread_attr_setschedparam
#define pthread_attr_getschedparam_rt    	pthread_attr_getschedparam
#define pthread_attr_setinheritsched_rt  	pthread_attr_setinheritsched
#define pthread_attr_getinheritsched_rt  	pthread_attr_getinheritsched
#define pthread_attr_setscope_rt         	pthread_attr_setscope
#define pthread_attr_getscope_rt         	pthread_attr_getscope
#define pthread_attr_setguardsize_rt     	pthread_attr_setguardsize
#define pthread_attr_getguardsize_rt     	pthread_attr_getguardsize
#define pthread_attr_setstackaddr_rt     	pthread_attr_setstackaddr
#define pthread_attr_getstackaddr_rt     	pthread_attr_getstackaddr
#define pthread_attr_setstack_rt         	pthread_attr_setstack
#define pthread_attr_getstack_rt         	pthread_attr_getstack
#define pthread_attr_setstacksize_rt     	pthread_attr_setstacksize
#define pthread_attr_getstacksize_rt     	pthread_attr_getstacksize
#define pthread_attr_setdetachstate_rt(attr, detachstate) pthread_attr_setdetachstate(attr, detachstate)
/* Thread cancellation */
#define pthread_cancel_rt 				pthread_cancel
#define pthread_setcanceltype_rt 	pthread_setcanceltype
#define pthread_setcancelstate_rt 	pthread_setcancelstate

/* Mutex handling */
#define pthread_mutex_init_rt     	pthread_mutex_init
#define pthread_mutex_lock_rt 		pthread_mutex_lock  		
#define pthread_mutex_trylock_rt 	pthread_mutex_trylock 		
#define pthread_mutex_timedlock_rt	pthread_mutex_timedlock 
#define pthread_mutex_unlock_rt 	pthread_mutex_unlock
#define pthread_mutex_destroy_rt 	pthread_mutex_destroy
#define pthread_mutexattr_init_rt(arg) 	pthread_mutexattr_init(arg)
#define pthread_mutexattr_destroy_rt(arg)	pthread_mutexattr_destroy(arg)
#define pthread_mutexattr_getpshared_rt(attr, pshared) pthread_mutexattr_getpshared(attr, pshared)
#define pthread_mutexattr_setpshared_rt(attr, pshared) pthread_mutexattr_setpshared(attr, pshared)
#define pthread_mutexattr_settype_rt(attr, kind) pthread_mutexattr_settype(attr, kind)
#define pthread_mutexattr_gettype_rt(attr, kind) pthread_mutexattr_gettype(attr, kind)
/* Condition variables */
#define pthread_cond_init_rt      pthread_cond_init
#define pthread_cond_destroy_rt   pthread_cond_destroy
#define pthread_cond_wait_rt      pthread_cond_wait
#define pthread_cond_signal_rt    pthread_cond_signal
#define pthread_cond_broadcast_rt pthread_cond_broadcast
#define pthread_cond_timedwait_rt pthread_cond_timedwait
#define pthread_condattr_init_rt(attr) 	pthread_condattr_init(attr)
#define pthread_condattr_destroy_rt(attr)  pthread_condattr_destroy(attr)
#define pthread_condattr_getpshared_rt(attr, pshared) pthread_condattr_getpshared(attr, pshared)
#define pthread_condattr_setpshared_rt(attr, pshared) pthread_condattr_setpshared(attr, pshared)
/* Barriers */
#define pthread_barrier_wait_rt 									pthread_barrier_wait
#define pthread_barrierattr_getpshared_rt(attr, pshared) pthread_barrierattr_getpshared(attr, pshared)
#define pthread_barrierattr_setpshared_rt(attr, pshared) pthread_barrierattr_setpshared(attr, pshared)
#define pthread_barrierattr_getpshared_rt(attr, pshared) pthread_barrierattr_getpshared(attr, pshared)
#define pthread_barrierattr_setpshared_rt(attr, pshared) pthread_barrierattr_setpshared(attr, pshared)
/* Miscellaneous */
#define pthread_join_rt 				pthread_join
#define pthread_setschedparam_rt 	pthread_setschedparam
#define pthread_getschedparam_rt 	pthread_getschedparam
#define pthread_self_rt             pthread_self
#define pthread_equal_rt            pthread_equal
#define pthread_detach_rt(thread) 	pthread_detach(thread)
#define sched_yield_rt					pthread_yield
#define pthread_exit_rt					pthread_exit

#define pthread_getconcurrency_rt() pthread_getconcurrency()

#define pthread_setconcurrency_rt(level) pthread_setconcurrency(level)

/* Register / Un-register tasks */
#define RTAI_REGISTER_THREAD 
#define RTAI_UNREGISTER_THREAD 	
#define START_RTAI_CLOCK 
#define STOP_RTAI_CLOCK  


#define pthread_cleanup_push_rt pthread_cleanup_push
#define pthread_cleanup_pop_rt  pthread_cleanup_pop

/*
#define pthread_cleanup_push(routine, arg) \
do { \
	{\
		int __hs_hs_hs__; \
		__hs_hs_hs__ = MAKE_SOFT(); \
		{ struct _pthread_cleanup_buffer _buffer; _pthread_cleanup_push (&_buffer, (routine), (arg)); \
		MAKE_HARD(__hs_hs_hs__);
	
#define pthread_cleanup_pop(execute) \
		__hs_hs_hs__ = MAKE_SOFT(); \
		_pthread_cleanup_pop (&_buffer, (0)); };\
		MAKE_HARD(__hs_hs_hs__); \
	} \
} while (0)
*/	
/*__RTAI__ has not been defined*/

#else
#define RTAI_REGISTER_THREAD(pr) 	\
	RT_TASK* task; \
	mlockall(MCL_CURRENT | MCL_FUTURE);\
	if (!(task = rt_task_init_schmod(rt_get_name(0),pr,0,0,SCHED_FIFO,0xFF))) {\
		printf("ERROR rt_task_init <RTAI module>\n"); \
	}
	
#define RTAI_UNREGISTER_THREAD rt_task_delete(task);	

#define START_RTAI_CLOCK  rt_set_oneshot_mode();\
								  start_rt_timer(0);
								  	
#define STOP_RTAI_CLOCK   stop_rt_timer();
#endif

#ifdef __RTAI_HARD__
#define WANT_IT_HARD rt_make_hard_real_time();
#define WANT_IT_SOFT rt_make_soft_real_time();
#define nanosleep(arg,cte)   rt_sleep(timespec2count(arg))

#else
#define WANT_IT_HARD 
#define WANT_IT_SOFT 
#endif
