#ifndef JAVATYPES_H
#define JAVATYPES_H

#include <gc.h>
#include <gc_types.h>

extern struct java_lang_Object;
extern struct java_lang_String;
extern struct java_lang_Thread;

GC__IMPL_REF(java_lang_Object, nullRef);


#ifndef JAVA_NULL
#define JAVA_NULL nullRef
#endif

#ifndef true
#define true 1
#endif

#ifndef false
#define false 0
#endif

#ifndef JBoolean
#define JBoolean short
#endif

#ifndef JInt
#ifdef HOST_AVR
#define JInt long // To get 32 bit ints on the AVR
#else
#define JInt int
#endif
#endif

#ifndef JLong
#ifndef HOST_AVR
#define JLong long long
#else // HOST_AVR
#define JLong long
#endif
#endif


#ifndef JFloat
#define JFloat float
#endif

#ifndef JDouble
#define JDouble double
#endif

#ifndef JByte
#define JByte signed char
#endif

#ifndef JChar
#define JChar char
#endif

#ifndef JShort
#define JShort short
#endif


//extern GC__IMPL_REF(LayoutHead, VAL_ARRAY_LAYOUT);
//extern GC__IMPL_REF(LayoutHead, REF_ARRAY_LAYOUT);

typedef struct RefArray {
  ARRAYHEAD;
  volatile JInt _RefA_length;
  volatile struct {void* bytes;} data[1];
} RefArray;

typedef struct JIntArray {
  ARRAYHEAD;
  volatile JInt _JIntA_length;
  volatile struct {JInt bytes;} data[1];
} JIntArray;

typedef struct JBooleanArray {
  ARRAYHEAD;
  volatile JInt _JBooleanA_length;
  volatile struct {JBoolean bytes;} data[1];
} JBooleanArray;

typedef struct JLongArray {
  ARRAYHEAD;
  volatile JInt _JLongA_length;
  volatile struct {JLong bytes;} data[1];
} JLongArray;

typedef struct JFloatArray {
  ARRAYHEAD;
  volatile JInt _JFloatA_length;
  volatile struct {JFloat bytes;} data[1];
} JFloatArray;

typedef struct JDoubleArray {
  ARRAYHEAD;
  volatile JInt _JDoubleA_length;
  volatile struct {JDouble bytes;} data[1];
} JDoubleArray;

typedef struct JCharArray {
  ARRAYHEAD;
  volatile JInt _JCharA_length;
  volatile struct {JChar bytes;} data[1];
} JCharArray;

typedef struct JByteArray {
  ARRAYHEAD;
  volatile JInt _JByteA_length;
  volatile struct {JByte bytes;} data[1];
} JByteArray;

typedef struct JShortArray {
  ARRAYHEAD;
  volatile JInt _JShortA_length;
  volatile struct {JShort bytes;} data[1];
} JShortArray;


GC_REF_FUNC_PROTO(JCharArray,newJCharArray,int size);
GC_REF_FUNC_PROTO(JBooleanArray,newJBooleanArray,int size);
GC_REF_FUNC_PROTO(JIntArray,newJIntArray,int size);
GC_REF_FUNC_PROTO(JLongArray,newJLongArray,int size);
GC_REF_FUNC_PROTO(JFloatArray,newJFloatArray,int size);
GC_REF_FUNC_PROTO(JDoubleArray,newJDoubleArray,int size);
GC_REF_FUNC_PROTO(JByteArray,newJByteArray,int size);
GC_REF_FUNC_PROTO(JShortArray,newJShortArray,int size);
GC_REF_FUNC_PROTO(RefArray,newRefArray,int size);

GC_REF_FUNC_PROTO(struct java_lang_String,java_lang_String_String_CCharArray, void* class, GC_PARAM(LayoutHead,layout),char* value);
GC_REF_FUNC_PROTO(struct java_lang_Thread,java_lang_Thread_Thread, void* class, GC_PARAM(LayoutHead,layout));


#endif
