package LabComm.Serial;
import se.lth.cs.realtime.RTThread;



/**
 * This thread writes the received byte array in a PipedOutputStream. 
 * The information is written in blocks of 1024bytes, except for the last block that has the bytes left.
 * 
 * @author Juan Periset, Ferran Carlas
 * .
*/
public class WriteThreadS extends RTThread{
	byte[] bout=new byte[UtilsSerial.BUFFERSIZE]; 
	UtilsSerial u;

public WriteThreadS(byte[] b,UtilsSerial ut){
	bout=b;
	u=ut;
}
public void run(){
		int offset=0;
		int count=0;
		//it is interrupted by the receiver thread when this finishes externalize method.
		while(!isInterrupted()){
			if(offset<bout.length){
					if((bout.length-offset)>=UtilsSerial.PIPESIZE){
						count=u.writePout(bout,offset,UtilsSerial.PIPESIZE);
						offset+=count;
					}
					else if((bout.length-offset)<UtilsSerial.PIPESIZE){
						u.writePout(bout,offset,bout.length-offset);
						offset=bout.length;
					}
				}
		}	
		
			
			
		System.out.println("END WRITET");
	}

}