package RTComm;


import java.io.*;

import LabComm.*;
import LabComm.External.UtilsExternal;
import DataStructure.*;


/**
 * The <code>RTSocket</code> class implements a socket used 
 * to send objects through ThrottleNet, fulfilling temporal restrictions.
 * 
 * @author  Juan Periset & Ferran Carlas
 * @version 
 * @see ThrottleNetSocket
 */
abstract class RTSocket extends Socket{	
	
	/**
	 * The utility needed for converting externalized objects to
	 * arrays of bytes and vice versa.
	 */
	protected UtilsExternal utilsE;
	
	/**
	 * The amount of data to be sent in bytes. Calculated from the largest object that can 
	 * be sent fulfilling real time restrictions.
	 * 
	 */
	protected int size;
	
		
	
	/**
	 * Constructs a RTsocket.
	 * 
	 * @param   name      the name of the connection.
	 * @param   objsize   the larget object (LabObject) that can be sent fulfilling temporal restrictions.
	 * @param   period_us the time between two packets in microseconds.
	 * 
	 * 
	 */
	public RTSocket(String name, LabObject objsize,int period_us)
											throws IOException {
		super(name,period_us);
		utilsE = new UtilsExternal();
		this.size=utilsS.getObjectSize(objsize);
		
	}
	
	
}	
