package java.io;

public class SimpleTCPInputStream extends InputStream
{
  private static final native int readByte(int sockfd); 
  private static final native int read(int sockfd, byte[] data, int offset, int length); 
  
  private int myfd;
  
  public SimpleTCPInputStream()
  {
  }

  public SimpleTCPInputStream(int fd)
  {
	  myfd = fd;
  }

  public int available() throws IOException
  {
    return 0;
  }

  public void close() throws IOException
  {
    // Do nothing
  }

  public void mark(int readLimit)
  {
    // Do nothing
  }

  public boolean markSupported()
  {
    return false;
  }

  public int read() throws IOException {
	  return readByte(myfd);
  }

  public int read(byte[] b) throws IOException {
	return read(b, 0, b.length);
  }

  public int read(byte[] b, int off, int len) throws IOException {
	if (off < 0 || len < 0 || off + len > b.length)
		throw new IndexOutOfBoundsException();
	if (b.length == 0)
		return 0;
	int res = read(myfd, b, off, len);
	return res;
  }
//  public int read(byte[] b, int off, int len) throws IOException
//  {
//    if (off < 0 || len < 0 || off + len > b.length)
//      throw new IndexOutOfBoundsException();
//    if (b.length == 0)
//      return 0;
//
//    int i, ch;
//
//    for (i = 0; i < len; ++i)
//      try
//	{
//	  if ((ch = read()) < 0)
//	    return i == 0 ? -1 : i;		// EOF
//	  b[off + i] = (byte) ch;
//	}
//      catch (IOException ex)
//	{
//	  // Only reading the first byte should cause an IOException.
//	  if (i == 0)
//	    throw ex;
//	  return i;
//	}
//
//    return i;
//  }

}
