
/**
 * AbstractAxis.java
 *
 *
 * Created: 1998-11-14
 * LastEditDate: 2000-08-23
 *
 * @author Leif Andersson
 * @version
 */
package se.lth.control.plot;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public abstract class AbstractAxis implements Axis  {
  protected String label = null;
  protected List points = new ArrayList(20);
  protected List grid = new ArrayList(20);

  public abstract double getMin();   
   
  public abstract double getMax(); 

  public int getGridSize() {
    if (grid != null) { return grid.size(); }
    else { return 0; }
  }

  public double getGridPoint(int i) {
    return ((Double)grid.get(i)).doubleValue();
  }

  public int getAxisSize() {
    if (points != null) { return points.size(); }
    else { return 0; }
  }

  public AxisPoint getAxisPoint(int i) {
    return (AxisPoint)points.get(i);
  }

  public String getLabel() { return label; }

  public String toString() {
    StringBuffer sb = new StringBuffer(200);
    sb.append("[ ");
    for (int i = 0; i < points.size(); i++) {
      sb.append((points.get(i)).toString());
      sb.append("  ");
    }
    if (grid == null) {
      sb.append("null");
    } else {
      for (int i = 0; i < grid.size(); i++) {
	sb.append((grid.get(i)).toString());
	sb.append("  ");
      }
    }
    sb.append("]");
    return sb.toString();
  }
    
    
} // AbstractAxis
