/**
 * ConditionVariable.java
 *
 * Created: 2000-09-12
 * LastEditDate: 2000-09-12
 *
 * @author 
 * @version
 */
package se.lth.control.realtime;

public class ConditionVariable {

    private Semaphore mutex;

    /**
       Creates a condition variable associated with the semaphore <TT>sem</TT>
     */
    public ConditionVariable(Semaphore sem) {
	mutex = sem;
    }

    /**
       Waits for the condition to occur
     */
    public void cvWait() {
	synchronized (this) {
	    mutex.give();
	    try {
		wait();
	    } catch (InterruptedException e) {}
        }
	mutex.take();
    }

    /**
       Notifies one thread that the condition has occured
     */
    public synchronized void cvNotify() {
	notify();
    }

    /**
       Notifies all threads that the condition has occured
     */
    public synchronized void cvNotifyAll() {
	notifyAll();
    }
}


    
	    
