/**
 * Semaphore.java
 *
 * Created: 2000-09-11
 * LastEditDate: 2000-09-11
 *
 * @author 
 * @version
 */
package se.lth.control.realtime;

public final class Semaphore {

    private int count = 0;

    /**
       Creates a counting semaphore with the inital value 0
    */
    public Semaphore() {}

    /**
       Creates a counting semaphore with the inital value <TT>init</TT>
    */
    public Semaphore(int init) {
        count = init;
    }

    /**
       Waits for the semaphore
    */
    public synchronized void take() { 
	while (count < 1) {
	    try {
		wait();
	    } catch (InterruptedException e) {}
	}
	--count;
    }

    /**
       Signals the semaphore
    */
    public synchronized void give() { 
	++count;
	notify();
    }
}
