/*
 * Created on 16/03/2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package se.lth.control.xml;


import java.io.StringReader;
import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author andersb
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class BeanFactoryTest extends TestCase {
	
	public static class Simple implements Bean {
		
		private String name;
		private String prop;
		private Vector child = new Vector();
		private StringBuffer text = new StringBuffer();
		
		public void setName(String value) {
			name = value;	
		}
		
		public String getName() {
			return name;
		}
		
		public void setProp(String value) {
			prop = value;	
		}
		
		public String getProp() {
			return prop;
		}
		
		public void addChild(Simple c) {
			child.add(c);
		}
		
		public Simple[] getChild() {
			return (Simple[])child.toArray(new Simple[0]);
		}
		
		public String toString() {
			return "Simple '" + name + "'"; 
		}
		
		public void appendText(Text t) {
			text.append(t.toString());
		}
		
		public Text getText() {
			return new Text(text.toString());
		}
		
	}
	
	public void testOne() throws Exception {
		Simple b = new Simple();
		BeanDescriptor d = BeanFactory.getDescriptor(b);
		d.getAttribute("name").setValue(b, "testName");
		assertEquals("testName", b.getName());
		try {
			BeanFactory.getDescriptor(b).getAttribute("error").setValue(b, "10");
			fail("unknown attribute could be set");
		} catch (Exception e) {
		}
		d.getChild("child").addChild(b, b);
		d.getChild("child").addChild(b, b);
		Bean children[] = d.getChild("child").getChildren(b);
		assertTrue(children.length == 2);
	}
	
	public void testParse() throws Exception {
		Simple b = (Simple)BeanFactory.parse(Simple.class, 
					new StringReader("<simple name='parent'><child name='child'><child prop='prop'/>text</child></simple>"));
		System.out.println(b + " " + b.getChild()[0]);
		BeanFactory.unparse(b, "root", System.out);
	}
}
