package se.lth.cs.camera;

import java.net.*;
import java.io.*;

/**
 *
 * Motion detector.
 *
 * @author Emma Nilsson-Nyman (emma.nyman@cs.lth.se)
 *
 */
public class MotionDetector {

    private int threshold;
    private int level;


/*
    private void updateValues() {
      try {
        Socket socket = new Socket();
	InetSocketAddress address = new InetSocketAddress(InetAddress.getLocalHost(), 80);
	socket.connect(address);
	DataOutputStream dOut = new DataOutputStream(socket.getOutputStream());
	DataInputStream dIn = new DataInputStream(socket.getInputStream());

	dOut.writeBytes("GET /axis-cgi/motion/motiondata.cgi HTTP/1.0\r\n");
	dOut.writeBytes("Authorization: Basic cnQ6c2lnZ2U\r\n\n");

        byte[] data = new byte[155];
	int readBytes = 0;
	while (readBytes < data.length) {
	  readBytes += dIn.read(data, readBytes, data.length-readBytes);
	}

	int firstNbrPos = 132;
	int firstNbrLength = 1;
	if (data[firstNbrPos + 2] == ';') {
	  firstNbrLength = 2;
	} else if (data[firstNbrPos + 3] == ';') {
	  firstNbrLength = 3;
	}
	String str1 = new String(data, firstNbrPos, firstNbrLength);
	System.out.println("Level: " + str1);
	
	int level = 0;
	try {
	  level = Integer.parseInt(str1);
	} catch (NumberFormatException e) {}
	
	int secondNbrPos = firstNbrPos + firstNbrLength + 11;
	int secondNbrLength = 2;
	if (data[secondNbrPos + 1] == ';') {
	  secondNbrLength = 1;
	} else if (data[secondNbrPos + 3] == ';') {
	  secondNbrLength = 3;
	}
	String str2 = new String(data, secondNbrPos, secondNbrLength);
	
	int threshold = 15;
	try {
	  threshold = Integer.parseInt(str2);
	} catch (NumberFormatException e) {}
	System.out.println("Threshold: " + threshold);
	
	socket.close();

      } catch (IOException e) {
        System.out.println(e.getMessage());
      }
    }
*/

    private native static int nativeConnect();
    private native static int nativeLevelUpdate(int fd);
    private native static void nativeClose(int fd);
    
    public MotionDetector() {
      threshold = 10;
      level = 0;
    }


    private void updateLevel() {
	int fd = nativeConnect();
	int newValue = nativeLevelUpdate(fd);
	if (newValue >= 0) {
	    level = newValue;
	}
	nativeClose(fd);
    }

    public int getLevel() {
      updateLevel();
      return level;
    }

    public int getThreshold() {
      return threshold;
    }

    public boolean detect() {
      updateLevel();
      return level > threshold;
    }
}
