/* $Id: RTEventBufferInput.java,v 1.3 2005/09/12 10:03:09 d02en Exp $         
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime.event;

/**
 * Methods for event buffer input. For documentation of the methods, refer 
 * to the class <code>RTEventBuffer</code>. When only the input side of such 
 * a buffer is to be provided for some event source, or as a resource in a 
 * monitor, a reference to an <code>RTEventBufferInput</code> object is 
 * better to use to prevent calling the output methods of the buffer (by 
 * accident). Note, however, in the case of buffer input from within a 
 * monitor: when the buffer object also comprises a monitor, do not use 
 * the <code>doPost</code> methods which are blocking (on buffer full) 
 * which will lock also the outer monitor (if not using the lock of the 
 * buffer for its mutual exclusion, which is not recommended).
 *
 * @see se.lth.cs.realtime.License
 * @see se.lth.cs.realtime.event.RTEventBuffer
 */

public interface RTEventBufferInput {
  RTEvent post(RTEvent e);
  void doPost(RTEvent e);
  RTEvent tryPost(RTEvent e);
  RTEvent tryPost(RTEvent e, long timeout);
}
