/* $Id: RTEventBufferOutput.java,v 1.3 2005/09/12 10:03:09 d02en Exp $         
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime.event;

/**
 * Methods for event buffer output. For documentation of the methods, refer 
 * to the class <code>RTEventBuffer</code>. When only the output side of such 
 * a buffer is to be provided for some event source, or as a resource in a 
 * monitor, a reference to an <code>RTEventBufferOutput</code> object is 
 * better to use to prevent calling the input methods of the buffer (by 
 * accident). Note, however, in the case of buffer output from within a 
 * monitor: when the buffer object also comprises a monitor, do not use 
 * the <code>doFetch</code> methods which are blocking (on buffer empty) 
 * which will lock also the outer monitor (if not using the lock of the 
 * buffer for its mutual exclusion, which is not recommended).
 *
 * @see se.lth.cs.realtime.License
 * @see se.lth.cs.realtime.event.RTEventBuffer
 */

public interface RTEventBufferOutput {
  RTEvent fetch();
  RTEvent doFetch();
  RTEvent tryFetch();
  RTEvent tryFetch(long timeout);
}
