/* $Id: RunnableEvent.java,v 1.4 2005/08/19 09:37:16 d02en Exp $         
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime.event;

import se.lth.cs.realtime.Timebase;

/**
 * Event providing code to be executed by the event receiver, by calling run.
 * 
 * @see License
 */

public abstract class RunnableEvent extends RTEvent implements Runnable {

  /**
   */
  public RunnableEvent() {
    super();
  }

  /**
   * @param source 
   */
  public RunnableEvent(Object source) {
    super(source);
  }

  /**
   * @param ts
   */
  public RunnableEvent(long ts) {
    super(ts);
  }

  /**
   * @param source
   * @param ts
   */
  public RunnableEvent(Object source, long ts) {
    super(source, ts);
  }

  /**
   * @param source
   * @param ts
   * @param timebase
   */
  public RunnableEvent(Object source, long ts, Timebase timebase) {
    super(source, ts, timebase);
  }

  abstract public void run();
}
