/*
 *	ScheduleEvent.java
 */

package se.lth.cs.realtime.event;

import se.lth.cs.realtime.Activity;

/**
 * An <code>ActivityEvent</code> that informs about parameter changes that
 * effect sceduling. Examples are change of priority and change of period.
 *
 * Instances of this event can either be passed to threads
 *
 * @author Klas.Nilsson@cs.lth.se
 * @version 0.02, 1999-09-09
 */
public class ScheduleEvent extends ActivityEvent {

    /**
     * Constructs a <code>SceduleEvent</code> object with the specified
     * source thread and identifier.
     *
     * @param source the thread where the event originated.
     */
    public ScheduleEvent( Activity source ) {
	super(source);
    }

}
