package se.lth.cs.robot.irb6;

public class IO {

    private int bitoutval;
    private int hival;
    private int loval;

    public IO() {
	bitoutval=0;
	hival=0;
	loval=0;
    }

    public static native void nativeInit();
    public static native void nativeCleanup();
    private static native int nativeFuncAnalogOut(int port, int gain);
    private static native int nativeFuncAnalogIn(int port);
    private static native int nativeFuncDigitalIn();
    private static native int nativeFuncBitIn();
    private static native int nativeFuncBitOut(int value);

    public static int analogOut(int port, int gain) {
	nativeFuncAnalogOut(port, gain);
	return 0;
    }

    public static int analogIn(int port) {
	return nativeFuncAnalogIn(port);
    }

    public int outVal()
    {
	return bitoutval;
    }

    public int loBitOut(int value) {
	loval=value&0x1f;
	bitoutval = hival|loval;
	nativeFuncBitOut(bitoutval);
	return 0;
    }

    public int hiBitOut(int value) {
	hival=value&0xe0;
	bitoutval = hival|loval;
	nativeFuncBitOut(bitoutval);
	return 0;
    }

    public int bitOut(int value) {
	bitoutval=value;
	nativeFuncBitOut(value);
	return 0;
    }

    public static int bitIn() {
	return nativeFuncBitIn();
    }

    public static int digitalIn() {
	return nativeFuncDigitalIn();
    }
}
