package se.lth.cs.robot.servo;

/**
 * Multiple-Input Multiple-Output algorithm.
 *
 */
public interface AlgorithmMIMO extends Algorithm {
    /**
     * Calculate output value of the algorithm.
     * 
     * @param y
     *            the measured values
     * @param r
     *            the setpoint(s)
     * @return the desired control signals
     */
    Sample[] compute(Sample[] y, Sample[] r);

    /**
     * Update state.
     * 
     * @param u
     *            the effective algorithm output, after succeeding saturation
     *            and the like.
     */
    void update(Sample[] u);

}
