package se.lth.cs.robot.servo;

/**
 * Single-Input Single-Output algorithm.
 *
 */
public interface AlgorithmSISO extends Algorithm {
    /**
     * Calculate output value of the algorithm.
     * 
     * @param y
     *            the measured value
     * @param r
     *            the setpoint
     * @return the desired control signal
     */
    Sample compute(Sample y, Sample r);

    /**
     * Update state.
     * 
     * @param u
     *            the effective algorithm output, after succeeding saturation
     *            and the like.
     */
    void update(Sample u);

}
