package se.lth.cs.robot.servo;

public interface ClassicPID_Enum {
	
	int K_ = 0;

	int Ti_ = 1;

	int Tr_ = 2;

	int Td_ = 3;

	int N_ = 4;

	int beta_ = 5;

	int h_ = 6;
	
	int I_on_ = 7;
	
	int ad_ = 8;
	
	int bd_ = 9;

	int PARAM_DIM = 10; 	// Number of array elements

	String[] paramName = {  // Naming of all tunable parameters:
			"K", 			// P-gain
			"Ti", 			// I-time
			"Tr",			// Tracking time constant
			"Td",			// D-time
			"N",			// Peak HF gain
			"beta",			// Setpoint to P factor
			"h",			// Sampling period
			"I_on"			// I-on
	};						// PAR_DIM-lable.length pars internally computed.

    //-----------------------------------------------------------------------
    
    int I_ = 0;
    
    int D_ = 1;
    
    int yold_ = 2;
    
    int STATE_DIM = 3;      // Dimension of state vector
    
    String[] stateName = {  // Naming of all visible states:
            "I",            // Integral part
            "D"             // Derivative part
    };
}
