/*
 * $Id: Sample.java,v 1.6 2005/09/15 12:13:37 sven Exp $
 */
package se.lth.cs.robot.servo;

import se.lth.cs.realtime.RTError;
import se.lth.cs.realtime.event.RTEvent;
import java.io.*;

/**
 * Definition of control signal data, as exposed data for connecting control blocks.
 */
public class Sample extends RTEvent implements Serializable, Cloneable {
	public float siso;
    	public float[] mimo;
	public long deadline;
	public short importance = -1;
	public short derived;
	public float siso1Dot;
	public float siso2Dot;
	public float siso3Dot;
	public float[] mimo1Dot;
	public float[] mimo2Dot;
	public float[] mimo3Dot;
	public boolean forward;
	public boolean backward;
	public boolean saturated;
	public boolean minimum;
	public boolean maximum;
	public String[] name;
	public transient Throwable fault;
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException err)  {
			throw new RTError(err);
		}
	}
	private static final long serialVersionUID = 1L; //fix

	public void setTimestamp(long ts) {
		timestamp = ts;
	}

	//void setSource(Object s) {
	//	source = s;
	//}
	
	public Sample() {
		super();
	}

	public Sample(long ts) {
		super(null, ts);
	}

	public Sample(Object source, long ts) {
		super(source, ts);
	}

	/*/ Copy the values of this into s
	 */
	void copy(Sample s) {
		s.siso=siso;
		s.mimo=mimo;
		s.deadline=deadline;
		s.importance = importance;
		s.derived = derived;
		s.siso1Dot = siso1Dot;
		s.siso2Dot = siso2Dot;
		s.siso3Dot = siso3Dot;
		s.mimo1Dot = mimo1Dot;
		s.mimo2Dot = mimo2Dot;
		s.mimo3Dot = mimo3Dot;
		s.forward = forward;
		s.backward = backward;
		s.saturated = saturated;
		s.minimum = minimum;
		s.maximum = maximum;
		s.name = name;
	}
}
