package se.lth.cs.throttlenet.event;


/**
 * An abstract adapter class for receiving throttlenet events. The methods in
 * this class are empty. This class exists as convenience for creating listener
 * objects.
 *
 * @author  Patricia Grudziecka
 * @author  Daniel Nyberg
 * @version 0.8, 12/12/03
 * @since   ThrottleNet0.1
 */
public abstract class ThrottleNetAdapter implements ThrottleNetListener {

	
	/**
	 * Invoked when the fragment time has been changed.
	 * 
	 * @param event throttlenet event.
	 */
	public void fragmentTimeChanged(ThrottleNetEvent event) {
	
	}
	
	
	/**
	 * Invoked when the fragment size has been changed.
	 * 
	 * @param event throttlenet event.
	 */
	public void fragmentSizeChanged(ThrottleNetEvent event) {
	
	}
	
}


