package se.lth.cs.throttlenet.event;


/**
 * An event which indicates that a throttlenet network state has been changed.
 *
 * @author  Patricia Grudziecka
 * @author  Daniel Nyberg
 * @version 0.8, 12/12/03
 * @since   ThrottleNet0.1
 */
public class ThrottleNetEvent {

	
	/**
	 * The updated fragment size.
	 */
	private int fragSize;

	
	/**
	 * The updated fragment time.
	 */
	private int fragTime;


	/**
	 * Constructs a ThrottleNetEvent object with the specified fragment time and
	 * size.
	 *
	 * @param   time			the updated fragment size.
	 * @param   size			the updated fragment time.
	 */
	public ThrottleNetEvent(int time, int size) {
		fragTime = time;
		fragSize = size;
	}
	
	
	/**
	 * Returns the updated fragment size.
	 *
	 * @return the updated fragment size.
	 */
	public int getFragmentSize() {
		return fragSize;
	}
	
	
	/**
	 * Returns the updated fragment time.
	 *
	 * @return the updated fragment time.
	 */
	public int getFragmentTime() {
		return fragTime;
	}
	
}
