package se.lth.cs.throttlenet.event;


/**
 * The listener interface for receiving throttlenet events (fragment time and
 * size changes).
 *
 * @author  Patricia Grudziecka
 * @author  Daniel Nyberg
 * @version 0.8, 12/12/03
 * @since   ThrottleNet0.1
 */
public interface ThrottleNetListener {

	
	/**
	 * Invoked when the fragment time has been changed.
	 * 
	 * @param event throttlenet event.
	 */
	public void fragmentTimeChanged(ThrottleNetEvent event);
	
	
	/**
	 * Invoked when the fragment size has been changed.
	 * 
	 * @param event throttlenet event.
	 */
	public void fragmentSizeChanged(ThrottleNetEvent event);
	
}
