package se.lth.cs.util.byteArrayAccess;

class BigEndian extends ByteArrayAccess {

    BigEndian(byte a[]){
    	super(a);
    }		

    public final short getShortInArray(byte[] mem, int offset){
	int tmpOffset = offset + DATA_OFFSET;
	return (   ((int) mem[tmpOffset + 1] & 0x000000ff)
		| (((int) mem[tmpOffset + 0] & 0x000000ff) << 8));
    }

    public final void setShortInArray(byte mem[], int offset, short val){
	mem[offset+DATA_OFFSET + 1] = (byte) (val & 0xff);
	mem[offset+DATA_OFFSET + 0] = (byte) ((val >> 8) & 0xff);
    }
    
    public final int getIntInArray(byte[] mem, int offset){
	int tmpOffset = offset + DATA_OFFSET;
	return (   ((int) mem[tmpOffset + 3] & 0x000000ff)
		| (((int) mem[tmpOffset + 2] & 0x000000ff) << 8)
		| (((int) mem[tmpOffset + 1] & 0x000000ff) << 16)
		| (((int) mem[tmpOffset + 0] & 0x000000ff) << 24));
    }

    public final void setIntInArray(byte mem[], int offset, int val){
	mem[offset+DATA_OFFSET + 3] = (byte) (val & 0xff);
	mem[offset+DATA_OFFSET + 2] = (byte) ((val >> 8) & 0xff);
	mem[offset+DATA_OFFSET + 1] = (byte) ((val >> 16) & 0xff);
	mem[offset+DATA_OFFSET + 0] = (byte) ((val >> 24) & 0xff);
    }
    
    public final long getLongInArray(byte[] mem, int offset) {
        int tmpOffset = offset + DATA_OFFSET;
        return (((long)mem[tmpOffset+7] & 0xff)
                | (((long)mem[tmpOffset+6]& 0xff) << 8)
                | (((long)mem[tmpOffset+5]& 0xff) << 16)
                | (((long)mem[tmpOffset+4]& 0xff) << 24)
                | (((long)mem[tmpOffset+3]& 0xff) << 32)
                | (((long)mem[tmpOffset+2]& 0xff) << 40)
                | (((long)mem[tmpOffset+1]& 0xff) << 48)
                | (((long)mem[tmpOffset+0]& 0xff) << 56));
    }

    public final void setLongInArray(byte mem[], int offset, long val){
	mem[offset+DATA_OFFSET + 7] = (byte) (val & 0xff);
	mem[offset+DATA_OFFSET + 6] = (byte) ((val >> 8) & 0xff);
	mem[offset+DATA_OFFSET + 5] = (byte) ((val >> 16) & 0xff);
	mem[offset+DATA_OFFSET + 4] = (byte) ((val >> 24) & 0xff);
	mem[offset+DATA_OFFSET + 3] = (byte) ((val >> 32) & 0xff);
	mem[offset+DATA_OFFSET + 2] = (byte) ((val >> 40) & 0xff);
	mem[offset+DATA_OFFSET + 1] = (byte) ((val >> 48) & 0xff);
	mem[offset+DATA_OFFSET + 0] = (byte) ((val >> 56) & 0xff);
    }

    public final float getFloatInArray(byte[] mem, int offset){
	int d1 = mem[offset+DATA_OFFSET + 3] & 0x000000ff;
	int d2 = mem[offset+DATA_OFFSET + 2] & 0x000000ff;
	int d3 = mem[offset+DATA_OFFSET + 1] & 0x000000ff;
	int d4 = mem[offset+DATA_OFFSET + 0] & 0x000000ff;
	return Float.intBitsToFloat((d4 << 24) | (d3 << 16) | (d2 << 8) | d1);
    }

    public final void setFloatInArray(byte mem[], int offset, float val){
	mem[offset+DATA_OFFSET + 3] = (byte)((Float.floatToIntBits(val) & 0x000000ff));
	mem[offset+DATA_OFFSET + 2] = (byte)((Float.floatToIntBits(val) & 0x0000ff00) >> 8);
	mem[offset+DATA_OFFSET + 1] = (byte)((Float.floatToIntBits(val) & 0x00ff0000) >> 16);
	mem[offset+DATA_OFFSET + 0] = (byte)((Float.floatToIntBits(val) & 0xff000000) >> 24);
    }

}
