#include <class_indices.h>

#ifdef SE_LTH_CS_UTIL_LINUX_KERNELSYMBOL_INDEX

/* configuration options... shouldn't really be here... */
#define JAVA2C
#undef HARDCODED_ADR
#define NO_DYNAMIC_MEM
#define ERRNO_HACK

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef HOST_RTAI_KERNEL
#include <stdio.h>
#endif


#ifdef LINUX
#include <asm/unistd.h> 	// needed for syscall
#include <asm/uaccess.h>	// needed for get_fs()
#include <asm/processor.h>	// needed for mm_segment_t;
#endif
#include <linux/module.h>
#include <linux/kernel.h>

#ifdef ERRNO_HACK
/* HERE BE DRAGONS!!! HORRIBLE HACK! */
static int errno;
#else
#include <errno.h>
#endif

#ifndef HARDCODED_ADR
#ifdef LINUX
_syscall5(int, query_module, const char*, name, int, which, void *, buf, size_t, bufsize, size_t*, ret)
#endif
#endif


#ifdef JAVA2C
#include <gc.h>
#include <javatypes.h>
#if GC_THREAD == GC_THREAD_PTHREAD
#include <pthread.h>
#endif
#include <java_lang_String.h>
#endif

/** Test program for looking up a kernel symbol with a given name in a
 *  given module
 **/

#ifdef HARDCODED_ADR
/* querying won't work, hardcode address... */
extern void* slave_global_memory;
#endif

struct module_symbol * find_symbols(const char *modName, size_t *length, size_t *symbolCount);

void **find_symbol(const char *modName, const char *symName);

#ifdef JAVA2C
GC_VAR_FUNC_BEGIN(JLong, se_lth_cs_util_linux_KernelSymbol_findSymbol_java_lang_String_java_lang_String, GC_PARAM(java_lang_String, modName), GC_PARAM(java_lang_String, symName))
	GC_PARAM_REF(java_lang_String, modName);
	GC_PARAM_REF(java_lang_String, symName);
	GC_PUSH_PARAM(modName);
	GC_PUSH_PARAM(symName);
 	GC_FUNC_ENTER;
{
	GC_REF(JCharArray, mn);
	GC_REF(JCharArray, sn);
	GC_PUSH_ROOT(mn);
	GC_PUSH_ROOT(sn);
	{
	void **adr;
#ifdef LINUX
	mm_segment_t fs;
#endif

	GC_GET_REF(mn, modName, _java_lang_String_data);
	GC_GET_REF(sn, symName, _java_lang_String_data);

	printk("find symbol %s::%s \n", GC___PTR(mn.ref)->data, GC___PTR(sn.ref)->data);

#ifdef LINUX
#ifndef GC_HAS_THREADS
	fs = get_fs();     /* save previous value */
	set_fs (get_ds()); /* use kernel limit */
#endif

	/* system calls can be invoked */

	adr = find_symbol(GC___PTR(mn.ref)->data, GC___PTR(sn.ref)->data);

#ifndef GC_HAS_THREADS
	set_fs(fs); /* restore before returning to user space */
#endif
#endif
	printk("find_symbol returned %x which contains %x\n", adr, *adr);
//	printk("symbol %s::%s = %x\n", GC___PTR(mn.ref)->data, GC___PTR(sn.ref)->data, adr);

	GC_POP_ROOT(sn);
	GC_POP_ROOT(mn);
	GC_RETURN_VAR((JLong) *adr);
	}
}
	GC_FUNC_LEAVE;
	GC_POP_PARAM(symName);
	GC_POP_PARAM(modName);
GC_VAR_FUNC_END(JLong, se_lth_cs_util_linux_KernelSymbol_findSymbol_java_lang_String_java_lang_String)
#endif

#ifndef HARDCODED_ADR 
/* HERE BE DRAGONS!
 * statically allocated buffer, should be (k|v)malloc:ed instead... */
#ifdef NO_DYNAMIC_MEM
struct module_symbol buf[1024];
#endif
struct module_symbol * find_symbols(const char *modName, size_t *length, size_t *symbolCount)
/* Find the symbols defined by module modName. length and symbolCount are
   set to values matching the returned array */
{
	int result;

	size_t ret;
#ifndef NO_DYNAMIC_MEM
	struct module_symbol *buf;
	/* bufsize = 0, this should "fail" as we probe for proper buffer size */
#else
	int bufsize = 1024;
#endif
	if(result = query_module(modName, QM_SYMBOLS, buf, bufsize, &ret)){
#ifndef NO_DYNAMIC_MEM
	/* HERE BE DRAGONS!
	 * Should we use kmalloc or vmalloc? */

		if(errno ==  ENOSPC) {
			/* find correct size for the buffer*/
			bufsize = ret;
			*length = ret;
			buf = (struct module_symbol *)malloc(bufsize);
		} else {
			/* this should not happen*/
			printk("find_symbols :: error: ERRNO=%d\n",errno);
			//perror(NULL);
			//exit(1);
			return 0;
		}
#else
		return 0;
	}
	if(result = query_module(modName, QM_SYMBOLS, buf, bufsize, &ret)){
		/* this should not happen*/
		//printk("find_symbols :: error: ERRNO=%d\n",errno);
		//perror(NULL);
		//exit(1);
		return 0;
	} else {
		*symbolCount=ret;
		return buf;
	}
#endif
}
#endif

void **find_symbol(const char *modName, const char *symName)
{
	int i;
	struct module_symbol *buf;
	size_t length, count;

#ifdef HARDCODED_ADR 
	printf("Warning: using hard coded address\n");
	return &slave_global_memory;
#else
	buf = find_symbols(modName, &length, &count);

	for(i=0; i<count; i++){
		char *c = ((char *)buf)+((JLong)buf[i].name);
		// printk("looking at %s : %x\n", c, buf[i].value);
		if(!strcmp(symName,c)){
			// printk("found match: %s [%x]\n", c, buf[i].value);
			return buf[i].value;
		}
	}
	return 0;
#endif	
}

#endif
