/*
 * $Revision: 1.5.2.4 $
 * $Author: andersn $
 * $Date: 2005/01/31 10:13:24 $
 */

#include <javatypes.h>
#include <gci_common.h>

#ifndef KERNELSPACE
extern GC__IMPL_REF(LayoutHead, VAL_ARRAY_LAYOUT); 
extern GC__IMPL_REF(LayoutHead, REF_ARRAY_LAYOUT); 
#endif

GC_REF_FUNC_BEGIN(JBooleanArray,newJBooleanArray,int size)
     GC_FUNC_ENTER
     GC_REF(JBooleanArray,this);
     GC_PUSH_ROOT(this);
     {
#ifndef KERNELSPACE
       JInt objSize,arrSize;
       arrSize = size*sizeof(JBoolean);
       objSize = ALIGN4(sizeof(JBooleanArray)+arrSize-sizeof(JBoolean));
       gc_lock();
       GC___ASSIGN(this->ref, HEAPALLOC(JBooleanArray, objSize, VAL_ARRAY_LAYOUT->ref));
       /* HERE BE DRAGONS! The following could (should?) be implemented with
        * a normal GC_SET() (then the gc_unlock() should be moved to before
        * this comment.
        */
       GC___PTR(this->ref)->arraySize = arrSize;
       GC___PTR(this->ref)->objectSize = objSize;
       GC___PTR(this->ref)->nbrElements = size;
       GC___PTR(this->ref)->_JBooleanA_length = size;
       gc_unlock();
       GC_RETURN_REF(this);
#endif
     }
     GC_POP_ROOT(this);
     GC_FUNC_LEAVE;
GC_REF_FUNC_END(JBooleanArray,newJBooleanArray)

GC_REF_FUNC_BEGIN(JIntArray,newJIntArray,int size)
     GC_FUNC_ENTER
     GC_REF(JIntArray,this);
     GC_PUSH_ROOT(this);
     {
#ifndef KERNELSPACE
       JInt objSize,arrSize;
       arrSize = size*sizeof(JInt);
       objSize = sizeof(JIntArray)+arrSize-sizeof(JInt);
       gc_lock();
       GC___ASSIGN(this->ref, HEAPALLOC(JIntArray, objSize, VAL_ARRAY_LAYOUT->ref));
       GC___PTR(this->ref)->arraySize = arrSize;
       GC___PTR(this->ref)->objectSize = objSize;
       GC___PTR(this->ref)->nbrElements = size;
       GC___PTR(this->ref)->_JIntA_length = size;
       gc_unlock();
       GC_RETURN_REF(this);
#endif
     }
     GC_POP_ROOT(this);
     GC_FUNC_LEAVE;
GC_REF_FUNC_END(JIntArray,newJIntArray)

GC_REF_FUNC_BEGIN(JLongArray,newJLongArray,int size)
     GC_FUNC_ENTER
     GC_REF(JLongArray,this);
     GC_PUSH_ROOT(this);
#ifndef KERNELSPACE
     {
       JInt objSize,arrSize;
       arrSize = size*sizeof(JLong);
       objSize = sizeof(JLongArray)+arrSize-sizeof(JLong);
       gc_lock();
       GC___ASSIGN(this->ref, HEAPALLOC(JLongArray, objSize, VAL_ARRAY_LAYOUT->ref));
       GC___PTR(this->ref)->arraySize = arrSize;
       GC___PTR(this->ref)->objectSize = objSize;
       GC___PTR(this->ref)->nbrElements = size;
       GC___PTR(this->ref)->_JLongA_length = size;
       gc_unlock();
       GC_RETURN_REF(this);
     }
#endif
     GC_POP_ROOT(this);
     GC_FUNC_LEAVE;
GC_REF_FUNC_END(JLongArray,newJLongArray)

GC_REF_FUNC_BEGIN(JFloatArray,newJFloatArray,int size)
     GC_FUNC_ENTER
     GC_REF(JFloatArray,this);
     GC_PUSH_ROOT(this);
#ifndef KERNELSPACE
     {
       JInt objSize,arrSize;
       arrSize = size*sizeof(JFloat);
       objSize = sizeof(JFloatArray)+arrSize-sizeof(JFloat);
       gc_lock();
       GC___ASSIGN(this->ref, HEAPALLOC(JFloatArray, objSize, VAL_ARRAY_LAYOUT->ref));
       GC___PTR(this->ref)->arraySize = arrSize;
       GC___PTR(this->ref)->objectSize = objSize;
       GC___PTR(this->ref)->nbrElements = size;
       GC___PTR(this->ref)->_JFloatA_length = size;
       gc_unlock();
       GC_RETURN_REF(this);
     }
#endif
     GC_POP_ROOT(this);
     GC_FUNC_LEAVE;
GC_REF_FUNC_END(JFloatArray,newJFloatArray)

GC_REF_FUNC_BEGIN(JDoubleArray,newJDoubleArray,int size)
     GC_FUNC_ENTER
     GC_REF(JDoubleArray,this);
     GC_PUSH_ROOT(this);
#ifndef KERNELSPACE
     {
       JInt objSize,arrSize;
       arrSize = size*sizeof(JDouble);
       objSize = sizeof(JDoubleArray)+arrSize-sizeof(JDouble);
       gc_lock();
       GC___ASSIGN(this->ref, HEAPALLOC(JDoubleArray, objSize, VAL_ARRAY_LAYOUT->ref));
       GC___PTR(this->ref)->arraySize = arrSize;
       GC___PTR(this->ref)->objectSize = objSize;
       GC___PTR(this->ref)->nbrElements = size;
       GC___PTR(this->ref)->_JDoubleA_length = size;
       gc_unlock();
       GC_RETURN_REF(this);
     }
#endif
     GC_POP_ROOT(this);
     GC_FUNC_LEAVE;
GC_REF_FUNC_END(JDoubleArray,newJDoubleArray)

GC_REF_FUNC_BEGIN(JCharArray,newJCharArray,int size)
     GC_FUNC_ENTER
     GC_REF(JCharArray,this);
     GC_PUSH_ROOT(this);
#ifndef KERNELSPACE
     {
       JInt objSize,arrSize;
       arrSize = size*sizeof(JChar);
/*     java_lang_PhonyWriter_println_int(arrSize); */
       objSize = ALIGN4(sizeof(JCharArray)+arrSize-sizeof(JChar));
/*     java_lang_PhonyWriter_println_int(objSize); */
/*     java_lang_PhonyWriter_println_int(size); */
       gc_lock();
/*        transmitInt(GC___PTR(this->ref)); */
/*        transmit('\n'); */
       GC___ASSIGN(this->ref, HEAPALLOC(JCharArray, objSize, VAL_ARRAY_LAYOUT->ref));
/*        transmitInt(GC___PTR(this->ref)); */
/*        transmit('\n'); */
/*        GC_SET(this,arraySize,arrSize); */
/*        GC_SET(this,objectSize,objSize); */
/*        GC_SET(this,nbrElements,size); */
/*        GC_SET(this,_JCharA_length,size); */
       GC___PTR(this->ref)->arraySize = arrSize;
       GC___PTR(this->ref)->objectSize = objSize;
       GC___PTR(this->ref)->nbrElements = size;
       GC___PTR(this->ref)->_JCharA_length = size;
/*        transmitInt(arrSize); */
/*        transmit('\n'); */
/*        transmitInt(GC___PTR(this->ref)->arraySize); */
/*        transmit('\n'); */
/*        transmitInt(objSize); */
/*        transmit('\n'); */
/*        transmitInt(GC___PTR(this->ref)->objectSize); */
/*        transmit('\n'); */
/*        transmitInt(size); */
/*        transmit('\n'); */
/*        transmitInt(GC___PTR(this->ref)->nbrElements); */
/*        transmit('\n'); */
       gc_unlock();
/*     java_lang_PhonyWriter_println_int(GC___PTR(this->ref)->_JCharA_length); */
       GC_RETURN_REF(this);
     }
#endif
     GC_POP_ROOT(this);
     GC_FUNC_LEAVE;
GC_REF_FUNC_END(JCharArray,newJCharArray)

GC_REF_FUNC_BEGIN(JByteArray,newJByteArray,int size)
     GC_FUNC_ENTER
     GC_REF(JByteArray,this);
     GC_PUSH_ROOT(this);
#ifndef KERNELSPACE
     {
       JInt objSize,arrSize;
       arrSize = size*sizeof(JByte);
       objSize = ALIGN4(sizeof(JByteArray)+arrSize-sizeof(JByte));
       gc_lock();
       GC___ASSIGN(this->ref, HEAPALLOC(JByteArray, objSize, VAL_ARRAY_LAYOUT->ref));
       //if (GC___PTR(this->ref) == 0) printf("ERROR: could not alloc array!!!\n");
       GC___PTR(this->ref)->arraySize = arrSize;
       GC___PTR(this->ref)->objectSize = objSize;
       GC___PTR(this->ref)->nbrElements = size;
       GC___PTR(this->ref)->_JByteA_length = size;
       gc_unlock();
       GC_RETURN_REF(this);
     }
     GC_POP_ROOT(this);
     GC_FUNC_LEAVE;
GC_REF_FUNC_END(JByteArray,newJByteArray)

GC_REF_FUNC_BEGIN(JShortArray,newJShortArray,int size)
     GC_FUNC_ENTER
     GC_REF(JShortArray,this);
     GC_PUSH_ROOT(this);
     {
       JInt objSize,arrSize;
       arrSize = size*sizeof(JShort);
       objSize = ALIGN4(sizeof(JShortArray)+arrSize-sizeof(JShort));
       gc_lock();
       GC___ASSIGN(this->ref, HEAPALLOC(JShortArray, objSize, VAL_ARRAY_LAYOUT->ref));
       GC___PTR(this->ref)->arraySize = arrSize;
       GC___PTR(this->ref)->objectSize = objSize;
       GC___PTR(this->ref)->nbrElements = size;
       GC___PTR(this->ref)->_JShortA_length = size;
       gc_unlock();
       GC_RETURN_REF(this);
     }
#endif
     GC_POP_ROOT(this);
     GC_FUNC_LEAVE;
GC_REF_FUNC_END(JShortArray,newJShortArray)

GC_REF_FUNC_BEGIN(RefArray,newRefArray,int size)
     GC_FUNC_ENTER
     GC_REF(RefArray,this);
     GC_PUSH_ROOT(this);
#ifndef KERNELSPACE
     {
       JInt objSize,arrSize;
       arrSize = size*sizeof(void *);
       objSize = sizeof(RefArray)+arrSize-sizeof(void*);
       gc_lock();
       GC___ASSIGN(this->ref, HEAPALLOC(RefArray, objSize, REF_ARRAY_LAYOUT->ref));
       GC___PTR(this->ref)->arraySize = arrSize;
       GC___PTR(this->ref)->objectSize = objSize;
       GC___PTR(this->ref)->nbrElements = size;
       GC___PTR(this->ref)->_RefA_length = size;
       gc_unlock();
       GC_RETURN_REF(this);
     }
#endif
     GC_POP_ROOT(this);
     GC_FUNC_LEAVE;
GC_REF_FUNC_END(RefArray,newRefArray)

