#include <class_indices.h>

#ifdef SE_LTH_CS_REALTIME_SEMAPHORE_COUNTINGSEM_INDEX

#include <gc.h>
#include <pthread.h>
#include <javatypes.h>
#include <semaphore.h>
#include <se_lth_cs_realtime_semaphore_CountingSem.h>

#ifdef GC_HAS_FINALIZERS
static void dealloc_sem(se_lth_cs_realtime_semaphore_CountingSem *this){
#ifdef GC_PRINT_DEBUG
    printf("freed semaphore: %x\n", this->_se_lth_cs_realtime_semaphore_CountingSem_target);
#endif
	free(this->_se_lth_cs_realtime_semaphore_CountingSem_target);		
}
#endif

GC_VAR_FUNC_BEGIN(JLong,se_lth_cs_realtime_semaphore_CountingSem_createCountingSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),int iValue)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
  sem_t* sem;
  sem=malloc(sizeof(sem_t));
/*   sem_init(sem,0,0); */
  sem_init(sem,0,iValue);
#ifdef GC_HAS_FINALIZERS
#ifdef GC_PRINT_DEBUG
    printf("Allocated semaphore: %x\n", sem);
#endif
  GC_SET_FINALIZER(this, dealloc_sem);
#endif

  GC_RETURN_VAR((JLong)sem);
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_VAR_FUNC_END(JLong,se_lth_cs_realtime_semaphore_CountingSem_createCountingSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_CountingSem_giveCountingSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
  sem_post((sem_t*)target);
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(_se_lth_cs_realtime_semaphore_CountingSem_giveCountingSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_CountingSem_takeCountingSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
  sem_wait((sem_t*)target);
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(_se_lth_cs_realtime_semaphore_CountingSem_takeCountingSem_int)

#endif
