#include <class_indices.h>

#ifdef SE_LTH_CS_REALTIME_SEMAPHORE_MUTEXSEM_INDEX

#include <gc.h>
#include <javatypes.h>
#include <se_lth_cs_realtime_semaphore_MutexSem.h>
#include <rtai/mutex.h>
#include <rtai/types.h>

#ifdef GC_HAS_FINALIZERS
static void dealloc_mutex(se_lth_cs_realtime_semaphore_MutexSem *this){
#ifdef GC_PRINT_DEBUG
    printf("freed mutex semaphore: %x\n", this->_se_lth_cs_realtime_semaphore_MutexSem_target);
#endif
    rt_mutex_delete(this->_se_lth_cs_realtime_semaphore_MutexSem_target);
    free(this->_se_lth_cs_realtime_semaphore_MutexSem_target);		
}
#endif

GC_VAR_FUNC_BEGIN(JLong,se_lth_cs_realtime_semaphore_MutexSem_createMutexSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),int iValue)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
	RT_MUTEX* mutex = (RT_MUTEX*)malloc(sizeof(RT_MUTEX));
	rt_mutex_create(mutex, "mutex");

#ifdef GC_HAS_FINALIZERS
#ifdef GC_PRINT_DEBUG
    printf("Allocated mutex semaphore: %x\n", mutex);
#endif
  GC_SET_FINALIZER(this, dealloc_mutex);
#endif

  GC_RETURN_VAR((JLong)mutex);
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_VAR_FUNC_END(JLong,se_lth_cs_realtime_semaphore_MutexSem_createMutexSem_int)

	
GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_MutexSem_giveMutexSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
	rt_mutex_unlock(target);
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(_se_lth_cs_realtime_semaphore_MutexSem_giveMutexSem_long)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_MutexSem_takeMutexSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
	rt_mutex_lock(target, TM_INFINITE);
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(_se_lth_cs_realtime_semaphore_MutexSem_takeMutexSem_long)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_MutexSem_takeMutexSem_long_long,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),JLong target, JLong timeout)
	GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
	GC_PUSH_PARAM(this);
	GC_FUNC_ENTER;
{
	RTIME to = timeout;
	
	if(timeout < 0){
		to = 0;
		printf("negative timeout in mutexSem.takeMutexSem \n");
	}

	rt_mutex_lock(target,to);
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(_se_lth_cs_realtime_semaphore_MutexSem_takeMutexSem_long_long)
	
	
#endif
