#include <javatypes.h> 
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <asm/errno.h> 
#include <linux/ioctl.h>
#include <sys/ioctl.h>

#include <gc.h>

#define IRB6_IO_MAGIC 0xd0
#define IOCT_SETPORT _IO(IRB6_IO_MAGIC, 1)
#define IOCT_ANALOGIN _IOR(IRB6_IO_MAGIC, 2, result)
#define DEVICE "/dev/vme_dev"
#define IOCT_ANALOGOUT _IO(IRB6_IO_MAGIC, 3)
#define IOCT_DIGITALIN _IOR(IRB6_IO_MAGIC, 4, result)
#define IOCT_BITIN _IOR(IRB6_IO_MAGIC, 5, result)
#define IOCT_BITOUT _IO(IRB6_IO_MAGIC, 6)

//int bitIn();
//int bitOut(int value);
//int digitalIn();
//int analogIn(int port);
//int analogOut(int channel, int gain);

static int file_descriptor=0;

GC_PROC_BEGIN(se_lth_cs_robot_irb6_IO_nativeInit)
{
  file_descriptor = open(DEVICE, O_RDWR);
}
GC_PROC_END(se_lth_cs_robot_irb6_IO_nativeInit)

GC_PROC_BEGIN(se_lth_cs_robot_irb6_IO_nativeCleanup)
{
  close(file_descriptor);
}
GC_PROC_END(se_lth_cs_robot_irb6_IO_nativeCleanup)

GC_VAR_FUNC_BEGIN(JInt,se_lth_cs_robot_irb6_IO_nativeFuncAnalogOut_int_int, JInt port, JInt gain)
{  
  int resultvalue;
//  int file_descriptor = open(DEVICE, O_RDWR);
  ioctl(file_descriptor, IOCT_SETPORT, port);
  resultvalue = ioctl(file_descriptor, IOCT_ANALOGOUT, gain);
  if(resultvalue == -ENOTTY ) {
    printf("\nError ioctl - analogOut \n");
    return -1;
  }
//  close(file_descriptor);
//  analogOut(port,gain);
  return 0;
}
GC_VAR_FUNC_END(JInt,se_lth_cs_robot_irb6_IO_nativeFuncAnalogOut_int_int)

GC_VAR_FUNC_BEGIN(JInt,se_lth_cs_robot_irb6_IO_nativeFuncAnalogIn_int, JInt port)
{
  int value, result[1];
  float returnvalue;
//  int file_descriptor = open(DEVICE, O_RDWR);
  ioctl(file_descriptor, IOCT_SETPORT, port);
  value = ioctl(file_descriptor, IOCT_ANALOGIN, result);
  if(value == -EFAULT) {
    printf("\nError ioctl - analogIn\n");	
    return -1;
  }
//  close(file_descriptor);
  return result[0];
//    return analogIn(port);
}
GC_VAR_FUNC_END(JInt,se_lth_cs_robot_irb6_IO_nativeFuncAnalogIn_int)

GC_VAR_FUNC_BEGIN(JInt,se_lth_cs_robot_irb6_IO_nativeFuncDigitalIn)
{
  int value;
  int result[1]; 
  int rev, pos;
//  int file_descriptor = open(DEVICE, O_RDWR);
  value = ioctl(file_descriptor, IOCT_DIGITALIN, result);
  if(value == -EFAULT) {
    printf("\nError ioctl - digitalInput\n");	
    return -1;
  }
//  close(file_descriptor);
  return result[0];
//    return digitalIn();
}
GC_VAR_FUNC_END(JInt,se_lth_cs_robot_irb6_IO_nativeFuncDigitalIn)

GC_VAR_FUNC_BEGIN(JInt,se_lth_cs_robot_irb6_IO_nativeFuncBitIn)
{
  int value, result[1];
//  int file_descriptor = open(DEVICE, O_RDWR);
  value = ioctl(file_descriptor, IOCT_BITIN, result);
  if(value == -EFAULT) {
    printf("\nError ioctl - bitIn\n");
    return -1;
  }
//  close(file_descriptor);
  return result[0];
//    return bitIn();
}
GC_VAR_FUNC_END(JInt,se_lth_cs_robot_irb6_IO_nativeFuncBitIn)

GC_VAR_FUNC_BEGIN(JInt,se_lth_cs_robot_irb6_IO_nativeFuncBitOut_int, JInt value)
{
//  int file_descriptor = open(DEVICE, O_RDWR);
  int resultvalue = ioctl(file_descriptor, IOCT_BITOUT, value);
  if(resultvalue == -ENOTTY ) {
    printf("\nError ioctl - bitOut \n");
    return -1;
  }
//  close(file_descriptor);
  return 0;
//    bitOut(value);
//    return 0;
}
GC_VAR_FUNC_END(JInt,se_lth_cs_robot_irb6_IO_nativeFuncBitOut_int)
