#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef HOST_RTAI_KERNEL
#include <stdio.h>
#include <sys/time.h>
#endif
#include <gc.h>
#include <gci_common.h>
#include <exception.h>
#include <javatypes.h>
#include <java_lang_Thread.h>
#include <java_lang_Runnable.h>
#include <iface.h>
#include <class_indices.h>
#include <errno.h>
#include <java2c_lxrt.h>


#define NS_MS 	1000000
#define MS 		1000
#define NSEC 1000000000

extern GC_REF(LayoutHead,java_lang_Thread_Layout);
extern java_lang_Thread_Class;

#if GC_THREAD == GC_THREAD_RTAIKERNEL
void cleanup_module(void) {
  printk("unloading\n");
}
int init_module(void) {
#else
int main() {
#endif
  GC_INIT(GC_HEAPSIZE);
  {
	  javaClasses_Init();
	  JAVAMAIN();
  }
  GC_EXIT;
  return 0;
}

/* Native implementation of java.lang.start() */

GC_PROC_BEGIN(java_lang_Thread_start,GC_PARAM(java_lang_Thread,this))
     GC_PARAM_REF(java_lang_Thread,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER 
     {
       printf("java.lang.Thread.start() is not available without threads\n");
     }	
	
     GC_FUNC_LEAVE;
     GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_start)

/* Native implementation of java.lang.Thread.sleep(long millis) */

GC_PROC_BEGIN(java_lang_Thread_sleep_long,long millis) EXCEPTION_THROWS;
  GC_FUNC_ENTER
  {
#ifndef HOST_RTAI_KERNEL
	int status;
  	struct timespec time;
	time.tv_sec  = (millis / MS);
	time.tv_nsec = (millis % MS) * NS_MS;
  	nanosleep(&time,0); 	
#endif
  }
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_Thread_sleep_long)


/* Native implementation of java.lang.Thread.sleep(long millis,int nanos) */

GC_PROC_BEGIN(java_lang_Thread_sleep_long_int,long millis,int nanos)
  GC_FUNC_ENTER
  {
#ifndef HOST_RTAI_KERNEL
  	int status;
  	struct timespec time;
	time.tv_sec  = (millis / MS);
	time.tv_nsec = (millis % MS) * NS_MS + nanos;
  	nanosleep(&time,0); 
#endif
  }
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_Thread_sleep_long_int)

/* Native implementation of java.lang.Thread.interrupt() */
int debug;

GC_PROC_BEGIN(java_lang_Thread_interrupt,GC_PARAM(java_lang_Thread,this))
  GC_PARAM_REF(java_lang_Thread,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
  {
    printf("java.lang.Thread.interrupt() has no meaning without threads\n");
  }
  GC_FUNC_LEAVE;  
  GC_POP_PARAM(this);	
GC_PROC_END(java_lang_Thread_interrupt)

/* Native implementation of java.lang.Thread.interrupted() */

GC_VAR_FUNC_BEGIN(JBoolean,java_lang_Thread_interrupted,GC_PARAM(java_lang_Thread,this))
  GC_PARAM_REF(java_lang_Thread,this);
  JBoolean tmp;
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
    tmp = 0;
  GC_RETURN_VAR(tmp);    
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_VAR_FUNC_END(JBoolean,java_lang_Thread_interrupted)

/* Native implementation of java.lang.Thread.currentThread() */

GC_REF_FUNC_BEGIN(java_lang_Thread,java_lang_Thread_currentThread)
  GC_REF(java_lang_Thread,tmp);
  GC_FUNC_ENTER;
  GC_PUSH_ROOT(tmp);
  {	
    printf("java.lang.Thread.currentThread() has no meaning without threads\n");
    GC_RETURN_REF(tmp);
  }  
  GC_POP_ROOT(tmp);
  GC_FUNC_LEAVE;
  GC_POP_PARAM(tmp);
GC_REF_FUNC_END(java_lang_Thread,java_lang_Thread_currentThread)

/* Native implementation of java.lang.Thread.setPriority() */

GC_PROC_BEGIN(java_lang_Thread_setPriority_int,GC_PARAM(java_lang_Thread,this),JInt priority)  EXCEPTION_THROWS
  GC_PARAM_REF(java_lang_Thread,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
    printf("java.lang.Thread.setPriority(int) has no meaning without threads\n");
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_setPriority_int)

/* Native implementation of java.lang.Thread.join() */

GC_PROC_BEGIN(java_lang_Thread_join,GC_PARAM(java_lang_Thread,this))
  GC_PARAM_REF(java_lang_Thread,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
    printf("java.lang.Thread.join() has no meaning without threads\n");
  GC_FUNC_LEAVE;  
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_join)

/* Native implementation of java.lang.Thread.join(long millis) */

GC_PROC_BEGIN(java_lang_Thread_join_long,GC_PARAM(java_lang_Thread,this),JLong millis)
  GC_PARAM_REF(java_lang_Thread,this);  
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
    printf("java.lang.Thread.join(long) has no meaning without threads\n");
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_join_long)

/* Native implementation of java.lang.Thread.join(long millis, int nanos) */

GC_PROC_BEGIN(java_lang_Thread_join_long_int,GC_PARAM(java_lang_Thread,this),JLong millis,JInt nanos)
  GC_PARAM_REF(java_lang_Thread,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
    printf("java.lang.Thread.join(long,int) has no meaning without threads\n");
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_join_long_int)

GC_PROC_BEGIN(java_lang_Thread_yield)
  GC_FUNC_ENTER;
    printf("java.lang.Thread.yield() has no meaning without threads\n");
  GC_FUNC_LEAVE;
GC_PROC_END(java_lang_Thread_yield)

GC_PROC_BEGIN(java_lang_Thread_inheritPriority)
  GC_FUNC_ENTER;
    printf("java.lang.Thread.inheritPriority() has no meaning without threads\n");
  GC_FUNC_LEAVE;
GC_PROC_END(java_lang_Thread_inheritPriority)

GC_PROC_BEGIN(java_lang_Thread_createThread)
  GC_FUNC_ENTER;
    printf("java.lang.Thread.createThread() has no meaning without threads\n");
  GC_FUNC_LEAVE;
GC_PROC_END(java_lang_Thread_createThread)
