
//#include <class_indices.h>
//#include <gc.h>
#include <pthread.h>
#include <javatypes.h>
#include <semaphore.h>
#include <java2c_lxrt.h>
//#include <java_lang_Object.h>

#include <aux.h>

void monitor_init(ObjectHead *this){
	if(this != 0 && this->lock == 0) {
		pthread_mutexattr_t attr;
		//printf("monitor init: %x\n", this);
		this->lock = malloc(sizeof(pthread_mutex_t));
		//printf("mallock lock...\n");
		this->cond = malloc(sizeof(pthread_cond_t));
		//printf("mallock cond...\n");
		pthread_mutexattr_init_rt(&attr);
		pthread_mutexattr_settype_rt(&attr,PTHREAD_MUTEX_RECURSIVE);
		pthread_mutex_init_rt(this->lock,&attr);
		//printf("mutex init...\n");
		//pthread_mutex_init_rt((GC___PTR(((GC___REF(ObjectHead))this)))->lock,&attr);
		pthread_cond_init_rt(this->cond,NULL);
		//printf("cond init...\n");
		pthread_mutexattr_destroy_rt(&attr);
	}

}

// void monitor_enter_static(Java_lang_Object *this){
//
// 	pthread_mutex_lock_rt(this.class_lock);
// }

void monitor_enter(ObjectHead *this){
//	if(isStatic){
//		pthread_mutex_lock_rt(((struct java_lang_Object_ClassStruct*)this)->class_lock);
//
//	}else;
  printf("monitor enter [%p]...\n", this->lock);
	pthread_mutex_lock_rt(this->lock);
}

void monitor_leave(ObjectHead *this){
	//printf("monitor leave...\n");
	pthread_mutex_unlock_rt(this->lock);
}

/* Function translates Java priority in an equivalent scheduler's priority
   specified by the parameter sched */

int javaPr2schedPr(int java_prio,int sched) {
	const int pr_step_java = 10;
	int pr_step_posix;
	pr_step_posix = sched_get_priority_max(sched) - sched_get_priority_min(sched);
	return (((10-(java_prio-1)) * (abs(pr_step_posix)))/(pr_step_java))-(abs(sched_get_priority_min(sched)));
}

int schedPr2javaPr(int sched_prio,int sched) {
	const int pr_step_java = 10;
	int pr_step_posix;
	pr_step_posix = sched_get_priority_max(sched) - sched_get_priority_min(sched);
	return (int)((float)11- (float)((float)(sched_prio+sched_get_priority_min(sched)) * ((float)(abs(pr_step_java))/(pr_step_posix))));
}


