/* $Revision: 1.8.2.6 $
 * $Author: andersn $
 * $Date: 2005/04/15 12:54:18 $
 */
#include <class_indices.h>
#ifdef JAVA_LANG_STRING_INDEX

#include <javatypes.h>
#include <sys/time.h>
#include <stddef.h>
#include <gc.h>
#include <gci_common.h>
#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include <java_lang_String.h>
#include <java_lang_Object.h>

GC_VAR_FUNC_BEGIN(JLong,java_lang_System_currentTimeMillis)
  GC_FUNC_ENTER;
  {
    struct timeval tp;
    JLong time;
    gettimeofday(&tp,0);
    time = ((JLong) tp.tv_sec*1000)+((JLong) tp.tv_usec/1000);
    GC_RETURN_VAR(time);
 }
 GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,java_lang_System_currentTimeMillis)

GC_VAR_FUNC_BEGIN(JLong,java_lang_System_currentTimeMicros)
  GC_FUNC_ENTER;
  {
    struct timeval tp;
    int time;
    gettimeofday(&tp,0);
    time = ((JLong) tp.tv_sec*1000)+((JLong) tp.tv_usec/1000);
    GC_RETURN_VAR(time*1000);
 }
 GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,java_lang_System_currentTimeMicros)

GC_PROC_BEGIN(java_lang_System_exit_int,JInt i) 
  GC_FUNC_ENTER
  exit(i);
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_System_exit_int)

GC_PROC_BEGIN(java_lang_System_registerNatives) 
  GC_FUNC_ENTER
  /* Missing implementation */
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_System_registerNatives)

GC_VAR_FUNC_BEGIN(JInt, java_lang_PhonyReader_read, GC_PARAM(java_lang_PhonyReader, this))
  GC_PARAM_REF(java_lang_PhonyReader, this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
    unsigned char tmp;
    scanf("%c", &tmp);
    GC_RETURN_VAR((int)tmp);
  GC_FUNC_LEAVE
  GC_POP_PARAM(this);
GC_VAR_FUNC_END(Jint, java_lang_PhonyReader_read)

GC_PROC_BEGIN(java_lang_PhonyWriter_print,GC_PARAM(java_io_PrintStream,p))
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_print)

GC_PROC_BEGIN(java_lang_PhonyWriter_println,GC_PARAM(java_io_PrintStream,p)) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("\n");
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_println)

GC_PROC_BEGIN(java_lang_PhonyWriter_print_int,GC_PARAM(java_io_PrintStream,p),int i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%d",i);
  fflush(stdout);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_print_int) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_int,GC_PARAM(java_io_PrintStream,p),int i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%d\n",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_println_int) 

/* GC_PROC_BEGIN(java_lang_PhonyWriter_print_java_lang_String,char* i)  */
/*   GC_FUNC_ENTER */
/*   printf("%s",i); */
/*   GC_FUNC_LEAVE */
/* GC_PROC_END(java_lang_PhonyWriter_print_java_lang_String)  */

/* GC_PROC_BEGIN(java_lang_PhonyWriter_println_java_lang_String,char* i)  */
/*   GC_FUNC_ENTER */
/*   printf("%s\n",i); */
/*   GC_FUNC_LEAVE */
/* GC_PROC_END(java_lang_PhonyWriter_println_java_lang_String)  */

GC_PROC_BEGIN(java_lang_PhonyWriter_print_java_lang_String,GC_PARAM(java_io_PrintStream,p),GC_PARAM(java_lang_String,s)) 
  GC_PARAM_REF(java_lang_String,s);
  GC_PUSH_PARAM(s);
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER;
{  
  GC_REF(JCharArray, data);    
  GC_PUSH_ROOT(data);
  if (GC_IS_NULL(s)) {
    printf("null");
  } else {
    GC_GET_REF(data,s,_java_lang_String_value);
    {
      JInt len,i;
      GC_GET(len,data,_JCharA_length);
      for (i=0; i<len; i++) {
	char c;
	c = GC___PTR(data->ref)->data[i].bytes;
	putchar(c);
      }
    }
  }
  GC_POP_ROOT(data);
}
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
  GC_POP_PARAM(s);
GC_PROC_END(java_lang_PhonyWriter_print_java_lang_String) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_java_lang_String,GC_PARAM(java_io_PrintStream,p),GC_PARAM(java_lang_String,s)) 
  GC_PARAM_REF(java_lang_String,s);
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(s);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER;
{  
  GC_REF(JCharArray, data);    
  GC_PUSH_ROOT(data);
  if (GC_IS_NULL(s)) {
    printf("null\n");
  } else {
    GC_GET_REF(data,s,_java_lang_String_value);
    {
      JInt len,i;
      GC_GET(len,data,_JCharA_length);
      for (i=0; i<len; i++) {
	char c;
	c = GC___PTR(data->ref)->data[i].bytes;
	putchar(c);
      }
      putchar('\n');
    }
  }
  GC_POP_ROOT(data);
}
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
  GC_POP_PARAM(s);
GC_PROC_END(java_lang_PhonyWriter_println_java_lang_String) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_float,GC_PARAM(java_io_PrintStream,p),float i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%f",i);
  fflush(stdout);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_print_float) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_float,GC_PARAM(java_io_PrintStream,p),float i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%f\n",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_println_float) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_double,GC_PARAM(java_io_PrintStream,p),double i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%f",i);
  fflush(stdout);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_print_double) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_double,GC_PARAM(java_io_PrintStream,p),double i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%f\n",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_println_double) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_short,GC_PARAM(java_io_PrintStream,p),short i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%d",i);
  fflush(stdout);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_print_short) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_short,GC_PARAM(java_io_PrintStream,p),short i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%d\n",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_println_short) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_char,GC_PARAM(java_io_PrintStream,p),char i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%c",i);
  fflush(stdout);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_print_char) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_char,GC_PARAM(java_io_PrintStream,p),char i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%c\n",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_println_char) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_long,GC_PARAM(java_io_PrintStream,p),long long i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%lld",i);
  fflush(stdout);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_print_long) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_long,GC_PARAM(java_io_PrintStream,p),long long i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  printf("%lld\n",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_println_long) 


GC_PROC_BEGIN(java_lang_PhonyWriter_print_boolean,GC_PARAM(java_io_PrintStream,p),short i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  if (i) {
    printf("true");
  } else {
    printf("false");
  }
  fflush(stdout);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_print_boolean) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_boolean,GC_PARAM(java_io_PrintStream,p),short i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  if (i) {
    printf("true\n");
  } else {
    printf("false\n");
  }
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_PhonyWriter_println_boolean) 

JInt java_lang_System_identityHashCode_java_lang_Object(void* o) {
  return (JInt) o;
}


GC_PROC_BEGIN(java_lang_System_arraycopy_java_lang_Object_int_java_lang_Object_int_int,GC_PARAM(java_lang_Object,src),int src_pos,GC_PARAM(java_lang_Object,dest),int dest_pos,int length)
     GC_PARAM_REF(java_lang_Object,src);
     GC_PARAM_REF(java_lang_Object,dest);
     GC_FUNC_ENTER
     {
       GC_REF(JCharArray, a_src);
       GC_REF(JCharArray, a_dst);
       GC_PUSH_ALIAS(a_src);
       GC_PUSH_ALIAS(a_dst);
       GC_ASSIGN(a_src,src);
       GC_ASSIGN(a_dst,dest);

/*        memmove(&(((GC___REF(JCharArray))(GC___PTR(dest->ref)))->data[dest_pos]), */
/* 	       &(((GC___REF(JCharArray))(GC___PTR(src->ref)))->data[src_pos]), */
/* 	       length); */
/*        memmove(&(GC___PTR((GC___REF(JCharArray))dest->ref)->data[dest_pos]),&(GC___PTR((GC___REF(JCharArray))src->ref)->data[src_pos]),length); */
       memmove(&(GC___PTR(a_dst->ref)->data[dest_pos]),
	       &(GC___PTR(a_src->ref)->data[src_pos]),
	       length);

       
     }
     GC_FUNC_LEAVE
GC_PROC_END(java_lang_System_arraycopy_java_lang_Object_int_java_lang_Object_int_int)

GC_PROC_BEGIN(java_lang_ErrWriter_print,GC_PARAM(java_io_PrintStream,p))
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_ErrWriter_print)

GC_PROC_BEGIN(java_lang_ErrWriter_println,GC_PARAM(java_io_PrintStream,p)) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  fprintf(stderr,"\n");
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_ErrWriter_println)

GC_PROC_BEGIN(java_lang_ErrWriter_print_int,GC_PARAM(java_io_PrintStream,p),int i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  fprintf(stderr,"%d",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_ErrWriter_print_int) 

/* GC_PROC_BEGIN(java_lang_ErrWriter_print_java_lang_String,GC_PARAM(java_io_PrintStream,p),char* i)  */
/*   GC_PARAM_REF(java_io_PrintStream,p); */
/*   GC_PUSH_PARAM(p); */
/*   GC_FUNC_ENTER */
/*   fprintf(stderr,"%s",i); */
/*   GC_FUNC_LEAVE */
/*   GC_POP_PARAM(p); */
/* GC_PROC_END(java_lang_ErrWriter_print_java_lang_String)  */

GC_PROC_BEGIN(java_lang_ErrWriter_print_java_lang_String,GC_PARAM(java_io_PrintStream,p),GC_PARAM(java_lang_String,s)) 
  GC_PARAM_REF(java_lang_String,s);
  GC_PUSH_PARAM(s);
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER;
{  
  GC_REF(JCharArray, data);    
  GC_PUSH_ROOT(data);
  if (GC_IS_NULL(s)) {
    printf("null");
  } else {
    GC_GET_REF(data,s,_java_lang_String_value);
    {
      JInt len,i;
      GC_GET(len,data,_JCharA_length);
      for (i=0; i<len; i++) {
	char c;
	c = GC___PTR(data->ref)->data[i].bytes;
	putchar(c);
      }
    }
  }
  GC_POP_ROOT(data);
}
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
  GC_POP_PARAM(s);
GC_PROC_END(java_lang_ErrWriter_print_java_lang_String) 

GC_PROC_BEGIN(java_lang_ErrWriter_println_java_lang_String,GC_PARAM(java_io_PrintStream,p),GC_PARAM(java_lang_String,s)) 
  GC_PARAM_REF(java_lang_String,s);
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(s);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER;
{  
  GC_REF(JCharArray, data);    
  GC_PUSH_ROOT(data);
  if (GC_IS_NULL(s)) {
    printf("null\n");
  } else {
    GC_GET_REF(data,s,_java_lang_String_value);
    {
      JInt len,i;
      GC_GET(len,data,_JCharA_length);
      for (i=0; i<len; i++) {
	char c;
	c = GC___PTR(data->ref)->data[i].bytes;
	putchar(c);
      }
      putchar('\n');
    }
  }
  GC_POP_ROOT(data);
}
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
  GC_POP_PARAM(s);
GC_PROC_END(java_lang_ErrWriter_println_java_lang_String) 

GC_PROC_BEGIN(java_lang_ErrWriter_println_int,GC_PARAM(java_io_PrintStream,p),int i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  fprintf(stderr,"%d\n",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_ErrWriter_println_int) 

/* GC_PROC_BEGIN(java_lang_ErrWriter_println_java_lang_String,GC_PARAM(java_io_PrintStream,p),char* i)  */
/*   GC_PARAM_REF(java_io_PrintStream,p); */
/*   GC_PUSH_PARAM(p); */
/*   GC_FUNC_ENTER */
/*   fprintf(stderr,"%s\n",i); */
/*   GC_FUNC_LEAVE */
/*   GC_POP_PARAM(p); */
/* GC_PROC_END(java_lang_ErrWriter_println_java_lang_String)  */

GC_PROC_BEGIN(java_lang_ErrWriter_print_float,GC_PARAM(java_io_PrintStream,p),float i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  fprintf(stderr,"%f",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_ErrWriter_print_float) 

GC_PROC_BEGIN(java_lang_ErrWriter_println_float,GC_PARAM(java_io_PrintStream,p),float i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  fprintf(stderr,"%f\n",i);
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_ErrWriter_println_float) 

GC_PROC_BEGIN(java_lang_ErrWriter_print_boolean,GC_PARAM(java_io_PrintStream,p),short i) 
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  if (i) {
    fprintf(stderr,"true");
  } else {
    fprintf(stderr,"false");
  }
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_ErrWriter_print_boolean) 

GC_PROC_BEGIN(java_lang_ErrWriter_println_boolean,GC_PARAM(java_io_PrintStream,p),short i)
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER
  if (i) {
    fprintf(stderr,"true\n");
  } else {
    fprintf(stderr,"false\n");
  }
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
GC_PROC_END(java_lang_ErrWriter_println_boolean) 

#endif
