//FIXME: Since threading activity is scattered between java.lang.Object, 
//       java.lang.Thread, ..., all methods affecting threading is moved
//       to a common file

#if 0
/***********************************************************************
 * File : java_langThread.h Implementation of the main() method called
 * by any program compiled with Java2C compiled. gc_lock needs to be
 * defined in the compilation of the generated files to call the right
 * method, translation of the Java main.
 * 
 * Implementation of the native methods included in java.lang.Thread API
 * 
 * Functions corresponding to native Methods declared in java.lang.Thread
 *		createThread();
 *		start();
 *		<syncrhonized> interrupt();
 *		<syncrhonized> interrupted();
 * 	<static> currentThread();
 *		<static> sleep(long millis);
 *
 * This library needs :
 *		class_indices.h  	 <generated by Java2C>
 *		java_lang_Thread.h <generated by Java2C>
 *		java_types.h		 <included in Java2C releases>
 *		Garbage collector  directory <included in Java2C releases>
 *		misc. libraries :  pthread.h - time.h 
 ************************************************************************/

#include <pthread.h>
#include <sys/time.h>
#include <gc.h>
#include <gci_common.h>
#include <exception.h>
#include <javatypes.h>
#include <sys/mman.h>
#include <java_lang_Thread.h>
#include <java_lang_Runnable.h>
#include <iface.h>
#include <class_indices.h>
#include <errno.h>
#include <java2c_lxrt.h>

//#include <java_lang_IllegalArgumentException.h>


#define NS_MS 	1000000
#define MS 		1000
#define NSEC 1000000000

// Q&D Fix?
/* #ifndef JAVA_LANG_INTERRUPTEDEXCEPTION_INDEX */
/* #define JAVA_LANG_INTERRUPTEDEXCEPTION_INDEX -1 */
/* #endif */

/* #ifndef JAVA_LANG_ILLEGALARGUMENTEXCEPTION_INDEX */
/* #define JAVA_LANG_ILLEGALARGUMENTEXCEPTION_INDEX -1 */
/* #endif */
extern void * gc_mutex;

#ifdef JAVA_LANG_OBJECT_INDEX
#include <java_lang_Object.h>
#endif
#ifdef JAVA_LANG_INTERRUPTEDEXCEPTION_INDEX
#include <java_lang_InterruptedException.h>
extern struct java_lang_InterruptedException_ClassStruct java_lang_InterruptedException_Class;
#endif
#ifdef JAVA_LANG_ILLEGALARGUMENTEXCEPTION_INDEX
//#include <java_lang_IllegalArgumentException.h>
//extern GC_REF(LayoutHead,java_lang_IllegalArgumentException_Layout);
extern struct java_lang_IllegalArgumentException_ClassStruct java_lang_IllegalArgumentException_Class;
#endif

static int __thread_is_started = 0;

/* extern GC_REF(LayoutHead,java_lang_Thread_Layout); */
/* extern java_lang_Thread_Class; */
extern GC_REF(LayoutHead,java_lang_String_Layout);
extern java_lang_String_Class;

/* Number of program's thread alive */
static int nbr_threads;

/* Mutex protecting access to nbr_threads local variable */
static pthread_mutex_t threads_interrupt_mutex;

/* Mutex protecting access to nbr_threads local variable */
static pthread_mutex_t threads_mutex;

/* Mutex protecting the this-parameter at thread creation */
static pthread_mutex_t this_param_mutex;

/* Condition to wake up C main thread when any other thread exits */
static pthread_cond_t gc_threadhasdied_cond;

/* Variable that stores the range of priorities in posix */
static int pr_step_posix;

/* Variable that stores the range of priorities in JAVA */
static int pr_step_java;

/* Thread specific data key (TSD), needed in the implementation of currentThread */
pthread_key_t tsd_key;

/* Attribute specifying that the priority is inherited from the creator thread */
pthread_attr_t attr;


/* Static reference to hold argument list for main */
GC_REF(RefArray, args);

/* Data structure used by join(long millis) and join(long millis,int nanos) */
struct timedjoin_data {
	pthread_t target;
	pthread_mutex_t lock;
	pthread_cond_t cond;
	struct timespec time;
};

typedef struct thread_interrupt_data_t {
  pthread_mutex_t mutex;
  pthread_cond_t cond;
} thread_interrupt_data_t;

/* Function increasing the number of C threads alive */
void init_rt_scheduling() {
	int policy;
	struct sched_param param;
	/* Java priority to Posix priority */
	param.sched_priority = javaPr2schedPr(_RT_NORMAL_PR_JAVA,_RT_SCHEDULING_POSIX);
	if (pthread_setschedparam_rt(pthread_self_rt(),_RT_SCHEDULING_POSIX,&param) != 0) 
		printf("Error pthread_setschedparam()\n");
	if (pthread_attr_init_rt(&attr) !=0)
		printf("Error pthread_attr_init()\n");	
	if (pthread_attr_setinheritsched_rt(&attr,PTHREAD_INHERIT_SCHED) !=0) 
		printf("Error pthread_attr_setinheritsched()\n");
}

/* /\* Native implementation of java.lang.Thread.setPriority() *\/ */

/* GC_PROC_BEGIN(java_lang_Thread_setPriority_int,GC_PARAM(java_lang_Thread,this),JInt priority)  EXCEPTION_THROWS */
/*   GC_PARAM_REF(java_lang_Thread,this); */
/*   GC_PUSH_PARAM(this); */
/*   GC_FUNC_ENTER */
/*   struct sched_param param; */
/*   JInt policy; */
/*   JLong tmp; */
/*   JInt status; */
/*   if (priority > 10 || priority < 1) { */
/*     EXCEPTION_THROW(JAVA_LANG_ILLEGALARGUMENTEXCEPTION_INDEX) */
/*   } */
/*   else { */
/*     GC_SET(this,_java_lang_Thread_priority,priority); */
/*     if(__thread_is_started){ */
/* 	 GC_GET(tmp,this,_java_lang_Thread_target); */
/* 	 param.sched_priority = javaPr2schedPr(priority,_RT_SCHEDULING_POSIX); */
/* 	 if ((status = pthread_setschedparam_rt(tmp,_RT_SCHEDULING_POSIX,&param)) != 0 && status != ESRCH) { */
/* 	 	printf("pthread_setschedparam() %d[%d,%d]\n",param.sched_priority,sched_get_priority_min(_RT_SCHEDULING_POSIX),sched_get_priority_max(_RT_SCHEDULING_POSIX)); */
/* 	} */
/*     } else { */
/* //      printf("setPriority: delaying priority %d\n", priority); */
/*     } */
/*   } */
/*   GC_FUNC_LEAVE; */
/*   GC_POP_PARAM(this); */
/* GC_PROC_END(java_lang_Thread_setPriority_int) */
 
/* void *thread_pthread_main_start(void *gc_param_ithis) */
/* { */
/* 	/\* GC_THREAD_INIT declares gc_thread_t gc_thread *\/ */
/*    GC_THREAD_INIT */
/*      { */
/* 	thread_interrupt_data_t interrupt_data; */

/* 	GC_PARAM_REF(java_lang_Thread, ithis); */
/*  	GC__GET_THREAD_ROOT; */
/* 		GC_PUSH_PARAM(ithis); */
/* 		{ */
/* 		  GC_REF(java_lang_Thread, this); */
/* 		  GC_PUSH_ROOT(this); */
/* 		  GC_ASSIGN(this, ithis); */
/* 		  pthread_mutex_unlock_rt(&this_param_mutex); */
/* 		  pthread_mutex_init(&interrupt_data.mutex, 0); */
/* 		  pthread_cond_init(&interrupt_data.cond, 0); */
      
/* 	      	  GC_ASSIGN(gc_thread.javaThis,this); */
/* 		  gc_thread.this = (GC___REF(ObjectHead)) this->ref;     */
/* 		{ */
/* 	  	  int status; */
/* 		  gc_thread_t *tsd; */
/* 	  	  /\* Data specific *\/	 */
/* 		  if ((status = pthread_setspecific(tsd_key,&gc_thread)) != 0) 	 */
/* 		  		printf("Error pthread_setspecific()\n");    	 */
/* 	     tsd = (gc_thread_t*) pthread_getspecific(tsd_key); */
/* 	     tsd->semObj = &interrupt_data; */
/* 	     GC_SET(this,_java_lang_Thread_TSD,tsd); */
/* 		} */
/* 		GC_SET(this,_java_lang_Thread_target,(long) pthread_self()); */

/* 	GC_PROC_CALL(java_lang_Thread_setPriority_int,GC_PASS(this),_RT_NORMAL_PR_JAVA);	  */
/* #ifdef GC_PRINT_DEBUG */
/* #endif */
/* 	Fields_Init(); */
/* /\* 	GC_PROC_CALL(JAVAMAIN,GC_PASS(this)); *\/ */
/* 	GC_PROC_CALL(JAVAMAIN,GC_PASS(args)); */
/* #ifdef GC_PRINT_DEBUG */
/* #endif */
/* 	dec_threads(); */
/* 	GC_POP_ROOT(this); */
/* 	  } */
/*       GC_POP_PARAM(ithis); */
/* 	}	 */
/*   GC_THREAD_EXIT */
/*     } */


/* GC_PROC_BEGIN(create_main_thread) */
/*   GC_FUNC_ENTER */
/*   pthread_t t; */
/*   GC_REF(java_lang_Thread,main_thread); */
/*   GC_PUSH_ROOT(main_thread); */
/*   GC_REF_FUNC_CALL(main_thread,java_lang_Thread_Thread,&java_lang_Thread_Class,GC_PASS(java_lang_Thread_Layout));   */
/*   inc_threads(); */
/*   gc_lock(); */
/*   pthread_mutex_lock_rt(&this_param_mutex); */
/*   pthread_create(&t, 0, thread_pthread_main_start, GC_PASS(main_thread)); */
/*   gc_unlock();   */
/* pthread_mutex_lock_rt(&this_param_mutex); */
/* pthread_mutex_unlock_rt(&this_param_mutex); */
/*   GC_POP_ROOT(main_thread); */
/*   GC_FUNC_LEAVE; */
/* GC_PROC_END(create_main_thread) */

int main(int argc, char **argv) {
  GC_INIT(GC_HEAPSIZE);
  {
    int i;
    GC__IMPL_REF(ObjectHead,__eFlag__);
    GC_PUSH_STATIC_ROOT(__eFlag__);
/*     int __eFlag__ = 0; */
	  nbr_threads = 0;
	  pthread_mutex_init_rt(&threads_mutex,0);
	  pthread_mutex_init_rt(&threads_interrupt_mutex,0);
	  pthread_cond_init_rt(&gc_threadhasdied_cond, NULL);
	  if (pthread_key_create(&tsd_key,NULL) != 0)	
  		printf("Error pthread_key_create()\n");
	  javaClasses_Init();

	  GC_PUSH_STATIC_ROOT(args);
	  GC_REF_FUNC_CALL(args,newRefArray,argc-1);
	  for (i=1; i<argc; i++) {
	    GC_REF(java_lang_String,s);
	    GC_PUSH_STATIC_ROOT(s);
	    GC_REF_FUNC_CALL(s,
			     java_lang_String_String_CCharArray,
			     &java_lang_String_Class,
			     GC_PASS(java_lang_String_Layout),argv[i]);
	    GC_SET_REF_ARRAY(args,i-1,s);
	    GC_POP_STATIC_ROOT(s);
	  }

	  GC_PROC_CALL(create_main_thread);
	  //JAVAMAIN();
//	  printf("Waiting for threads to die\n");
	  wait_for_all_threads_to_die(); 
//	  printf("All threads dead\n");
  }
  GC_EXIT;
  return 0;
}

* Aux Native functions */
/*result=((i * (abs(POSIX_SUP-POSIX_INF)))/(JAVA_SUP-JAVA_INF))-(abs(POSIX_INF)+((abs(POSIX_SUP-POSIX_INF))/(JAVA_SUP-JAVA_INF)));*/

/* Native implementation of java.lang.start() */

GC_PROC_BEGIN(java_lang_Thread_start,GC_PARAM(java_lang_Thread,this))
     GC_PARAM_REF(java_lang_Thread,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER 
	{
	  int status;
	  pthread_t t;
	  static int count;

	  inc_threads();
	  pthread_mutex_lock_rt(&this_param_mutex);
	  gc_lock();
	  if (pthread_create(&t, 0, thread_pthread_do_start, GC_PASS(this))) {
	    printf("Error pthread_create()\n");	  
	  }
	  //printf("Thread created\n");
	  gc_unlock();	  
	  pthread_mutex_lock_rt(&this_param_mutex);
	  pthread_mutex_unlock_rt(&this_param_mutex);
	  GC_SET(this,_java_lang_Thread_target,(long) t);	  
	  //printf("exit Thread.start()\n");
	  // HERE BE DRAGONS
      #ifdef __SOLARIS__
      	thr_setconcurrency(count+2);
	  #endif	  
	}	
	
     GC_FUNC_LEAVE;
     GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_start)


/* Native implementation of java.lang.Thread.currentThread() */

GC_REF_FUNC_BEGIN(java_lang_Thread,java_lang_Thread_currentThread)
  GC_FUNC_ENTER
  GC_REF(java_lang_Thread,tmp);
  GC_PUSH_ROOT(tmp);
  {	
  	gc_thread_t *obj;
	obj = (gc_thread_t*) pthread_getspecific(tsd_key);
	GC_ASSIGN(tmp,obj->javaThis);
    GC_RETURN_REF(tmp);
  }  
  GC_POP_ROOT(tmp);
  GC_FUNC_LEAVE;
GC_REF_FUNC_END(java_lang_Thread,java_lang_Thread_currentThread)

* Native implementation of java.lang.Thread.join() */

GC_PROC_BEGIN(java_lang_Thread_join,GC_PARAM(java_lang_Thread,this))
  GC_PARAM_REF(java_lang_Thread,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  JLong tmp;
  JInt status;
#ifdef __RTAI__
  gc_thread_t *tsd;
#endif
  GC_GET(tmp,this,_java_lang_Thread_target);
  GC_POP_PARAM(this);
#ifdef __RTAI__
  tsd = (gc_thread_t*) pthread_getspecific(tsd_key);
  tsd->semObj = -2;     
#endif  
  if ((status = pthread_join_rt(tmp,0)) != 0 && status != ESRCH && status != EINVAL) printf("Error pthread_join() %d [%d,%d]\n",status,ESRCH,EINVAL);
#ifdef __RTAI__
  tsd->semObj = 0;     
#endif    
  GC_FUNC_LEAVE;  
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_join)


/* Auxiliar functions for join(long millis) and join(long millis,int nanos) */

void interruptible_join(struct timedjoin_data* data) {
	struct sched_param param;
	int policy;
   if (pthread_getschedparam_rt(pthread_self_rt(),&policy,&param) != 0) printf("Error pthread_getschedparam()\n");
	RTAI_REGISTER_THREAD(param.sched_priority);
	pthread_join_rt(data->target,0);
	pthread_cond_signal_rt(&data->cond);
	RTAI_UNREGISTER_THREAD
}

void timedjoin_end(pthread_t* th) {
#if HAS_EXCEPTIONS == 1
	pthread_cancel_rt(*th);
	/* Free thread's resources */
	pthread_join_rt(*th,0);
#endif
}

/* Native implementation of java.lang.Thread.join(long millis) */

GC_PROC_BEGIN(java_lang_Thread_join_long,GC_PARAM(java_lang_Thread,this),JLong millis)
  GC_PARAM_REF(java_lang_Thread,this);  
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  struct timedjoin_data data;
  struct timeval tp;
  pthread_t th;	
  JBoolean has_been_interrupted;
  GC_REF(java_lang_Thread,tmp);
  gc_thread_t *tsd;
  pthread_mutex_init_rt(&data.lock,0);
  pthread_cond_init_rt(&data.cond,0);
  data.target = 0;
  GC_GET(data.target,this,_java_lang_Thread_target);
  gettimeofday(&tp,0);
  data.time.tv_sec  = (millis / MS)+ tp.tv_sec;
  data.time.tv_nsec = (millis % MS) * NS_MS + tp.tv_usec * MS;
  if (pthread_create_rt(&th,0,(void*)interruptible_join,(void*)&data) != 0)   
  		printf("Error pthread_create()<join>\n");	
  pthread_cleanup_push_rt(timedjoin_end,(void*)&th);
  tsd = (gc_thread_t*) pthread_getspecific(tsd_key);
  tsd->semObj = &data.cond;     
  pthread_cond_timedwait_rt(&data.cond,&data.lock,&data.time);
  pthread_cleanup_pop_rt(0); /* timedjoin_end is executed always */
  pthread_cancel_rt(th);
  tsd->semObj = 0;
  GC_PUSH_ROOT(tmp);
  GC_REF_FUNC_CALL(tmp,java_lang_Thread_currentThread);
  GC_GET(has_been_interrupted,tmp,_java_lang_Thread_interruptedFlag);
  GC_POP_ROOT(tmp); 
  if (has_been_interrupted) { 
//    GC_PROC_CALL(interrupter_impl);		
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_join_long)

/* Native implementation of java.lang.Thread.join(long millis, int nanos) */

GC_PROC_BEGIN(java_lang_Thread_join_long_int,GC_PARAM(java_lang_Thread,this),JLong millis,JInt nanos)
  GC_PARAM_REF(java_lang_Thread,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  struct timedjoin_data data;
  struct timeval tp;
  pthread_t th;	  
  pthread_mutex_init_rt(&data.lock,0);
  pthread_cond_init_rt(&data.cond,0);
  data.target = 0;
  GC_GET(data.target,this,_java_lang_Thread_target);
  gettimeofday(&tp,0);
  data.time.tv_sec  = (millis / MS) + tp.tv_sec;
  data.time.tv_nsec = (millis % MS) * NS_MS + nanos + tp.tv_usec * MS;
  if (pthread_create_rt(&th,0,(void*)interruptible_join,(void*)&data) != 0)   
  		printf("Error pthread_create()<join>\n");	
  pthread_cleanup_push_rt(timedjoin_end,(void*)&th);
  pthread_cond_timedwait_rt(&data.cond,&data.lock,&data.time);
  pthread_cleanup_pop_rt(1); /* timedjoin_end is executed always */
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_join_long_int)

GC_PROC_BEGIN(java_lang_Thread_yield)
  GC_FUNC_ENTER;
  sched_yield();
  GC_FUNC_LEAVE;
GC_PROC_END(java_lang_Thread_yield)

#endif
