#include <gc.h>
#include <gci_common.h>
#include <exception.h>
#include <javatypes.h>

#include <unistd.h>
#include <sys/socket.h>

#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <stdio.h>

#ifdef JAVA_IO_IOEXCEPTION_INDEX
#include <java_io_IOException.h>
#endif

/* Need this to create strings... */
extern struct java_lang_String_ClassStruct java_lang_String_Class;
extern GC_REF(LayoutHead, java_lang_String_Layout);
/* and Exceptions */
extern struct java_io_IOException_ClassStruct java_io_IOException_Class;
extern GC_REF(LayoutHead,java_io_IOException_Layout);

GC_PROC_BEGIN(java_net_Socket_close_int,
		JInt sockfd)
	GC_FUNC_ENTER
{
	shutdown(sockfd, SHUT_RDWR);
	close(sockfd);
}
	GC_FUNC_LEAVE;
GC_PROC_END(java_net_Socket_close)


GC_VAR_FUNC_BEGIN(JInt,
		java_net_Socket_createSocket)
	GC_FUNC_ENTER;
{
	int sockfd;
	sockfd = socket(PF_INET, SOCK_STREAM, 0);
	GC_RETURN_VAR((JInt) sockfd);
}
	GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JInt, java_net_Socket_createSocket)

GC_PROC_BEGIN(java_net_Socket_connect_int_int_int_int,
		JInt sockfd,
		JInt adr,
		JInt port,
		JInt timeout) EXCEPTION_THROWS
	GC_FUNC_ENTER;
{
	printf("native connecting...\n");
	struct sockaddr_in	dest_addr;

	/* FIXME: This needs cleaning up! */
	/*printf("IP Address : %s\n", inet_ntoa(*((struct in_addr *)&adr)));*/
	dest_addr.sin_family = AF_INET;
	dest_addr.sin_port = htons(port);
	dest_addr.sin_addr.s_addr = adr;
	memset(dest_addr.sin_zero, '\0', sizeof(dest_addr.sin_zero));
	//dest_addr.sin_addr.s_addr = inet_addr(DEST_IP);
	//dest_addr.sin_addr = *((struct in_addr *)adr);
	//dest_addr.sin_addr = *((struct in_addr *)he->h_addr);

	int result = connect((int)sockfd, (struct sockaddr *)&dest_addr, sizeof(struct sockaddr));
	if (result == -1) {
		perror("java.net.Socket native connect");
		const char* error;

		/* FIXME: strerror_r not available on CRIS! */
		error = strerror(errno);
		GC_REF(java_io_IOException, exception);
		GC_REF(java_lang_String, errmsg);
		GC_PUSH_ROOT(exception);
		GC_PUSH_ROOT(errmsg);
		GC_REF_FUNC_CALL(errmsg,
				java_lang_String_String_CCharArray,
				&java_lang_String_Class,
				GC_PASS(java_lang_String_Layout),
				error);CHECK(0);

		GC_REF_FUNC_CALL(exception,
				java_io_IOException_IOException_java_lang_String,
				&java_io_IOException_Class,
				GC_PASS(java_io_IOException_Layout), 
				GC_PASS(errmsg));
		GC_POP_ROOT(errmsg);
		EXCEPTION_STORE_OBJ(exception);
		GC_POP_ROOT(exception);
		EXCEPTION_THROW(0, &java_io_IOException_Class);
	}

}
	GC_FUNC_LEAVE;
GC_PROC_END(java_net_Socket_connect_int_int_int_int)

