#include <gc.h>
#include <javatypes.h>
#include <stddef.h>
#include <java_lang_String.h>
/* #include <throttlenet.h> */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if GC_ALGORITHM == GC_ALGORITHM_INCREMENTAL_MS_NONMOVING
//#define __NONMOVING__
#endif

//private native int initTransmitSocket(String dstName, int size, int period_us);
GC_VAR_FUNC_BEGIN(JInt, se_lth_cs_throttlenet_ThrottleNetTransmitSocket_initTransmitSocket_java_lang_String_int_int,
				  GC_PARAM(se_lth_cs_throttlenet_ThrottleNetTransmitSocket, this),
				  GC_PARAM(java_lang_String, dstName), JInt size, JInt period_us)
	GC_PARAM_REF(se_lth_cs_throttlenet_ThrottleNetTransmitSocket, this);
	GC_PARAM_REF(java_lang_String, dstName);
	GC_PUSH_PARAM(this);
	GC_PUSH_PARAM(dstName);
	GC_FUNC_ENTER {
		JInt socket;
		JInt length, i = 0;
		char* newname;
		GC_REF(JCharArray, name);
		GC_PUSH_ROOT(name);
		printf("!!! ThrottleNetTransmitSocket.<init> not implemented correct for pthreads\n");
		GC_GET_REF(name, dstName, _java_lang_String_data);
		GC_GET(length, name, _JCharA_length);
#ifdef __NONMOVING__
/* 		socket = throttlenet_open_transmit_socket(GC___PTR(name->ref)->data, size, period_us); */
#else
		newname = malloc(sizeof(char) * length);
		gc_lock();
		for (i=0; i<length; i++) {
			newname[i] = (char)GC___PTR(name->ref)->data[i].bytes;
		}
		gc_unlock();
/* 		socket = throttlenet_open_transmit_socket(newname, size, period_us); */
		free(newname);
#endif
		GC_POP_ROOT(name);
		GC_RETURN_VAR(socket);
	} GC_FUNC_LEAVE
	GC_POP_PARAM(dstName);
	GC_POP_PARAM(this);
GC_VAR_FUNC_END(JInt, se_lth_cs_throttlenet_ThrottleNetTransmitSocket_initTransmitSocket_java_lang_String_int_int)


//private native int transmitData(int socket, byte[] data, int length) throws IOException;
GC_VAR_FUNC_BEGIN(JInt, se_lth_cs_throttlenet_ThrottleNetTransmitSocket_transmitData_int_byteA_int,
				  GC_PARAM(se_lth_cs_throttlenet_ThrottleNetTransmitSocket, this),
				  JInt socket, GC_PARAM(JByteArray, data), JInt length)
	GC_PARAM_REF(se_lth_cs_throttlenet_ThrottleNetTransmitSocket, this);
	GC_PARAM_REF(JByteArray, data);
	GC_PUSH_PARAM(this);
	GC_PUSH_PARAM(data);
	GC_FUNC_ENTER {
		JInt n, i;
		printf("!!! ThrottleNetTransmitSocket.transmitData() not implemented correct for pthreads\n");
#ifdef __NONMOVING__
/* 		n = throttlenet_transmit(socket, GC___PTR(data->ref)->data, length); */
#else
		char* newdata = malloc(sizeof(char) * length);
		gc_lock();
		for (i=0; i<length; i++) {
			char c;
			newdata[i] = (char)GC___PTR(data->ref)->data[i].bytes;
		}
		gc_unlock();
/* 		n = throttlenet_transmit(socket, newdata, length); */
		free(newdata);
#endif
		GC_RETURN_VAR(n);
	} GC_FUNC_LEAVE
	GC_POP_PARAM(data);
	GC_POP_PARAM(this);
GC_VAR_FUNC_END(JInt, se_lth_cs_throttlenet_ThrottleNetTransmitSocket_transmitData)


// private native void closeSocket(int socket);
// throttlenet_close_transmit_socket(socket);
GC_PROC_BEGIN(se_lth_cs_throttlenet_ThrottleNetTransmitSocket_closeSocket_int,
				  GC_PARAM(se_lth_cs_throttlenet_ThrottleNetTransmitSocket, this),
				  JInt socket)
	GC_PARAM_REF(se_lth_cs_throttlenet_ThrottleNetTransmitSocket, this);
	GC_PUSH_PARAM(this);
	GC_FUNC_ENTER {
		printf("!!! ThrottleNetTransmitSocket.closeSocket() not implemented correct for pthreads\n");
		//throttlenet_close_transmit_socket(socket);
	} GC_FUNC_LEAVE
	GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_throttlenet_ThrottleNetTransmitSocket_closeSocket_int)





