#ifndef CPU_UTILIZATION_LOGGER
#define CPU_UTILIZATION_LOGGER

#include <linux/proc_fs.h>
#include <rtai_proc_fs.h>
#include <rtai_sched.h>

#define SAMPLE_RATE 0
#define GC_CYCLE 1
#define LOCK_COUNTING 0
#define DELAY_MEASURE 0 // 0 av, 1 lock(), 2 after lock() -> before unlock()
#define CPU_TIME 0

#define MAX_NBR_OF_ID 10

#if DELAY_MEASURE > 0
#define DELAY_SLOTS 1000
#define DELAY_SLOTSIZE 512
#endif


int cpu_utilization_logger_read_proc(char *page, char **start, off_t off,
				  int count, int *eof, void *data);
void cpu_utilization_logger_init_proc();
void cpu_utilization_logger_init();
void cpu_utilization_logger_remove_proc();
void cpu_utilization_logger_addNamedTask(RT_TASK *task, char *taskname);
void cpu_utilization_logger_addTask(RT_TASK *task);
#if DELAY_MEASURE == 1
void cpu_utilization_logger_logg(long delay);
#elif DELAY_MEASURE == 2
void cpu_utilization_logger_startLockTimer();
void cpu_utilization_logger_stopLockTimer();
#endif
#if LOCK_COUNTING > 0
void cpu_utilization_logger_loggLock();
void cpu_utilization_logger_loggLazyLock();
#endif
#if CPU_TIME > 0
void cpu_utilization_logger_setGCRunning();
void cpu_utilization_logger_setGCnotRunning();
void cpu_utilization_logger_printMyNumber();
#endif
#endif
