#include <gc.h>
#include <gci_common.h>
#include <exception.h>
#include <javatypes.h>

//#include <sys/types.h>
//#include <netdb.h>

#include <net.h>
#include <net/sock.h>

//#include <in.h>
//#include <socket.h>
//#include <inet.h>
//#include <tcp.h>
//#include <fcntl.h>

#define PORT 44444

struct socket* sock = NULL;
struct socket* new_sock = NULL;
int sock_fd;
struct sockaddr_in sa;
int connected_tcp_fd;

GC_VAR_FUNC_BEGIN(JLong, java_net_ServerSocket_createServerSocket_int,GC_PARAM(java_lang_Object,this),JInt port) //EXCEPTION_THROWS
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  {
	int error_no;
	int sizeof_sa;

	//initialize sockaddr-struct
	printk("createServerSocket - 01\n");
	sa.sin_family=AF_INET;
	sa.sin_port=htons((unsigned short)PORT);
	sa.sin_addr.s_addr=INADDR_ANY;
	
	printk("createServerSocket - 02 - port: %d\n", (unsigned short) PORT);
	//create socket and bind it to specified port.
	//sock_fd = socket(PF_INET,SOCK_STREAM,IPPROTO_TCP);

	sock_create(PF_INET,SOCK_STREAM,IPPROTO_TCP,&sock);

	printk("createServerSocket - 02.5 - FileDesc: %d\n", sock_fd);
	//printk("EINVAL:%d, EPROTONOSUPPORT:%d, EAFNOSUPPORT:%d, ENFILE:%d, EMFILE:%d EACCES:%d, ENOMEM:%d, ENOBUFS:%d\n", EINVAL, EPROTONOSUPPORT, EAFNOSUPPORT, ENFILE, EMFILE, EACCES, ENOMEM, ENOBUFS);

	//error_no = bind(sock_fd, (struct sockaddr *) &sa, sizeof(sa));
	error_no = sock->ops->bind(sock, (struct sockaddr*) &sa, sizeof(sa));

	printk("Bind error: %d\n",error_no);
	printk("createServerSocket - 03\n");
	//se the socket in listenstate
	//error_no = listen(sock_fd,SOMAXCONN);
	error_no = sock->ops->listen(sock,48);
	printk("listen error: %d\n",error_no);
	sock_fd = 0;//sock_map_fd(sock);
	GC_RETURN_VAR((JLong)sock_fd);
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_VAR_FUNC_END(JLong, java_net_ServerSocket_createServerSocket_int)

GC_VAR_FUNC_BEGIN(JLong, java_net_ServerSocket_accept_long,GC_PARAM(java_lang_Object,this),JLong fd) //EXCEPTION_THROWS
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  {
	//Blocking call waiting for connection...
        printk("accept - 01\n");
        new_sock = sock_alloc();
	printk("accept - 02\n");
        new_sock->type = sock->type;
	printk("accept - 03\n");
        new_sock->ops = sock->ops;
	//int sizeof_sa = sizeof(sa);
	//connected_tcp_fd = accept((int)fd,(struct sockaddr *)&sa, &sizeof_sa);
	printk("accept - 04 - sock:%x, new_sock:%x\n",sock, new_sock);
        sock->ops->accept(sock,new_sock,0); 
	printk("accept - 05\n");
        connected_tcp_fd = 0; //sock_map_fd(new_sock);
	printk("accept - 06\n");
        
	GC_RETURN_VAR((JLong)connected_tcp_fd);
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_VAR_FUNC_END(JLong, java_net_ServerSocket_accept)

GC_PROC_BEGIN(java_net_ServerSocket_close,GC_PARAM(java_lang_Object,this))// EXCEPTION_THROWS
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  {
        int err;
	//struct socket* sock = sock_fd_lookup(sock_fd, &err);
	sock_release(sock);
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_net_ServerSocket_close)

