#include <class_indices.h>

#ifdef SE_LTH_CS_REALTIME_SEMAPHORE_BINARYSEM_INDEX

#include <rtai_sched.h>
#include <gc.h>
#include <gci_thread.h>
#include <javatypes.h>
#include <se_lth_cs_realtime_semaphore_BinarySem.h>

#ifdef GC_HAS_FINALIZERS
static void dealloc_sem(se_lth_cs_realtime_semaphore_BinarySem *this){
#ifdef GC_PRINT_DEBUG
    printk("freed semaphore: %x\n", this->_se_lth_cs_realtime_semaphore_BinarySem_target);
#endif
        kfree(this->_se_lth_cs_realtime_semaphore_BinarySem_target);
}
#endif

GC_VAR_FUNC_BEGIN(JLong,se_lth_cs_realtime_semaphore_BinarySem_createBinarySem_int,GC_PARAM(se_lth_cs_realtime_semaphore_BinarySem,this),JInt iValue)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_BinarySem,this);
     GC_PUSH_PARAM(this);
GC_FUNC_ENTER
  SEM* sem;
  sem = kmalloc(sizeof(SEM),0);//???
  rt_typed_sem_init(sem,iValue,BIN_SEM);
#ifdef GC_HAS_FINALIZERS
  GC_SET_FINALIZER(this, dealloc_sem);
#endif

#ifdef HOST_PPC
  GC_RETURN_VAR(*(JLong*) ((void *)sem));
#else
  GC_RETURN_VAR((JLong) sem);
#endif
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_VAR_FUNC_END(JLong,se_lth_cs_realtime_semaphore_BinarySem_createBinarySem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_BinarySem_giveBinarySem_long,GC_PARAM(se_lth_cs_realtime_semaphore_BinarySem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_BinarySem,this);
     GC_PUSH_PARAM(this);
GC_FUNC_ENTER
  rt_sem_signal((SEM*)target);
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(_se_lth_cs_realtime_semaphore_BinarySem_giveBinarySem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_BinarySem_takeBinarySem_long,GC_PARAM(se_lth_cs_realtime_semaphore_BinarySem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_BinarySem,this);
     GC_PUSH_PARAM(this);
GC_FUNC_ENTER
  //printk("takeBinarySem returned %x\n", rt_sem_wait((SEM*)target));
  HACK_ENSURE_UNLOCK
  rt_sem_wait((SEM*)target);
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(_se_lth_cs_realtime_semaphore_BinarySem_takeBinarySem_int)

#endif
