#include <class_indices.h>

#ifdef SE_LTH_CS_REALTIME_SEMAPHORE_COUNTINGSEM_INDEX

#include <gc.h>
#include <gci_thread.h>
//#include <pthread.h>
#include <javatypes.h>
//#include <semaphore.h>
#include <se_lth_cs_realtime_semaphore_CountingSem.h>
#include <rtai_sched.h>

#ifdef GC_HAS_FINALIZERS
static void dealloc_sem(se_lth_cs_realtime_semaphore_CountingSem *this){
#ifdef GC_PRINT_DEBUG
    printk("freed semaphore: %x\n", this->_se_lth_cs_realtime_semaphore_CountingSem_target);
#endif
        kfree(this->_se_lth_cs_realtime_semaphore_CountingSem_target);
}
#endif

GC_VAR_FUNC_BEGIN(JLong,se_lth_cs_realtime_semaphore_CountingSem_createCountingSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),JInt iValue)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
     GC_PUSH_PARAM(this);
GC_FUNC_ENTER
  SEM* sem;
  sem = kmalloc(sizeof(SEM),0);//???
  rt_typed_sem_init(sem,iValue,CNT_SEM);
#ifdef GC_HAS_FINALIZERS
#ifdef GC_PRINT_DEBUG
    printf("Allocated semaphore: %x\n", sem);
#endif
  GC_SET_FINALIZER(this, dealloc_sem);
#endif
  //printk("CountingSem.createCountingSem: target = %x\n",sem);
  //printk("CountingSem.createCountingSem: target = %d (%x)\n",*(JLong*) ((void *)&sem),*(JLong*) ((void *)&sem));
#ifdef HOST_PPC
// ***************************************************************
// HERE BE DRAGONS!!! How can this possibly work? (it seems to...) 
// It seems to be a dereference too many... But if the next line
// is changed to &sem the semaphore stops working... I'm confused
  GC_RETURN_VAR(*(JLong*) ((void *)sem));
// ***************************************************************
#else
  GC_RETURN_VAR((JLong) sem);
#endif
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_VAR_FUNC_END(JLong,se_lth_cs_realtime_semaphore_CountingSem_createCountingSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_CountingSem_giveCountingSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
  //printk("CountingSem.giveCountingSem: target = %x\n",(SEM*) target);
  //printk("CountingSem.giveCountingSem: target = %d (%x)\n", target, target);
  rt_sem_signal((SEM*)target);
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_realtime_semaphore_CountingSem_giveCountingSem_long)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_CountingSem_takeCountingSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
     GC_PUSH_PARAM(this);
GC_FUNC_ENTER
  //printk("CountingSem.takeCountingSem: target = %x\n",(SEM*) target);
  //printk("CountingSem.takeCountingSem: target = %d (%x)\n", target, target);
  //printk("takeCountingSem returned %x\m", rt_sem_wait((SEM*)target));
  HACK_ENSURE_UNLOCK
  rt_sem_wait((SEM*)target);
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_realtime_semaphore_CountingSem_takeCountingSem_long)

#endif
