#include <class_indices.h>

#ifdef SE_LTH_CS_REALTIME_SEMAPHORE_MUTEXSEM_INDEX

#include <gc.h>
#include <javatypes.h>
#include <se_lth_cs_realtime_semaphore_MutexSem.h>
#include <rtai_sched.h>

#ifdef GC_HAS_FINALIZERS
static void dealloc_sem(se_lth_cs_realtime_semaphore_MutexSem *this){
#ifdef GC_PRINT_DEBUG
    printk("freed semaphore: %x\n", this->_se_lth_cs_realtime_semaphore_MutexSem_target);
#endif
        kfree(this->_se_lth_cs_realtime_semaphore_MutexSem_target);
}
#endif


GC_VAR_FUNC_BEGIN(JLong,se_lth_cs_realtime_semaphore_MutexSem_createMutexSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),JInt iValue)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
     GC_PUSH_PARAM(this);
GC_FUNC_ENTER
  SEM* sem;
  sem = kmalloc(sizeof(SEM),0);//???
  rt_typed_sem_init(sem,iValue,RES_SEM);
#ifdef GC_HAS_FINALIZERS
  GC_SET_FINALIZER(this, dealloc_sem);
#endif
  //rt_typed_sem_init(sem,1,CNT_SEM);
  //printk("MutexSem.createMutexSem: sem = %d (%x)\n", sem, sem);
#ifdef HOST_PPC
  GC_RETURN_VAR(*(JLong*) ((void *)sem));
#else
  GC_RETURN_VAR((JLong) sem);
#endif
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_VAR_FUNC_END(JLong,se_lth_cs_realtime_semaphore_MutexSem_createMutexSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_MutexSem_giveMutexSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
     GC_PUSH_PARAM(this);
GC_FUNC_ENTER
  //printk("MutexSem.giveMutexSem: target = %d (%x)\n", target, target);
  //printk("giveMutexSem returned %x\n", rt_sem_signal((SEM*)target));
  rt_sem_signal((SEM*)target);
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(_se_lth_cs_realtime_semaphore_MutexSem_giveMutexSem_long)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_MutexSem_takeMutexSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),JLong target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
     GC_PUSH_PARAM(this);
GC_FUNC_ENTER
  //JLong t;
  //GC_GET(t,this,_se_lth_cs_realtime_semaphore_MutexSem_target);
  //printk("MutexSem.takeMutexSem: target = %d (%x)\n", target, target);
  //printk("takeMutexSem returned %x\n",rt_sem_wait((SEM*)target));
  rt_sem_wait((SEM*)target);
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_realtime_semaphore_MutexSem_takeMutexSem_long)

#endif
