#include <gc.h>
#include <gci_thread.h>
#include <javatypes.h>
#include <stddef.h>
#include <java_lang_String.h>
#include <throttlenet.h>


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if GC_ALGORITHM == GC_ALGORITHM_INCREMENTAL_MS_NONMOVING
//#define __NONMOVING__
#endif

//private native int initReceiveSocket(String dstName, int size, int period_us, int deadline);
GC_VAR_FUNC_BEGIN(JInt, se_lth_cs_throttlenet_ThrottleNetReceiveSocket_initReceiveSocket_java_lang_String_int_int_int,
				  GC_PARAM(se_lth_cs_throttlenet_ThrottleNetReceiveSocket, this),
				  GC_PARAM(java_lang_String, dstName), JInt size, JInt period_us, JInt deadline)
	GC_PARAM_REF(se_lth_cs_throttlenet_ThrottleNetReceiveSocket, this);
	GC_PARAM_REF(java_lang_String, dstName);
	GC_PUSH_PARAM(this);
	GC_PUSH_PARAM(dstName);
	GC_FUNC_ENTER {
		JInt socket;
		JInt length, i = 0;
		char* newname;
		GC_REF(JCharArray, name);
		GC_PUSH_ROOT(name);
		GC_GET_REF(name, dstName, _java_lang_String_data);
		GC_GET(length, name, _JCharA_length);
#ifdef __NONMOVING__
		socket = throttlenet_open_receive_socket(GC___PTR(name->ref)->data, size, 
period_us); 
#else
		newname = kmalloc(sizeof(char) * length, 0);
		gc_lock();
		for (i=0; i<length; i++) {
			newname[i] = (char)GC___PTR(name->ref)->data[i].bytes;
		}
		gc_unlock();
		socket = throttlenet_open_receive_socket(newname, size, period_us);
		kfree(newname);
#endif
		GC_POP_ROOT(name);
		GC_RETURN_VAR(socket);
	} GC_FUNC_LEAVE
	GC_POP_PARAM(dstName);
	GC_POP_PARAM(this);
GC_VAR_FUNC_END(JInt, se_lth_cs_throttlenet_ThrottleNetReceiveSocket_initReceiveSocket_java_lang_String_int_int_int)


//private native int receiveData(int socket, byte[] data, int length) throws IOException;
GC_VAR_FUNC_BEGIN(JInt, se_lth_cs_throttlenet_ThrottleNetReceiveSocket_receiveData_int_byteA_int,
				  GC_PARAM(se_lth_cs_throttlenet_ThrottleNetReceiveSocket, this),
				  JInt socket, GC_PARAM(JByteArray, data), JInt length)
	GC_PARAM_REF(se_lth_cs_throttlenet_ThrottleNetReceiveSocket, this);
	GC_PARAM_REF(JByteArray, data);
	GC_PUSH_PARAM(this);
	GC_PUSH_PARAM(data);
	GC_FUNC_ENTER {
		JInt i, n = 0;
#ifdef __NONMOVING__
		n = throttlenet_receive(socket, GC___PTR(data->ref)->data, length);
#else
		char* newdata = kmalloc(sizeof(char) * length, 0);
		HACK_ENSURE_UNLOCK
		n = throttlenet_receive(socket, newdata, length);
		gc_lock();
		for (i=0; i<length; i++) {
			char c;
			GC___PTR(data->ref)->data[i].bytes = (JByte)newdata[i];
		}
		gc_unlock();
		kfree(newdata);
#endif
		GC_RETURN_VAR(n);
	} GC_FUNC_LEAVE
	GC_POP_PARAM(data);
	GC_POP_PARAM(this);
GC_VAR_FUNC_END(JInt, se_lth_cs_throttlenet_ThrottleNetReceiveSocket_receiveData_int_byteA_int)


// private native void closeSocket(int socket);
// throttlenet_close_receive_socket(socket);
GC_PROC_BEGIN(se_lth_cs_throttlenet_ThrottleNetReceiveSocket_closeSocket_int,
				  GC_PARAM(se_lth_cs_throttlenet_ThrottleNetReceiveSocket, this),
				  JInt socket)
	GC_PARAM_REF(se_lth_cs_throttlenet_ThrottleNetReceiveSocket, this);
	GC_PUSH_PARAM(this);
	GC_FUNC_ENTER {
		//throttlenet_close_receive_socket(socket);
	} GC_FUNC_LEAVE
	GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_throttlenet_ThrottleNetReceiveSocket_closeSocket_int)



