#include <gc.h>
#include <Kernel.h>
#include <Monitors.h>
#include <Semaphores.h>

// HERE BE DRAGONS! We need to know how a struct _Thread_ClassStruct looks
// in order to find the run method. This could maybe be fixed with a
// aux function getMethodPointer(char *className, char *methodName) or
// something like that.
// For now, we require that a (manually created) Thread.h exists
// #include "se_lth_cs_sven_Thread.h"
#include "compiled.h"

static int nbr_threads;
extern int hp_CBSh;
extern int lp_CBSh;

static Monitors_Monitor __thread_mon;
static Monitors_Event gc_threadhasdied_cond;
static Semaphores_Semaphore __pass_sem;
static void * __this_param;


/* HERE BE DRAGONS! Hack to make it compile */

_java_lang_Object_hashCode() {}
_java_lang_Object_notify() {}
_java_lang_Object_notifyAll() {}


void inc_threads() {
  Monitors_Enter(__thread_mon);
  nbr_threads++;
  Monitors_Leave(__thread_mon);
}

void dec_threads() {
  Monitors_Enter(__thread_mon);
  nbr_threads--;
  Monitors_Cause(gc_threadhasdied_cond);
  Monitors_Leave(__thread_mon);
}

void wait_for_all_threads_to_die() {
  Monitors_Enter(__thread_mon);
  while (nbr_threads) {
    // printf("Nbr of live threads before: %d\n",nbr_threads);
    Monitors_Await(gc_threadhasdied_cond);
    // printf("Nbr of live threads after: %d\n",nbr_threads);
  }
  Monitors_Leave(__thread_mon);
}
extern int gc_exited;
int foo_main() {
  GC_INIT(100000);
  LCS_Init();
#ifdef LOGGING  
  Measure_Init();
  log_init();
#endif  
  nbr_threads = 0;
  Monitors_New(&__thread_mon, "thread_mon", 11);
  Monitors_NewEvent(&gc_threadhasdied_cond, __thread_mon, "threadhasdied", 15);
  Semaphores_New(&__pass_sem, 1, "pass_sem", 9); 
  //Kernel_SetPriority(150L); 
  JAVAMAIN();
  //printf("Waiting for threads to die\n");
  wait_for_all_threads_to_die(); 
  printf("All threads dead\n");
  gc_exited = 1;	 // Tell GC thread to die
  Kernel_WaitTime(5000); // HERE BE DRAGONS! wait for the GC thread to die.
#ifdef LOGGING  
  Measure_Print();
  log_print();
#endif  
  GC_EXIT;
  return 0;
}

//void* thread_pthread_do_start(GC_PARAM(_Thread,this)) {
void thread_stork_do_start(void)
{
  void *gc_param_this = __this_param;
  GC_THREAD_INIT
  GC_PARAM_REF(se_lth_cs_sven_Thread, this);
  GC_PUSH_PARAM(this);
  //Kernel_SetPriority(50L);

    Semaphores_Signal(__pass_sem);
    /* GC_THREAD_INIT declares gc_thread_t gc_thread */
    gc_thread.this = (void *) GC_PASS(this);
    {
      struct se_lth_cs_sven_Thread_ClassStruct *_tmp_method;
      GC_GET(_tmp_method,this,class);
      GC_PROC_CALL(_tmp_method->methodTbl->run, GC_PASS(this));
      dec_threads();
    }

  GC_POP_PARAM(this);
  GC_THREAD_EXIT
}


GC_PROC_BEGIN(_se_lth_cs_sven_Thread_start,GC_PARAM(se_lth_cs_sven_Thread,this))
     GC_PARAM_REF(se_lth_cs_sven_Thread,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER
{
  char threadstr[] = "hp_thread_  ";
  threadstr[10] = (char) ('1' + nbr_threads);
  inc_threads();
  Semaphores_Wait(__pass_sem);
  gc_lock();
  __this_param = GC_PASS(this);
#if 1
  LCS_CreateTaskInCBS((PROC)thread_stork_do_start, 30000L, 
  //	(STRING)"java_thread", 12L, LCS_RelTime(1.0)
  //	(STRING)"java_thread", 12L, Times_Add(Times_Now(),Times_SecondsToDuration(0.1))
  	(STRING)threadstr, 13L, Times_Add(Times_Now(),Times_SecondsToDuration(0.1))
   	, Times_SecondsToDuration(0.0), hp_CBSh);
#endif
#if 0  
  Kernel_CreateProcess(thread_stork_do_start, 30000, "java_thread", 12);
#endif  
  gc_unlock();
  // HERE BE DRAGONS! Here we should remove the thread from the
  // thread root stack.
  //pthread_detach(t);
}

     GC_FUNC_LEAVE
     GC_POP_PARAM(this);
GC_PROC_END(__Thread_start)

GC_PROC_BEGIN(_se_lth_cs_sven_Thread_start_lp,GC_PARAM(se_lth_cs_sven_Thread,this))
     GC_PARAM_REF(se_lth_cs_sven_Thread,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER
{
  char threadstr[] = "lp_thread_  ";
  threadstr[10] = (char) ('1' + nbr_threads);
  inc_threads();
  Semaphores_Wait(__pass_sem);
  gc_lock();
  __this_param = GC_PASS(this);
#if 1
  LCS_CreateTaskInCBS((PROC)thread_stork_do_start, 30000L, 
  //	(STRING)"java_thread", 12L, LCS_RelTime(1.0)
  //	(STRING)"java_thread", 12L, Times_Add(Times_Now(),Times_SecondsToDuration(0.1))
  	(STRING)threadstr, 13L, Times_Add(Times_Now(),Times_SecondsToDuration(0.1))
   	, Times_SecondsToDuration(0.0), lp_CBSh);
#endif
#if 0  
  Kernel_CreateProcess(thread_stork_do_start, 30000, "java_thread", 12);
#endif  
  gc_unlock();
  // HERE BE DRAGONS! Here we should remove the thread from the
  // thread root stack.
  //pthread_detach(t);
}

     GC_FUNC_LEAVE
     GC_POP_PARAM(this);
GC_PROC_END(__Thread_start)

GC_PROC_BEGIN(_se_lth_cs_sven_Thread_sleep_long,long millis)
GC_FUNC_ENTER
{
        // HERE BE DRAGONS! Is the argument to WaitTime in milliseconds?
        Kernel_WaitTime(millis);
} 
 
GC_FUNC_LEAVE
GC_PROC_END(_se_lth_cs_sven_Thread_sleep_long)
  

