; some ports we will use
SPH = 0x3E
SPL = 0x3D
SREG = 0x3F

; these are offsets in the kernel thread structure
OFFSET_SPL = 10
OFFSET_SPH = 11

; called when a thread wants to give up it's time share
.global kernel_reschedule
.func kernel_reschedule
kernel_reschedule:
  cli

  ; store context
  push	r0
  push	r1
  push	r2
  push	r3
  push	r4
  push	r5
  push	r6
  push	r7
  push	r8
  push	r9
  push	r10
  push	r11
  push	r12
  push	r13
  push	r14
  push	r15
  push	r16
  push	r17
  push	r18
  push	r19
  push	r20
  push	r21
  push	r22
  push	r23
  push	r24
  push	r25
  push  r26
  push	r27
  push	r28
  push	r29
  push	r30
  push	r31

  in	r25, SREG
  push	r25

  rjmp	switch_continue

; timer interrupt handler
  .global __vector_default
__vector_default:	
  cli

  ; store context
  push	r0
  push	r1
  push	r2
  push	r3
  push	r4
  push	r5
  push	r6
  push	r7
  push	r8
  push	r9
  push	r10
  push	r11
  push	r12
  push	r13
  push	r14
  push	r15
  push	r16
  push	r17
  push	r18
  push	r19
  push	r20
  push	r21
  push	r22
  push	r23
  push	r24
  push	r25
  push  r26
  push	r27
  push	r28
  push	r29
  push	r30
  push	r31

  in	r25, SREG
  push	r25

  ; let Z point at tick counter
  ldi	r30, lo8(kernel_ticks)
  ldi	r31, hi8(kernel_ticks)

  ; increase tick counter by one
  ld	r25, Z
  subi	r25, 0xFF
  st	Z+, r25
  ld	r25, Z
  sbci	r25, 0xFF
  st	Z+, r25
  ld	r25, Z
  sbci	r25, 0xFF
  st	Z+, r25
  ld	r25, Z
  sbci	r25, 0xFF
  st	Z+, r25
  ; end increase tick

  ; save thread on ready queue
  ldi	r24, lo8(ready_queue)
  ldi	r25, hi8(ready_queue)
  lds	r22, current_thread
  lds	r23, current_thread+1
  call	pq_insert

switch_continue:
  ; save stack pointer
  lds	r30, current_thread
  lds	r31, current_thread+1
  in	r25, SPL
  std	Z+OFFSET_SPL, r25
  in	r25, SPH
  std	Z+OFFSET_SPH, r25

  ; do thread scheduling
  call	kernel_next_thread

  ; load stack pointer
  lds	r30, current_thread
  lds	r31, current_thread+1
  ldd	r25, Z+OFFSET_SPL
  out	SPL, r25
  ldd	r25, Z+OFFSET_SPH
  out	SPH, r25

  pop	r25
  out	SREG, r25

  pop	r31
  pop	r30
  pop	r29
  pop	r28
  pop	r27
  pop	r26
  pop	r25
  pop	r24
  pop	r23
  pop	r22
  pop	r21
  pop	r20
  pop	r19
  pop	r18
  pop	r17
  pop	r16
  pop	r15
  pop	r14
  pop	r13
  pop	r12
  pop	r11
  pop	r10
  pop	r9
  pop	r8
  pop	r7
  pop	r6
  pop	r5
  pop	r4
  pop	r3
  pop	r2
  pop	r1
  pop	r0
  reti

