#ifndef AVR_KERNEL_H
#define AVR_KERNEL_H

#include "AVR_Types.h"

/* number of kernel priority levels (n-1..0)
 * and priority levels for different thread types
 */
#define PRIO_LEVELS 3
#define PRIO_IDLE (0)
#define PRIO_JAVAMAIN (1)
#define PRIO_JAVA (2)

extern volatile kthread_t*	current_thread;
extern volatile queue_t		sleep_queue;
extern volatile queue_t		ready_queue;
extern volatile uint32_t	kernel_ticks;

/* switch context */
extern void kernel_reschedule(void);

/* kernel functions */
void kernel_start();
void kernel_wait(uint32_t time);
void kernel_sleep(uint32_t delay);
uint32_t kernel_get_ticks();
uint32_t kernel_get_tick_frac(); 

#endif
