#ifndef AVR_MEMORY_H
#define AVR_MEMORY_H

#include "AVR_Types.h"

#ifdef _AVR_EXT_MEM
#define AVR_HEAP_END		(0x9100)
#define HEAP_SPACE_FREE		(0x6000)
#define IDLE_STACK_END		(0x1080)
#define STACK_SPACE_FREE	(0x0F80)
#else
#error cannot run threads without external memory
#endif

/* This will allocate a memory region on the heap.
 * This memory cannot be recycled.
 */
void* ealloc(unsigned size);

/* This is used for putting stuff in internal memory (mainly stacks).
 * Internal memory has lower latency.
 */
void* ialloc(unsigned size);

#endif
