#ifndef AVR_TYPES_H
#define AVR_TYPES_H

#include <stdint.h>

#define CHECK_STACK

typedef unsigned char byte;
typedef void (*entrypt_t)();

typedef struct kernel_thread	kthread_t;
struct kernel_thread {
	volatile kthread_t*	succ;		/* successor in group */
	volatile kthread_t*	last;		/* last thread in group */
	volatile uint32_t	time;		/* time to wait */
	volatile uint8_t	prio_fix;	/* original priority */
	volatile uint8_t	prio_dyn;	/* current priority */
	volatile intptr_t	sp;		/* stack pointer */
#ifdef CHECK_STACK
	volatile intptr_t	stack_end;	/* for stack consistency checks */
#endif
};

#if 1
typedef struct thread_queue {
	volatile kthread_t*	succ;		/* successor in group */
	volatile kthread_t*	last;		/* last thread in group */
} queue_t;
#else
typedef struct kernel_thread	queue_t;
#endif

typedef struct semaphore {
	volatile queue_t	queue;
	volatile uint8_t	counter;
} semaphore_t;

typedef struct mutex {
	volatile queue_t	queue;
	volatile kthread_t*	owner;
	volatile uint8_t	prio_ceil;
} mutex_t;


typedef struct _Object_ _Object_;
struct _Object_ {
	volatile int		size;
	volatile _Object_*	next;	/* used as a marking stack */
	volatile _Object_**	ptr;	/* Pointer to entry in objectTable */
	volatile int*		ptrInfo;
};

#endif
