#include "AVR_UART.h"

void RS232_init()
{
	/* init USART */
	/*outp((unsigned char) BAUD>>8,UBRR0H);*/
	UBRR0H = (unsigned char) BAUD >> 8;
	/*outp(~0x03,PORTB);*/
	PORTB = ~0x03;
	/*outp((unsigned char) BAUD,UBRR0L);*/
	UBRR0L = (unsigned char) BAUD;
	/*outp(0,UCSR0A);*/
	UCSR0A = 0;

	/* Enable transmitter */
	/*outp((1<<3),UCSR0B);*/
	UCSR0B = 1<<3;

	// Set protocol 8N1
	/*outp((1<<UCSZ0) | (1<<UCSZ1) ,UCSR0C);*/
	UCSR0C = (1<<UCSZ0) | (1<<UCSZ1);
	/*outp(~0x04,PORTB);*/
	PORTB = ~0x04;
}

void transmit(char cc) {
	/*   while (!(inp(UCSR0A) & (1<<UDRE))) ; */
	/*   outp(cc,UDR0);   */
	while (!(UCSR0A & (1<<UDRE))) ;
	UDR0 = cc;  
}

void transmitInt(unsigned int i)
{
	char cc[6];
	int ix=0;
	if (i==0) {
		transmit('0');
	} else {
		while (i>0) {
			cc[ix++] = (i % 10)+0x30;
			i /= 10;
		}
		while (ix > 0) {
			/*	 while (!(inp(UCSR0A) & (1<<UDRE))) ; */
			while (!(UCSR0A & (1<<UDRE))) ;
			/*	 outp(cc[--ix],UDR0);	*/
			UDR0 = cc[--ix];
		}
	}
	transmit(';');
}

void transmitLong(unsigned long i)
{
	char cc[8];
	int ix=0;
	if (i==0) {
		transmit('0');
	} else {
		while (i>0) {
			cc[ix++] = (i % 10)+0x30;
			i /= 10;
		}
		while (ix > 0) {
			/*	 while (!(inp(UCSR0A) & (1<<UDRE))) ; */
			/*	 outp(cc[--ix],UDR0);	*/
			while (!(UCSR0A & (1<<UDRE))) ;
			UDR0 = cc[--ix];  
		}
	}
	transmit(';');
}

void transmitString(char* cc)
{
	int i;
	for (i=0; i<strlen(cc); i++) {
		/*     while (!(inp(UCSR0A) & (1<<UDRE))) ; */
		/*     outp(cc[i],UDR0);   */
		while (!(UCSR0A & (1<<UDRE))) ;
		UDR0 = cc[i];  
	}
}


