
 ; NAME AVR_ContextSwitch

; #include <iom128.h>
#include <avr/io.h>
#define OFFSET_NEXT 0
#define OFFSET_PRED 2
#define OFFSET_LAST 4
#define OFFSET_TIME 6
#define OFFSET_PRIO 10
#define OFFSET_ORGPRIO 11
#define OFFSET_INTQUEUE 15
#define OFFSET_SP 12
#define OFFSET_SPL 12
#define OFFSET_SPH 13

#define CONTEXT_SWITCH_STARTED	1
#define	THREAD_SUSPENDED	2
#define	PREEMTION_DISABLED	4

    .global switchContext, reSchedule, setInts
;    .global switchContext, enableInts, disableInts, reSchedule, setInts
;  EXTERN readyQueueInsertLast, prioQueueRemoveMulti, readyQueueDelete 
;  EXTERN prioTimeQueueRemoveMulti
;  EXTERN initThread
;  EXTERN tickCounter, threadState, currentThread, timeQueue, threadQueues
;  EXTERN intQueue0, timeQueue, currentReady, main;

;    .section AVR_ContextSwitch
;  .comm  INTVEC(1)
;  ORG INT0_vect
;    rjmp	interrupt0
;   ORG INT4_vect
;    .org SIG_OUTPUT_COMPARE2
;    .org 0x0012
;    rjmp  switchContextTimeTick
  
;_main
;  ldi r16, 0xc0
;  out MCUCR, r16
;  ldi r28, 0x20 // YLO
;  ldi r29, 0x05 // YHI
;  ldi r16, 0x1f
;  out SPL, r16
;  ldi r16, 0x01
;  out SPH, r16
;  rjmp  main

;enableInts:
setInts:
  cli
  out	0x39, r24 // EIMSK
  out	0x37, r25 //TIMSK
  reti

;disableInts:
;  cli
;  in	r24, 0x39
;  in	r25, 0x37
;  ldi	r23, 0x00
;  out	0x39, r23 //EIMSK
;  out	0x37, r23 //TIMSK
;  reti

;   .global _unexpected_
; _unecpected_:
;   ldi	r25, 0xff
;   out	0x18, r25
  eternalLoop:	
  rjmp eternalLoop
	
;  .global enable
;  .func enable
;enable:	
; sei
; ret
;  .endfunc

;  .global disable
;  .func disable
;disable:	
; cli
; ret
;  .endfunc

   .global interrupt0
   .func interrupt0
interrupt0:
	ldi	r25, 0x41
; 	call	done_LCDDisplay_print_char
;   push  r25
;   lds    r25, SREG
;   push  r25
;   lds	r25, EIMSK
;   push	r25
;   lds	r25, TIMSK
;   push	r25
;   push  r28
;   push  r29

;   push  r24
;   push  r26
;   push  r27
;   push  r30
;   push  r31
;   push  r0
;   push  r1
;   push  r2
;   push  r3
;   push  r4
;   push  r5
;   push  r6
;   push  r7
;   push  r8
;   push  r9
;   push  r10
;   push  r11
;   push  r12
;   push  r13
;   push  r14
;   push  r15
;   push  r16
;   push  r17
;   push  r18
;   push  r19
;   push  r20
;   push  r21
;   push  r22
;   push  r23


  ; Move interrupt processes to ready state

intWakeupLoop:	
  lds	r24, intQueue0
  lds	r25, intQueue0+1
  call	prioQueueRemoveMulti
  ldi	r18, 0x00
  cp	r24, r18
  cpc	r25, r18
  breq	intNoMoreToWakeUp
  mov   r22, r24
  mov   r23, r25
  call	readyQueueInsertLast
  rjmp	intWakeupLoop
intNoMoreToWakeUp:	

  pop   r23
  pop   r22
  pop   r21
  pop   r20
  pop   r19
  pop   r18
  pop   r17
  pop   r16
  pop   r15
  pop   r14
  pop   r13
  pop   r12
  pop   r11
  pop   r10
  pop   r9
  pop   r8
  pop   r7
  pop   r6
  pop   r5
  pop   r4
  pop   r3
  pop   r2
  pop   r1
  pop   r0
  pop   r31
  pop   r30
  pop   r27
  pop   r26
  pop   r24
  
  pop   r29
  pop   r28

  pop	r25
  sts	TIMSK, r25
  pop	r25
  sts	EIMSK, r25
  pop   r25
  sts   SREG, r25

  pop   r25
  reti
  .endfunc

/* Testing context switches */
   .global testCS
   .func testCS
 testCS:	
   rjmp	switchContextTimeTick
   .endfunc	
		
/* Called when a thread requests to put itself to sleep */
  .global switchContext
  .func switchContext
switchContext:
   cli

	; Test code
;    ldi	r25, 'A'
;    call	done_LCDDisplay_writeDataByte_char
;    rjmp eternalLoop
	; End of test code

;   rjmp switchContextTimeTick // Just for testing, remove!!!!
  push  r25
  lds    r25, SREG
  push  r25
  lds	r25, EIMSK
  push	r25
  lds	r25, TIMSK
  push	r25
  rjmp  switchContinue

/* Context switch required when a thread has used its timeslice */
    .global switchContextTimeTick
;    .global _vector_9
;   .global _vector_5
;   .global _vector_4
;   .global _vector_3
;   .global _vector_2
;   .global _vector_1
;   .global _vector_6
;   .global _vector_7
;   .global _vector_8
;   .global _vector_15
;  _vector_9:	
; _vector_5:	
; _vector_4:	
; _vector_3:	
; _vector_2:	
; _vector_1:	
; _vector_6:	
; _vector_7:	
; _vector_8:	
; _vector_15:
   .global __vector_default
__vector_default:	
switchContextTimeTick:
   cli
  /* Start Increase Tick */

/* Restore stack and exit, only for testing purpose */
;   pop	r25
;   pop	r25
;   pop	r25
;   pop	r25
;   reti

	
/* Print something on the LED */
;   push	r25
;   ldi	r25, 0x12
;   out	0x18, r25
;   pop	r25
;   rjmp eternalLoop	

  push  r25
  lds   r25, SREG
  push  r25
  lds	r25, EIMSK
  push	r25
  lds	r25, TIMSK
  push	r25


;   rjmp switchContextMain	
		  
  push  r30
  push  r31
  ldi   r30, lo8(tickCounter)   ;  let Z point at tickCounter
  ldi   r31, hi8(tickCounter)
	

  ld    r25, Z                   ; increase tickCounter by one

  /* Testing only !!! return from interrupt */
;   pop	r31
;   pop	r30
;   pop	r25	
;   pop	r25	
;   pop	r25	
;   sts	SREG, r25
;   pop	r25	
;   reti
  /* End of testing code */


  subi  r25, 0xff
/* Print something on the LED */
;   push	r25
;   push	r24
;   ldi	r24, 0x80
;   eor	r25, r24
;   out	0x18, r25
;   pop	r24
;   pop	r25
;   pop	r31
;   pop	r30
;   rjmp eternalLoop	

  
  st    Z+, r25
  ld    r25, Z
  sbci  r25, 0xff

/* Print something on the LED */
;   out	0x18, r25

	
  st    Z+, r25
  ld    r25, Z
  sbci  r25, 0xff
  st    Z+, r25
  ld    r25, Z
  sbci  r25, 0xff
  st    Z+, r25
  
	
  pop   r31
  pop   r30
  /* End Increase Tick */

	
;   ldi	r25, ~0x10
;   out	0x18, r25

  rjmp  switchContextMain


/* Switch to next scheduable thread. Make sure global interrupts are disabled when called */
switchContextMain:	
  lds	r25, threadState		// check for preemtion enabled
;   out	0x18, r25
  andi	r25, PREEMTION_DISABLED
  brne	noPreemtion
  lds	r25, threadState		// check for nested context switch
  andi	r25, CONTEXT_SWITCH_STARTED
  breq	switchContinue
  lds    r30, SPL                // load SP into Z
  lds    r31, SPH
  subi  r30, 0xfd               // add 0x02, Z now points to the return adress
  sbci  r31, 0xff
  ldi   r25, hi8(reSchedule)    // change return adress to reSchedule
;   lsr	r25
  st    Z+, r25
  ldi   r25, lo8(reSchedule)
;   lsr	r25
  st    Z+, r25

/* Print something on the LED */	
;   push	r25
;   ldi	r25, 0x80
;   out	0x18, r25
;   pop	r25
  
  pop   r25	// TIMSK
  pop   r25	// EIMSK
  pop	r25	// SREG
  pop	r25
;   rjmp	reSchedule
/* Print something on the LED */
;   push	r25
;   ldi	r25, ~0x02
;   out	0x18, r25
;   pop	r25

  reti
  .endfunc
  
noPreemtion:				// Do not switch context, restore current and continue
  /* Testing only !!! return from interrupt */
  pop	r25	
  pop	r25	
  pop	r25	
  pop	r25	
  reti
  /* End of testing code */
;   ldi	r25, ~0x11
;   out	0x18, r25

  pop	r25
  sts	TIMSK, r25
  pop	r25
  sts	EIMSK, r25
  pop	r25
  sts	SREG, r25
  pop	r25
  reti
  
switchContinue:	
  /* Testing only !!! return from interrupt */
;     pop	r25	
;     pop	r25	
;     pop	r25	
;     pop	r25	
;     reti
  /* End of testing code */


/* Print something on the LED */
;   ldi	r25, ~0x12
;   out	0x18, r25
	
  push  r28
  push  r29

  push  r24
  push  r26
  push  r27
  push  r30
  push  r31
  push  r0
  push  r1
  push  r2
  push  r3
  push  r4
  push  r5
  push  r6
  push  r7
  push  r8
  push  r9
  push  r10
  push  r11
  push  r12
  push  r13
  push  r14
  push  r15
  push  r16
  push  r17
  push  r18
  push  r19
  push  r20
  push  r21
  push  r22
  push  r23

	
  // Make sure to store all registers

; Save stack pointer to thread structure  
  lds   r30, currentThread              // Z points at the current running Thread
  lds   r31, currentThread+1
  lds    r25, SPL
  std   Z+OFFSET_SPL, r25
  lds    r25, SPH
  std   z+OFFSET_SPH, r25

; Check stack pointer for overflow
  call	CheckStack

  lds	r25, threadState
  andi	r25, THREAD_SUSPENDED
  brne	Blocked

  lds	r22, currentThread
  lds	r23, currentThread+1
  call	readyQueueInsertLast

Blocked:	

  lds	r25, threadState	// indicate context switch started
  ori	r25, CONTEXT_SWITCH_STARTED
  sts	threadState, r25

  /* The entired context is now saved in the thread structure, now it's time
   * to reschedule. The following code may be restarted by a new contextSwitch
   */
  .global reSchedule
  .func reSchedule
reSchedule:	
  /* Start wake up waiting threads */

wakeupLoop:	
  lds	r24, timeQueue
  lds	r25, timeQueue+1
  call	prioTimeQueueRemoveMulti
  ldi	r18, 0x00
  cp	r24, r18
  cpc	r25, r18
  breq	noMoreToWakeUp
  mov   r22, r24
  mov   r23, r25
  call	readyQueueInsertLast
  rjmp	wakeupLoop
noMoreToWakeUp:	


  
  /* Start Reschedule */
  
  /* Find the next available thread in threadQueues. The first list contains
   * the ready threads in the highest priority level. There will at least be 
   * one ready thread in one of the Queues as there is an idle thread
   */
  ldi   r30, lo8(threadQueues)          // Z points at the first thread queue
  ldi   r31, hi8(threadQueues)
scheduleLoop:	
  ldd	r28, Z+0
  ldd	r29, Z+1
  ldd   r24, Y+OFFSET_NEXT
  ldd   r25, Y+OFFSET_NEXT+1
  ldi	r23, 0x00
  cp    r24, r23
  cpc   r25, r23
  brne  foundNextThread
  subi  r30, 0xfe       // increase Z by 2
  sbci  r31, 0xff
  rjmp  scheduleLoop
foundNextThread:	
  ;cli
  sts	currentThread, r24
  sts	currentThread+1, r25
  call	readyQueueDelete
  .endfunc
  ;sei
  
;   ldi	r25, ~0x13
;   out	0x18, r25

  /* End Reschedule */
    
  /* Start restore context */
  lds	r24, currentThread	// Y points to the next running thread
  lds	r25, currentThread+1
  call	initThread
  
  lds	r28, currentThread	// Y points to the next running thread
  lds	r29, currentThread+1
  
;   rjmp eternalLoop
;   rjmp restoreContext
  ldd   r25, Y+OFFSET_SP


  sts   SPL, r25        // restore Stack Pointer Lo
;   in	r25, 0x3a
;   out	0x18, r25
;   rjmp restoreContext


;   in	r25, 0x3f
;   ldi	r24, 0xff
;   eor	r25, r24
;   out	0x18, r25
;   rjmp eternalLoop

  ldd   r25, Y+OFFSET_SP+1
  sts   SPH, r25        // restore Stack Pointer Hi
	
restoreContext:		
  pop   r23
  pop   r22
  pop   r21
  pop   r20
  pop   r19
  pop   r18
  pop   r17
  pop   r16
  pop   r15
  pop   r14
  pop   r13
  pop   r12
  pop   r11
  pop   r10
  pop   r9
  pop   r8
  pop   r7
  pop   r6
  pop   r5
  pop   r4
  pop   r3
  pop   r2
  pop   r1
  pop   r0
  pop   r31
  pop   r30
  pop   r27
  pop   r26
  pop   r24
  
  pop   r29
  pop   r28

  cli
  lds	r25, threadState		// Indicate end of context switch
  andi	r25, ~CONTEXT_SWITCH_STARTED
  sts	threadState, r25

;   out	0x18, r29
  pop	r25
  sts	TIMSK, r25
  pop	r25
  sts	EIMSK, r25
  pop   r25

;   out	0x18, r25
;   rjmp eternalLoop
	
/* Print something on the LED */
;   push	r25
;   ldi	r25, 0x12
;   out	0x18, r25
;   pop	r25

  sts   SREG, r25


;   push	r24	
;   in	r25, 0x3f
;   ldi	r24, 0xff
;   eor	r25, r24
;   out	0x18, r25
;   pop	r24
;   rjmp eternalLoop

  pop   r25
;   out	0x18, r25
/* Print something on the LED */
;   push	r25
;   ldi	r25, ~0x08
;   out	0x18, r30
;   pop	r25

	; Test code
;     ldi	r25, 'A'
;     call	done_LCDDisplay_writeDataByte_char
;     rjmp eternalLoop
	; End of test code
  reti
