#ifndef AVR_KERNEL_H
#define AVR_KERNEL_H

#define PRIO_LEVELS 4

#define PRIO_IDLE (PRIO_LEVELS)
#define PRIO_JAVAMAIN (PRIO_LEVELS-1)
#define PRIO_JAVA (PRIO_LEVELS-2)

#define CONTEXT_SWITCH_STARTED	1
#define	THREAD_SUSPENDED	2
#define	PREEMTION_DISABLED	4

#include "AVR_Types.h"
#include "AVR_Thread.h"
#include "AVR_Queue.h"
#include "AVR_Semaphore.h"
/* #include "AVR_GC.h" */
//#include <io.h>

extern KernelThread *currentThread;

extern void initialize(void);
extern void switchContext(void);
extern void reSchedule(void);

void setInts(uint16_t status);
void enableInts(uint8_t status);
uint8_t disableInts(void);
/*void enableInts(int status);*/
/*int disableInts(void);*/

void startKernel(void);
void initKernel(void);
void runKernel(void);
void waitUntil(long time);
void sleep(long delay);
long getTickTime(int this);
int getTickFraq(int this); 

#endif
