#include "AVR_Memory.h"
#include "AVR_Kernel.h"
/* #include <iom128.h>  */
/* #include <iomacros.h> */
/* #include <avr/io.h> */
#include <avr/io.h>
#include <config.h>

/* byte *memPointer = (byte *)32768; */
byte *memPointer;// = (byte *)0x8000;
long spend;// Stack sPace END address

int freeMem; // = 0x7000;
unsigned spfree;// Stack sPace FREE

void tobbe_heap_init(void) {
#ifdef _AVR_EXT_MEM
  memPointer = 0x9100;
  freeMem = 0x6000;// This may be a too optimistic guess
  spend = 0x1080;
  spfree = 0xF80;// This is taking into account the approximate size of the C (idle code) stack.
  // The C stack starts at the top of internal memory, 0x10FF.
  // We do *not* want to violate the C stack, or any other for that matter.
#else
  memPointer = 0xF90;
  freeMem = 0xF00;
  //spend = ?;
  //spfree = ?;
#endif
}

void *myMalloc(int size) {
  int status = disableInts();
  byte *returnValue;
  memPointer -= size;
  freeMem -= size;
  while (freeMem < 0) { 
/*     outp(~0xaa,PORTB);   */
    PORTB = ~0xaa;
  } 
  returnValue = memPointer;
  enableInts(status);
  return (void *)returnValue;
}

void *myStackMalloc(unsigned size) {
  int status = disableInts();
  long ptr;
  while (spfree <  size) {
    // Not engouh free stack space.
    // Print error message
    LCD_moveCursor(0);
    LCD_printChar('o');
    LCD_printChar('u');
    LCD_printChar('t');
    LCD_printChar(' ');
    LCD_printChar('o');
    LCD_printChar('f');
    LCD_printChar(' ');
    LCD_printChar('m');
    LCD_printChar('e');
    LCD_printChar('m');
    LCD_printChar('o');
    LCD_printChar('r');
    LCD_printChar('y');
	LCD_moveCursor(40);
	LCD_printInt(currentThread->id);
  }
  spend -= size;
  spfree -= size;
  ptr = spend;
  enableInts(status);
  return (void *)ptr;
}

