#include "AVR_Queue.h"

//extern void led(int i);

//int b=0;

void initQueue(Queue *q) {
  //int i,j;
  //char a;
  q->next = 0;
  q->pred = 0;
  q->last = (KernelThread *)q;
/*   a = (((int)q) & 0x00FF); */
/*   outp(~a,PORTB); */
/*   for (i=0; i<3000;i++){ */
/*     for (j=0; j<200;j++){ */
/*       a = inp(PORTB); */
/*     } */
/*   } */
/*   a = (((int)q->last) & 0x00FF ); */
/*   outp(~a,PORTB); */
/*   for (i=0; i<3000;i++){ */
/*     for (j=0; j<200;j++){ */
/*       a = inp(PORTB); */
/*     } */
/*   } */

}

void prioQueueInsert(Queue *q, KernelThread *t) {
  KernelThread *iter;
  iter = (KernelThread *)q;
  while(iter->next != 0 && iter->next->dynamicPrio
        < t->dynamicPrio) {
    iter = iter->next;
  }
  t->next = iter->next;
  t->pred = iter;
  t->last = t;
  iter->next = t;
  if(t->next != 0) {
    if(t->next->dynamicPrio == t->dynamicPrio) {
      t->last = t->next->last;
    }
    t->next->pred = t;
  }
}

KernelThread *prioQueueRemoveSingle(Queue *q) {
  KernelThread *element;
  element = q->next;
  if(element != 0) {
    q->next = element->next;
    if(q->next != 0) {
      q->next->pred = (KernelThread *)q;
    }
    element->last = element;
    element->pred = 0;
    element->next = 0;
  }
  return element;
}

KernelThread *prioQueueRemoveMulti(Queue *q) {
  KernelThread *element;
  element = q->next;
  if(element != 0) {
    q->next = element->last->next;
    if(q->next != 0) {
      q->next->pred = (KernelThread *)q;
    }
    element->pred = 0;
    element->last->next = 0;
  }
  return element;
}

void prioTimeQueueInsert(Queue *q, KernelThread *t) {
  KernelThread *iter;
  iter = (KernelThread *)q;
 
  while(iter->next != 0 && iter->next->time < t->time) {
    iter = iter->next;
  }
  
  /*  
  while(iter->next != 0 && (
        (t->time > tickCounter && iter->next->time > tickCounter && t->time > iter->next->time) ||
        (t->time < tickCounter && iter->next->time < tickCounter && t->time > iter->next->time) ||
        (t->time < tickCounter && iter->next->time > tickCounter) )) {
    iter = iter->next;
  }
  */
  
  while(iter->next != 0 && iter->next->time == t->time &&
        iter->next->dynamicPrio < t->dynamicPrio) {
    iter = iter->next;
  }
  t->next = iter->next;
  t->pred = iter;
  t->last = t;
  iter->next = t;
  if(t->next != 0) {
    if(t->next->time == t->time && t->next->dynamicPrio == t->dynamicPrio) {
      t->last = t->next->last;
    }
    t->next->pred = t;
  }

}

KernelThread *prioTimeQueueRemoveMulti(Queue *q) {
/*   int status = disableInts(); */
  KernelThread *element;
  element = q->next;
  // to be on the safe side, it's probably better to use <= instead of ==
  if(element != 0 && element->time <= tickCounter) {
    q->next = element->last->next;
    element->last->next->pred = (KernelThread *)q;
    element->last->next = 0;
    element->pred = 0;
  }
  else {
    element = 0;
  }
/*   enableInts(status); */
/*   if (element==0)  */
/*     outp((char) element,PORTB); */
  return element;
}

void readyQueueInsert(int this, KernelThread *t) {
  int index = t->dynamicPrio;
  t->next = threadQueues[index]->next;
  threadQueues[index]->next = t;
  t->pred = (KernelThread *)threadQueues[index];
  if(t->next != 0) {
    t->next->pred = t;
  }
}

void readyQueueInsertLast(int this, KernelThread *t) {
  KernelThread *last;
  int index = t->dynamicPrio;
/*   led(++b + 0x80); */
  last = (KernelThread *)threadQueues[index]->last;
  threadQueues[index]->last = t->last;
  last->next = t;
  t->pred = last;
}

void readyQueueDelete(KernelThread *t) {
  int index = t->dynamicPrio;
  t->pred->next = t->next;
  if(t->next == 0) {
    threadQueues[index]->last = t->pred;
  }
  else {
    t->next->pred = t->pred;
  }
  t->next = 0;
  t->pred = 0;
  t->last = t;
}

