#ifndef AVR_QUEUE_H
#define AVR_QUEUE_H

#include "AVR_Types.h"
#include "AVR_Thread.h"
#include "AVR_Kernel.h"

extern volatile unsigned long tickCounter;

extern Queue *threadQueues[PRIO_LEVELS+1];

void initQueue(Queue *);
void prioQueueInsert(Queue *, KernelThread *);
KernelThread *prioQueueRemoveSingle(Queue *);
KernelThread *prioQueueRemoveMulti(Queue *);
void prioTimeQueueInsert(Queue *, KernelThread *);
KernelThread *prioTimeQueueRemoveMulti(Queue *);
// Notice that "this" is not used for anything. It is passed
// to the threads "codeStart" but they do not expect any arguments
// in the current implementation. Why it would be needed for the
// readyQueue remains a mystery.
void readyQueueInsert(int this, KernelThread *t);
void readyQueueInsertLast(int this, KernelThread *t);
void readyQueueDelete(KernelThread *t);

#endif
