#ifndef AVR_THREAD_H
#define AVR_THREAD_H


// Different Thread Types
#define THREAD_ONESHOT 0
#define THREAD_PERIODIC 1
#define THREAD_INTERRUPT 2

#include "AVR_Memory.h"
// #include <ina90.h> 
/* #include <iom128.h> */
#include <avr/io.h> 
#include "AVR_Types.h"
#include "AVR_Queue.h"



extern volatile unsigned long tickCounter;
extern Queue *timeQueue;
extern KernelThread *currentThread;
extern void reSchedule(void);
extern Queue *intQueue0;

// Undefined function: setupIdle
//void setupIdle(int codeStart, int priority);
KernelThread *allocThread(int this, void (*codeStart)(void), int priority, unsigned stack_size);
KernelThread *allocPeriodicThread(int this, void (*codeStart)(void), int priority, int interval);
KernelThread *allocInterrupt(int this, void (*codeStart)(void), int priority, int intNbr);
// Undefined function: freeThread
//void freeThread(KernelThread *t);
void deallocCode(void);
void startThread(int this, KernelThread *t);
#endif
