#include <gc.h>
#include <avr/io.h> 

// HERE BE DRAGONS! We need to know how a struct _Thread_ClassStruct looks
// in order to find the run method. This could maybe be fixed with a
// aux function getMethodPointer(char *className, char *methodName) or
// something like that.
// For now, we require that a (manually created) Thread.h exists
#include <javatypes.h>
#include <java_lang_Thread.h>
#include <java_lang_Object.h>
#include <AVR_Thread.h>
#include <AVR_Kernel.h>
#include <AVR_Semaphore.h>
#include <gci_common.h>
#include <exception.h>
#include <config.h>

#define BAUD 25 // 9600bps @ 4MHz


extern void tobbe_heap_init(void);
//extern int JAVAMAIN(void);
extern void transmit(char);
extern void initPrintMutex(void);


GC_PROC_BEGIN(ljrt_monitor_init,GC_PARAM(java_lang_Object,this))
/*   GC_PARAM_REF(java_lang_Object,this); */
/*   GC_PUSH_PARAM(this); */
/*   GC_FUNC_ENTER { */
/*     GC_SET(this, lock, 0); // Lazy allocation */
/*   } GC_FUNC_LEAVE; */
/*   GC_POP_PARAM(this); */
GC_PROC_END(ljrt_monitor_init)

GC_PROC_BEGIN(ljrt_monitor_enter,GC_PARAM(java_lang_Object,this))
/*   GC_PARAM_REF(java_lang_Object,this); */
/*   GC_PUSH_PARAM(this); */
/*   GC_FUNC_ENTER { */
/*     ljrt_monitor_t *lock; */
/*     ljrt_thread_t *currentThread; */

/* //    printf("%s\n", __FUNCTION__); */
/*     currentThread = (ljrt_thread_t*)pthread_getspecific(ljrt_tsd_key); */
/*     GC_GET(lock, this, lock); */
/*     if (!lock) { */
/*       lock = malloc(sizeof(ljrt_monitor_t)); */
/*       lock->count = 0; */
/*       lock->seq = 0; */
/*       lock->waiters = 0; */
/*       pthread_mutex_init(&lock->mutex, 0); */
/*       pthread_cond_init(&lock->cond, 0); */
/*       GC_SET(this, lock, lock); */
/*     } */
/*     if (!lock) {  */
/*       printf("No monitor allocated\n");  */
/*     } else { */

/*       pthread_mutex_lock(&global_mutex); */
/*       do { */
/* 	if (lock->count == 0) { */
/* 	  // Acquire free lock  */
/* 	  lock->count = 1; */
/* 	  lock->owner = currentThread; */
/* 	  pthread_mutex_lock(&lock->mutex); */
/* 	} else if (lock->owner == currentThread) { */
/* 	  // Recursion on already owned lock */
/* 	  lock->count++; */
/* 	} else { */
/* 	  // Wait for lock to become free */
/* 	  lock->waiters++; */
/* 	  pthread_cond_wait(&lock->cond, &global_mutex); */
/* 	  lock->waiters--; */
/* 	} */
/*       } while (lock->owner != currentThread); */
/*       pthread_mutex_unlock(&global_mutex); */
/*     } */
/*   } GC_FUNC_LEAVE; */
/*   GC_POP_PARAM(this); */
GC_PROC_END(ljrt_monitor_enter)

GC_PROC_BEGIN(ljrt_monitor_leave,GC_PARAM(java_lang_Object,this))
/*   GC_PARAM_REF(java_lang_Object,this); */
/*   GC_PUSH_PARAM(this); */
/*   GC_FUNC_ENTER { */
/*     ljrt_monitor_t *lock; */
/*     ljrt_thread_t *thread; */

/* //    printf("%s\n", __FUNCTION__); */
/*     thread = (ljrt_thread_t*)pthread_getspecific(ljrt_tsd_key); */
/*     GC_GET(lock, this, lock); */
/*     pthread_mutex_lock(&global_mutex); */
/*     assert(lock->owner == thread); */
/*     assert(lock->count > 0); */
/*     lock->count--; */
/*     if (lock->count == 0) { */
/*       // Unlock the nown unoccupied monitor */
/*       pthread_mutex_unlock(&lock->mutex); */
/*       if (lock->waiters) { */
/* 	// Free at least one waiting task */
/* 	pthread_cond_signal(&lock->cond); */
/*       } */
/*     } */
/*     pthread_mutex_unlock(&global_mutex); */
/*   } GC_FUNC_LEAVE; */
/*   GC_POP_PARAM(this); */
GC_PROC_END(ljrt_monitor_leave)

void ljrt_monitor_free(java_lang_Object *this)
{
/*   ljrt_monitor_t *lock; */
/*   lock = this->lock; */
/*   if (lock) { */
/*     //FIXME: seems to be some race condition with the GC */
/*     //       at termination time (i.e printout not always present) */
/*     //       Possible cause: gc_thread stopped after object is */
/*     //       removed from heap, but before finalizers are run */
/* //    printf("Freed! %s %p\n", __FUNCTION__, lock); */
/*     this->lock = 0; */
/*     pthread_cond_destroy(&lock->cond); */
/*     pthread_mutex_destroy(&lock->mutex); */
/*     free(lock); */
/*   } */
}

void initRS232(){
  // init USART
/*   outp((unsigned char) BAUD>>8,UBRR0H); */
  UBRR0H = (unsigned char) BAUD >> 8;
/*   outp(~0x03,PORTB);      */
  PORTB = ~0x03;
/*   outp((unsigned char) BAUD,UBRR0L); */
  UBRR0L = (unsigned char) BAUD;
/*   outp(0,UCSR0A); */
  UCSR0A = 0;
  
  // Enable transmitter
/*   outp((1<<3),UCSR0B); */
  UCSR0B = 1<<3;
  
  // Set protocol 8N1
/*   outp((1<<UCSZ0) | (1<<UCSZ1) ,UCSR0C); */
  UCSR0C = (1<<UCSZ0) | (1<<UCSZ1);
/*   outp(~0x04,PORTB);      */
  PORTB = ~0x04;
}
     


static Semaphore *__pass_sem;
static void * __this_param;

int main() {
  void *eFlag = 0;
  void **__eFlag__ = &eFlag;
#ifdef _AVR_EXT_MEM
/*   outp(0x80,MCUCR); */
  MCUCR = 0x80;
#endif

  // Setup PORTB for LED display
/*   outp(0xFF,DDRB);       */
/*   outp(0x00,DDRE);       */
/*   outp(~0x01,PORTB);      */


  // Setup LCDDisplay, temporary for debug.
  LCD_setupPorts();
  LCD_writeDataByte('i');
  LCD_writeDataByte('n');
  LCD_writeDataByte('i');
  LCD_writeDataByte('t');
// LCD_writeDataByte('A');
//  while(1);

  
  // Setup the heap
/*   outp(~0x02,PORTB);      */
  tobbe_heap_init();  
  LCD_writeDataByte('.');
/*   outp(~0x03,PORTB);      */
//  LCD_writeDataByte('B');

  // Setup UART, if to be used
#ifdef _AVR_UART
  initRS232();
/*   transmit('\n'); */
/*   transmit('h'); */
/*   transmit('\n'); */
#endif

  // Initialize print mutex
  initPrintMutex();
  LCD_writeDataByte('.');
/*   initPrintMutex(); */

  // Initialize GC
  GC_INIT(GC_HEAPSIZE);  
/*   outp(~0x04,PORTB);      */
/*   while(1); */
//  LCD_writeDataByte('C');
  LCD_writeDataByte('.');

  javaClasses_Init(__eFlag__);
//  LCD_writeDataByte('D');
  LCD_writeDataByte('.');

/*   outp(~0x05,PORTB);      */
/*   while(1); */
  __pass_sem = allocSemaphore(0,1); 


  LCD_writeDataByte('.');
//  LCD_writeDataByte('a');
/*   takeBinarySemaphore(0,__pass_sem); */
//  LCD_writeDataByte('b');
/*   giveBinarySemaphore(0,__pass_sem); */
//  LCD_writeDataByte('c');


/*   outp(~0x06,PORTB);      */

/*   JAVAMAIN(); */
/*   outp(~0x07,PORTB);      */
/*   while(1); */
  startKernel(); 

  // Should never come here
/*   outp(~0x11,PORTB);      */
  PORTB = ~0x11;

  GC_EXIT;   
  return 0;
}


void thread_tobbe_do_start(void **__eFlag__) {
  void *gc_param_ithis = __this_param;
  GC_THREAD_INIT 
  GC__GET_THREAD_ROOT;
  GC_PARAM_REF(java_lang_Thread,ithis); 
  GC_PUSH_PARAM(ithis); 
/*   LCD_writeDataByte('x');  */
  gc_unlock();
  {
     GC_REF(java_lang_Thread, this);
     GC_PUSH_ROOT(this);
     GC_ASSIGN(this, ithis);
  // GC_THREAD_INIT declares gc_thread_t gc_thread  

    giveBinarySemaphore(0,__pass_sem);
    gc_thread.this = (void *) GC_PASS(this);
    {
      struct java_lang_Thread_ClassStruct *_tmp_method;
      GC_GET(_tmp_method,this,class);
      GC_PROC_CALL(_tmp_method->methodTbl->run, GC_PASS(this));
/*       dec_threads(); */
    }
    GC_POP_ROOT(this);
  } 
  gc_lock();
  GC_POP_PARAM(ithis); 
  GC_THREAD_EXIT 
} 


GC_VAR_FUNC_BEGIN(JLong,java_lang_Thread_createThread,GC_PARAM(java_lang_Thread,this))
  GC_PARAM_REF(java_lang_Thread,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;


  JLong _result_;
/* outp(~0x30,PORTB); */
  _result_ = (JLong) allocThread(0,&thread_tobbe_do_start, PRIO_JAVA, JAVA_STACK_SIZE);
/* outp(~0x3F,PORTB); */
  GC_RETURN_VAR(_result_);

  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);     
GC_VAR_FUNC_END(JLong,java_lang_Thread_createThread)

GC_PROC_BEGIN(java_lang_Thread_startThread_long,GC_PARAM(java_lang_Thread,this), JLong target)
     GC_PARAM_REF(java_lang_Thread,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER
{
/*   struct java_lang_Thread_ClassStruct *_tmp_method; */
/*   GC_GET(_tmp_method,this,class); */
/*   JLong target; */
/*   GC_GET(target,this,target); */
  takeBinarySemaphore(0,__pass_sem);
  gc_lock(); 
  __this_param = GC_PASS(this);
  readyQueueInsertLast((GC___REF(ObjectHead)) this->ref, target);
  gc_unlock();
  /* This is required to ensure that the activation record containing
   * __this_param is not popped from the stack until it has been read
   * by the child thread
   */
  takeBinarySemaphore(0,__pass_sem);
  giveBinarySemaphore(0,__pass_sem);
}

     GC_FUNC_LEAVE
     GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_start)

GC_PROC_BEGIN(java_lang_Thread_start,GC_PARAM(java_lang_Thread,this))
     GC_PARAM_REF(java_lang_Thread,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER
{
  JLong target;
  GC_GET(target,this,_java_lang_Thread_target);
  GC_PROC_CALL(java_lang_Thread_startThread_long,GC_PASS(this),target);
}

     GC_FUNC_LEAVE
     GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_start)

/* Native implementation of java.lang.Thread.currentThread() */

GC_REF_FUNC_BEGIN(java_lang_Thread,java_lang_Thread_currentThread)
  GC_FUNC_ENTER
  GC_REF(java_lang_Thread,tmp);
  GC_PUSH_ROOT(tmp);
  {	
/*   	ljrt_thread_t *obj; */
/* 	obj = (ljrt_thread_t*) pthread_getspecific(ljrt_tsd_key); */
/* 	GC_ASSIGN(tmp,obj->javathread); */
    GC_RETURN_REF(tmp);
  }  
  GC_POP_ROOT(tmp);
  GC_FUNC_LEAVE;
GC_REF_FUNC_END(java_lang_Thread,java_lang_Thread_currentThread)

GC_PROC_BEGIN(java_lang_Thread_sleep_long,long millis)
GC_FUNC_ENTER
{
/*   outp(~(millis/10),PORTB);  */

/*    sleep(0,millis/10);      */
   sleep(millis);     

/*   switchContext();  */
}
GC_FUNC_LEAVE
GC_PROC_END(java_lang_Thread_sleep_long)

GC_PROC_BEGIN(java_lang_Thread_inheritPriority,GC_PARAM(java_lang_Thread,this))
  GC_PARAM_REF(java_lang_Thread,this);
/*   struct sched_param param; */
/*   JInt result; */
/*   JInt policy; */
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
/*   if (pthread_getschedparam_rt(pthread_self_rt(),&policy,&param) != 0) printf("Error pthread_getschedparam()\n"); */
/*   Posix priority to Java priority */ 
/*   result = schedPr2javaPr(param.sched_priority,_RT_SCHEDULING_POSIX); */
/*   GC_SET(this,_java_lang_Thread_priority,result); */
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_inheritPriority)

/* GC_VAR_FUNC_BEGIN(JBoolean,java_lang_Thread_interrupted,GC_PARAM(java_lang_Thread,this)) */
/*   GC_PARAM_REF(java_lang_Thread,this); */
/*   JBoolean tmp; */
/* /\*   pthread_mutex_t* mutex; *\/ */
/*   GC_PUSH_PARAM(this); */
/*   GC_FUNC_ENTER; */
/* /\*   pthread_mutex_lock_rt(&threads_interrupt_mutex); *\/ */
/*   GC_GET(tmp,this,_java_lang_Thread_interruptedFlag); */
/*   GC_SET(this,_java_lang_Thread_interruptedFlag,false); */
/* /\*   pthread_mutex_unlock_rt(&threads_interrupt_mutex); *\/ */
/*   GC_RETURN_VAR(tmp);     */
/*   GC_FUNC_LEAVE; */
/*   GC_POP_PARAM(this); */
/* GC_VAR_FUNC_END(JBoolean,java_lang_Thread_interrupted) */

GC_PROC_BEGIN(java_lang_Thread_interrupt,GC_PARAM(java_lang_Thread,this))
  GC_PARAM_REF(java_lang_Thread,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
  {
/*   	int status; */
/* 	pthread_t t;	 */
/* 	gc_thread_t *tsd_blocked_thread; */
/* 	pthread_mutex_lock_rt(&threads_interrupt_mutex);						 */
	GC_SET(this,_java_lang_Object_interruptedFlag,true);
/* 	pthread_mutex_unlock_rt(&threads_interrupt_mutex);// */
/* 	GC_GET(t,this,_java_lang_Thread_target); */
/*    GC_GET(tsd_blocked_thread,this,_java_lang_Thread_TSD); */
/* 	if (tsd_blocked_thread == 0 || tsd_blocked_thread->semObj == 0) {		 */
/* #ifndef __RTAI__		 */
/* 		if (t != pthread_self_rt()) {  */
/* 			if ((status = pthread_cancel_rt(t)) != 0 && status !=ESRCH) printf("Error pthread_cancel()\n");   	   		 */
/* 		} */
/* #endif */
/*    // These conditionals only when RTAI is running */
/* #ifdef __RTAI__ */
/* 	} 	else if (tsd_blocked_thread->semObj == -2) { */
/* 		// Target thread is blocked in a join */
/* 		if (pthread_cancel_rt(t) != 0) printf("Error pthread_cancel()\n"); */
/* 	} else if (tsd_blocked_thread->semObj == -1) { */
/* 		// Do nothing - Flag already set	- Target thread is blocked in a sleep */
/* 		; */
/* #endif */
/* 	} else { */
/* 		pthread_cond_signal_rt(tsd_blocked_thread->semObj); */
/* 	} */
	//pthread_mutex_unlock_rt(&threads_interrupt_mutex);
  }   
  GC_FUNC_LEAVE;  
  GC_POP_PARAM(this);	
GC_PROC_END(java_lang_Thread_interrupt)

GC_PROC_BEGIN(java_lang_Thread_setPriority_int,GC_PARAM(java_lang_Thread,this),JInt priority)  EXCEPTION_THROWS
  GC_PARAM_REF(java_lang_Thread,this);
/*   struct sched_param param; */
  JInt policy;
  JLong tmp;
  JInt status;
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
/*   if (priority > 10 || priority < 1) { */
/*     EXCEPTION_THROW(JAVA_LANG_ILLEGALARGUMENTEXCEPTION_INDEX) */
/*   } */
/*   else { */
/*     GC_SET(this,_java_lang_Thread_priority,priority); */
/* 	 GC_GET(tmp,this,_java_lang_Thread_target); */
/* 	 param.sched_priority = javaPr2schedPr(priority,_RT_SCHEDULING_POSIX); */
/* 	 if ((status = pthread_setschedparam_rt(tmp,_RT_SCHEDULING_POSIX,&param)) != 0 && status != ESRCH) { */
/* 	 	printf("pthread_setschedparam() %d[%d,%d]\n",param.sched_priority,sched_get_priority_min(_RT_SCHEDULING_POSIX),sched_get_priority_max(_RT_SCHEDULING_POSIX)); */
/* 	} */
/*   } */
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_setPriority_int)

GC_PROC_BEGIN(java_lang_Thread_join,GC_PARAM(java_lang_Thread,this))
  GC_PARAM_REF(java_lang_Thread,this);
  JLong tmp;
  JInt status;
#ifdef __RTAI__
  gc_thread_t *tsd;
#endif
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
/*   GC_GET(tmp,this,_java_lang_Thread_target); */
/*   GC_POP_PARAM(this); */
/* #ifdef __RTAI__ */
/*   tsd = (gc_thread_t*) pthread_getspecific(tsd_key); */
/*   tsd->semObj = -2;      */
/* #endif   */
/*   pthread_cleanup_push_rt(interrupter,0); */
/*   if ((status = pthread_join_rt(tmp,0)) != 0 && status != ESRCH && status != EINVAL) printf("Error pthread_join() %d [%d,%d]\n",status,ESRCH,EINVAL); */
/*   pthread_cleanup_pop_rt(0); */
/* #ifdef __RTAI__ */
/*   tsd->semObj = 0;      */
/* #endif     */
  GC_FUNC_LEAVE;  
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_join)

GC_PROC_BEGIN(java_lang_Thread_join_long,GC_PARAM(java_lang_Thread,this),JLong millis)
  GC_PARAM_REF(java_lang_Thread,this);  
/*   struct timedjoin_data data; */
/*   struct timeval tp; */
/*   pthread_t th;	 */
  JBoolean has_been_interrupted;
  GC_REF(java_lang_Thread,tmp);
/*   gc_thread_t *tsd; */
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
/*   pthread_mutex_init_rt(&data.lock,0); */
/*   pthread_cond_init_rt(&data.cond,0); */
/*   data.target = 0; */
/*   GC_GET(data.target,this,_java_lang_Thread_target); */
/*   GC_POP_PARAM(this); */
/*   gettimeofday(&tp,0); */
/*   data.time.tv_sec  = (millis / MS)+ tp.tv_sec; */
/*   data.time.tv_nsec = (millis % MS) * NS_MS + tp.tv_usec * MS; */
/*   if (pthread_create_rt(&th,0,(void*)interruptible_join,(void*)&data) != 0)    */
/*   		printf("Error pthread_create()<join>\n");	 */
/*   pthread_cleanup_push_rt(interrupter,0); */
/*   pthread_cleanup_push_rt(timedjoin_end,(void*)&th); */
/*   tsd = (gc_thread_t*) pthread_getspecific(tsd_key); */
/*   tsd->semObj = &data.cond;      */
/*   pthread_cond_timedwait_rt(&data.cond,&data.lock,&data.time); */
/*   pthread_cleanup_pop_rt(0); /* timedjoin_end is executed always */ 
/*   pthread_cleanup_pop_rt(0); /* interrupter only executed when this thread is cancelled */ 
/*   pthread_cancel_rt(th); */
/*    tsd->semObj = 0; */
/* 	GC_PUSH_ROOT(tmp); */
/*    GC_REF_FUNC_CALL(tmp,java_lang_Thread_currentThread); */
/*    GC_GET(has_been_interrupted,tmp,_java_lang_Thread_interruptedFlag); */
/*    GC_POP_ROOT(tmp);  */
/*    if (has_been_interrupted) {  */
/* 		GC_PROC_CALL(interrupter_impl);		 */
/* 	} */
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_join_long)

GC_PROC_BEGIN(java_lang_Thread_join_long_int,GC_PARAM(java_lang_Thread,this),JLong millis,JInt nanos)
  GC_PARAM_REF(java_lang_Thread,this);
/*   struct timedjoin_data data; */
/*   struct timeval tp; */
/*   pthread_t th;	   */
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
/*   pthread_mutex_init_rt(&data.lock,0); */
/*   pthread_cond_init_rt(&data.cond,0); */
/*   data.target = 0; */
/*   GC_GET(data.target,this,_java_lang_Thread_target); */
/*   GC_POP_PARAM(this); */
/*   gettimeofday(&tp,0); */
/*   data.time.tv_sec  = (millis / MS) + tp.tv_sec; */
/*   data.time.tv_nsec = (millis % MS) * NS_MS + nanos + tp.tv_usec * MS; */
/*   if (pthread_create_rt(&th,0,(void*)interruptible_join,(void*)&data) != 0)    */
/*   		printf("Error pthread_create()<join>\n");	 */
/*   pthread_cleanup_push_rt(interrupter,0); */
/*   pthread_cleanup_push_rt(timedjoin_end,(void*)&th); */
/*   pthread_cond_timedwait_rt(&data.cond,&data.lock,&data.time); */
/*   pthread_cleanup_pop_rt(1); /* timedjoin_end is executed always */ 
/*   pthread_cleanup_pop_rt(0); /* interrupter only executed when this thread is cancelled */ 
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Thread_join_long_int)

