
//#include <class_indices.h>
/* #include <gc.h> */
/* #include <pthread.h> */
#include <javatypes.h>
/* #include <semaphore.h> */
/* #include <java2c_lxrt.h> */
/* #include <java_lang_Object.h> */
#include <rtai/mutex.h>

#include <aux.h>

#ifdef KERNELSPACE
#define strerror(a) "strerror not available"
#endif

#undef USE_MONITORS
#ifndef USE_MONITORS
#warning "****** monitors not working ****** "
#endif

#ifdef GC_HAS_FINALIZERS
static void dealloc_mon(ObjectHead *this){
	if(this->lock) {
		int status= rt_mutex_delete(this->lock);
#ifdef GC_PRINT_DEBUG
		printf("freed mutex: %x, status = %d\n", this->lock, status);
#endif
		this->lock = 0;
	}
}
#endif

void ljrt_monitor_free(java_lang_Object *this) {}

void monitor_init(ObjectHead *this) {}

void monitor_init_real(ObjectHead *this){
#ifdef USE_MONITORS
  if(this != 0 && this->lock == 0) {
    int status;
    this->lock = malloc(sizeof(RT_MUTEX));
/*     printf("monitor init: %x\n", this->lock); */


    char name[10];
    sprintf(name,"%x",this->lock);
    if (status = rt_mutex_create(this->lock,name)) {
      printf("monitor_init() failed: %d %s\n",status, strerror(-status));
    }
  }
#ifdef GC_HAS_FINALIZERS
  {
#ifdef GC_PRINT_DEBUG
    printf("setting finalizer for: %x (%x)\n", GC___PTR(this), this->lock);
#endif
    GC__IMPL_SET_FINALIZER(this->tmplate, dealloc_mon);
  }
#endif
#endif
}

// void monitor_enter_static(Java_lang_Object *this){
//
// 	pthread_mutex_lock_rt(this.class_lock);
// }

void monitor_enter(ObjectHead *this){
//	if(isStatic){
//		pthread_mutex_lock_rt(((struct java_lang_Object_ClassStruct*)this)->class_lock);
//
//	}else;
#ifdef USE_MONITORS
#ifdef GC_PRINT_DEBUG
	if(this) {
		printf("monitor enter...[%x] %x\n",rt_task_self() ,this->lock); 
	} else {
		// HERE BE DRAGONS
		printf("monitor enter: this == null?\n");
		return;
	}
#endif
/* 	pthread_mutex_lock_rt(this->lock); */
  int status;

  if (!this->lock) {
    monitor_init_real(this);
  }
  
  status = rt_mutex_lock(this->lock);
    if (status) {
      printf("monitor_enter() failed: %d %s\n",status,strerror(-status));
    }  
#endif
}

void monitor_leave(ObjectHead *this){
#ifdef USE_MONITORS
#ifdef GC_PRINT_DEBUG
	printf("monitor leave...[%x] %x\n",rt_task_self(), this->lock);
#endif
/* 	pthread_mutex_unlock_rt(this->lock); */
  int status;
  if (status = rt_mutex_unlock(this->lock)) {
    printf("monitor_leave failed: %d %s\n",status, strerror(-status));
  }  
#endif
}

/* Function translates Java priority in an equivalent scheduler's priority
   specified by the parameter sched */

/* int javaPr2schedPr(int java_prio,int sched) { */
/* 	const int pr_step_java = 10; */
/* 	int pr_step_posix; */
/* 	pr_step_posix = sched_get_priority_max(sched) - sched_get_priority_min(sched); */
/* 	return (((10-(java_prio-1)) * (abs(pr_step_posix)))/(pr_step_java))-(abs(sched_get_priority_min(sched))); */
/* } */

/* int schedPr2javaPr(int sched_prio,int sched) { */
/* 	const int pr_step_java = 10; */
/* 	int pr_step_posix; */
/* 	pr_step_posix = sched_get_priority_max(sched) - sched_get_priority_min(sched); */
/* 	return (int)((float)11- (float)((float)(sched_prio+sched_get_priority_min(sched)) * ((float)(abs(pr_step_java))/(pr_step_posix)))); */
/* } */


int javaPr2schedPr(int java_prio,int sched) {
//        return (10-java_prio)*((RT_LOWEST_PRIORITY-4000)/9) + 2000;
	return 70+java_prio;
}

int schedPr2javaPr(int sched_prio,int sched) {
//        return 10-sched_prio*9/(RT_LOWEST_PRIORITY - 2000);
	return sched_prio-70;
}
