/* $Revision: 1.1.2.13 $
 * $Author: sven $
 * $Date: 2004/07/01 15:58:20 $
 */
//#include <pthread.h>
//#include <sys/time.h>
#include <gc.h>
#include <gci_common.h>
#include <exception.h>
#include <javatypes.h>
//#include <sys/mman.h>
#include <java_lang_Object.h>
#include <java_lang_Thread.h>
#include <class_indices.h>
#include <errno.h>
#include <string.h>

#include <xenomai/native/mutex.h>

//#include <java2c_lxrt.h>


#define NS_MS 	1000000
#define MS 		1000
#define NSEC 1000000000

// RTAI include files & defines
//message to send in different cases.
#define RTAIKERNEL_NOTIFY_MSG    10
#define RTAIKERNEL_INTERRUPT_MSG 20


/* Auxiliar function called from the thread clean-up handler in order to call accordingly to the GCI 	 */
/* the interruption thrower itself	(interrupter_impl). It resets the cancel_state to ENABLE since seems */
/* to be DISABLE after a pthread_cancel() call															 */
//extern SEM wait_notify_sem;
//extern pthread_key_t tsd_key;

GC_VAR_FUNC_BEGIN(JInt,java_lang_Object_hashCode,GC_PARAM(java_lang_Object,this)) EXCEPTION_THROWS
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  {
    JInt _result_;
    _result_ = (JInt)this->ref;
    GC_RETURN_VAR(_result_);
  }

  GC_FUNC_LEAVE
  GC_POP_PARAM(this);
GC_VAR_FUNC_END(JInt,java_lang_Object_hashCode)



GC_PROC_BEGIN(java_lang_Object_wait_long_int,GC_PARAM(java_lang_Object,this),JLong timeout,JInt nanos) EXCEPTION_THROWS
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  {
	/*
	*  Interrupt not implemented yet in any wait or notify-function
	*
	*/
	int sem_counts = 0;
	unsigned int msg;
	gc_thread_t *waitQ_last_temp;
	gc_thread_t *current_gc_thread = gc_thread_get_current();
	RT_MUTEX *synch_lock;
	RT_MUTEX_INFO mutex_info;

	GC_GET(waitQ_last_temp, this, waitQ_last);

	if(waitQ_last_temp){
		waitQ_last_temp->waitQ_next = current_gc_thread;
		current_gc_thread->waitQ_previous = waitQ_last_temp;
	}else{
		GC_SET(this, waitQ_first, current_gc_thread);
		current_gc_thread->waitQ_previous = 0;
	}

	current_gc_thread->waitQ_next = 0;
	GC_SET(this, waitQ_last, current_gc_thread);

	GC_GET(waitQ_last_temp, this, waitQ_last);
	GC_GET(synch_lock, this, lock);
	//unlock
	rt_mutex_inquire(synch_lock,&mutex_info);
/* 	while(synch_lock && synch_lock->lockcnt == 0){ */
	while(synch_lock && mutex_info.nwaiters == 0){
		rt_sem_v(synch_lock);
		sem_counts++;
	}

/* 	rt_receive_until(0,&msg,nano2count(timeout*1000000 + nanos)); */
	if(msg == RTAIKERNEL_INTERRUPT_MSG){
#ifdef JAVA_LANG_INTERRUPTEDEXCEPTION_INDEX
	  EXCEPTION_THROW(0,JAVA_LANG_INTERRUPTEDEXCEPTION_INDEX);
#endif
		//printk("woohoo - Interruptmessage works!\n");
		//Implementation of interruption
	}
	//lock
	while(sem_counts){
		rt_sem_v(synch_lock);
		sem_counts--;
	}

	if(current_gc_thread->waitQ_next) {
		gc_thread_t *tmp_a = current_gc_thread->waitQ_next;
		GC_SET(this, waitQ_first, tmp_a);
		(current_gc_thread->waitQ_next)->waitQ_previous = 0;
		current_gc_thread->waitQ_next = 0;
	} else {
		GC_SET(this, waitQ_last, 0);
		GC_SET(this, waitQ_first, 0);
	}
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Object_wait_long_int)


GC_PROC_BEGIN(java_lang_Object_notify,GC_PARAM(java_lang_Object,this))
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  {

	unsigned int msg;
	gc_thread_t *waitQ_first_temp;
	msg = RTAIKERNEL_NOTIFY_MSG;
	GC_GET(waitQ_first_temp, this, waitQ_first);
	if(waitQ_first_temp && waitQ_first_temp->pid){
/* 		rt_send((RT_TASK*)(waitQ_first_temp->pid), msg); */
	  printf("Object.notify() not implemented for lxrt\n");
	}

  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Object_notify)


GC_PROC_BEGIN(java_lang_Object_notifyAll,GC_PARAM(java_lang_Object,this))
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  {
  	gc_thread_t *tmp;
	unsigned int msg;
	gc_thread_t *waitQ_first_temp;
	msg = RTAIKERNEL_NOTIFY_MSG;
	GC_GET(waitQ_first_temp, this, waitQ_first);
	while(waitQ_first_temp && waitQ_first_temp->pid){
		tmp = waitQ_first_temp;
		waitQ_first_temp = waitQ_first_temp->waitQ_next;
/* 		rt_send((RT_TASK*)(tmp->pid), msg); */
	  printf("Object.notifyAll() not implemented for lxrt\n");
	}
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Object_notifyAll)

GC_REF_FUNC_BEGIN(java_lang_Object,java_lang_Object_clone,GC_PARAM(java_lang_Object,this)) EXCEPTION_THROWS;
{
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
  {
    // Here be dragons. LACK IMPLEMENTATION
    GC_REF(java_lang_Object,result);
    GC_PUSH_ALIAS(result);
    GC_ASSIGN(result,this);
    GC_RETURN_REF(result);
  }

  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
}
GC_REF_FUNC_END(java_lang_Object,java_lang_Object_clone)
