#include <gc.h>
#include <gci_common.h>
#include <exception.h>
#include <javatypes.h>

#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>


/**********************************************************
 * 
 * int se.lth.cs.camera.Axis211A.connect()
 *
 * Connects to the camera device.
 *
 * Returns: The file descriptor.
 *
 **********************************************************/
GC_VAR_FUNC_BEGIN(JInt, se_lth_cs_camera_Axis211A_nativeConnect)
GC_FUNC_ENTER
{
	JInt fd = open("/dev/jpeg0", O_RDONLY);
	
	GC_RETURN_VAR(fd);
}
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JInt, se_lth_cs_camera_Axis211A_nativeConnect)


/**********************************************************
 * 
 * int se.lth.cs.camera.Axis211A.getJPEG(int fd, byte[] target, int offset)
 *
 * Parameters:
 * 	
 * 	fd     - The file descriptor
 * 	target - Byte array for storage
 * 	offset - Array offset
 *
 * Returns: The number of read bytes.
 *
 **********************************************************/
GC_VAR_FUNC_BEGIN(JInt, se_lth_cs_camera_Axis211A_nativeGetJPEG_int_byteA_int,
        JInt fd,
	GC_PARAM(JByteArray,target), 
	JInt offset)
GC_PARAM_REF(JByteArray, target);
GC_PUSH_PARAM(target);
GC_FUNC_ENTER
{
	char *target_p = (char *) &GC___PTR(target->ref)->data[offset];
	int image_length;

	if ((image_length = read(fd, target_p, 100000)) < 0) {
		GC_RETURN_VAR(-1);
	}

	GC_RETURN_VAR(image_length);

}
GC_FUNC_LEAVE;
GC_POP_PARAM(target);
GC_VAR_FUNC_END(JInt, se_lth_cs_camera_Axis211A_nativeGetJPEG_int_byteA_int)


/***********************************************
 * 
 * void se.lth.cs.camera.Axis211A.close(int fd)
 *
 * Closes the connection to the camera device.
 *
 * Parameters: fd - The file descriptor.
 *
 ***********************************************/
GC_PROC_BEGIN(se_lth_cs_camera_Axis211A_nativeClose_int, JInt fd)
GC_FUNC_ENTER
{
	close(fd);
}
GC_FUNC_LEAVE;
GC_PROC_END(se_lth_cs_camera_Axis211A_nativeClose_int)
